<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@page import="org.joda.time.format.DateTimeFormat"%>
<%@page import="com.emptoris.viewer.admin.srvrmgmt.data.UsageReportDetailVO"%>
<%@page import="com.emptoris.viewer.admin.srvrmgmt.data.UsageReportVO"%>
<%@page import="java.util.Date"%>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ page pageEncoding="UTF-8" contentType="text/html;charset=UTF-8"%>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="com.zeborg.util.WebUtil" %>



<%	//59941
    response.setHeader("Pragma", "public");
    response.setHeader("Cache-Control", "max-age=0");
	String encoding = WebUtil.getEncoding();
	String charSet = "charset="	+ ((null == encoding) ? "UTF-8" : encoding);
	response.setContentType("application/vnd.ms-excel;"+ charSet);
    String dateToday = new SimpleDateFormat("MM_dd_yyyy").format(new Date());
    ZSession   zs  = ZSessionUtil.getFromSession(pageContext);
    UsageReportVO  usageReportVO  = ((UsageReportDetailVO) request.getAttribute("usageReport")).getUsageReportVO();
    String fileName = URLEncoder.encode(usageReportVO.getReportName().toUpperCase()+"_"+dateToday+".xls","UTF-8").replace("+","");
    response.setHeader("Content-Disposition", "attachment; filename="+fileName+ "; filename*=UTF-8''"+fileName);
    
%>

<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zs.getUser().getTimeZone().getID()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	

<html xmlns:x="urn:schemas-microsoft-com:office:excel">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<style type="text/css">
<!--
.breadcrumb_new { font-family:Arial, Helvetica, sans-serif; font-size:11px; color:#000000; text-decoration:italics; }
.printTitle { font-family:Arial, Helvetica, sans-serif; font-size:24px; color:#003366; }
.columnHeadingStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:center; background-color: #DEE2EA; }
.breadCrumbHeadingStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left;}
.cellStyle { font-family: Arial, Helvetica, sans-serif; font-size: 11px; color: #000000; text-align:left; }
-->
</style>
</head>
<body>
<span class="printTitle"><fmt:message key="ui.report.table.header.name" /> : <c:out value="${ usageReport.usageReportVO.reportName }" /></span>
<br>
<br>
<table border="0" cellpadding="0" cellspacing="0">
<tr class="breadcrumb_new" >
	<td class="breadCrumbHeadingStyle"><fmt:message key="ui.label.Date.Created" /> : </td>
	<td class="breadCrumbHeadingStyle" x:str><fmt:formatDate value="${usageReport.usageReportVO.creationDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" /></td>
</tr>
<c:if test="${ ! usageReport.usageReportVO.olfUsageReportRequest}" >
<tr class="breadcrumb_new" >
	<td class="breadCrumbHeadingStyle"><fmt:message key="ui.label.Company" /> :  </td>
	<td class="breadCrumbHeadingStyle"><c:out value="${ usageReport.usageReportVO.companyId }" /></td>
</tr>
<tr class="breadcrumb_new" >
	<td class="breadCrumbHeadingStyle"><fmt:message key="ui.label.Dataset" /> : </td>
	<td class="breadCrumbHeadingStyle"><c:out value="${ usageReport.usageReportVO.datasetId }" /></td>
</tr>
</c:if>
<tr class="breadcrumb_new" >
	<td class="breadCrumbHeadingStyle"><fmt:message key="ui.usability.startdate" />:</td>
	<td class="breadCrumbHeadingStyle" x:str>
		<fmt:formatDate value="${usageReport.usageReportVO.startDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" />
	</td>
</tr>
<tr class="breadcrumb_new" >
	<td class="breadCrumbHeadingStyle"><fmt:message key="ui.usability.enddate" /> :</td>
	<td class="breadCrumbHeadingStyle" x:str>
		<fmt:formatDate value="${usageReport.usageReportVO.endDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" />
	</td>
</tr>
</table>
<br>
<table border="1" cellpadding="0" cellspacing="0">
<tr>
		<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.user" /></td>
		<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.display.name" /></td>
		<c:choose>
			<c:when test="${ usageReport.usageReportVO.olfUsageReportRequest}">
				<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.datasetname" /></td>
				<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.feedbackapplied.date" /></td>
				<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.addcount" /></td>
				<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.mapcount" /></td>
				<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.movecount" /></td>
				<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.renamecount" /></td>
				<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.total" /></td>
			</c:when>
			<c:otherwise>
				<c:if test="${usageReport.usageReportVO.login}">
					<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.logins" /></td>				
					<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.days" /></td>
					<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.firstday" /></td>
					<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.lastday" /></td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.datasetAccess}">
					<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.dataset.viewed" /></td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.click}">
					<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.clicks" /></td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.bookmark}">
					<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.bookmarks" /></td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.tabulation}">
					<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.crosstabs" /></td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.dashboard}">
					<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.dashboards" /></td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.analytic}">
					<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.analytics" /></td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.feedback}">
					<td class="columnHeadingStyle"><fmt:message key="ui.usability.report.heading.feedbacks" /></td>
				</c:if>
			</c:otherwise>
		</c:choose>
</tr>
<c:forEach items="${ usageReport.usageReportRows }" var="row">
<tr class="breadcrumb_new" >
	<td class="cellStyle" align="left"><c:out value="${ row.userName }" /></td>
	<td class="cellStyle" align="left"><c:out value="${ row.displayName }" /></td>
	<c:choose>
		<c:when test="${ usageReport.usageReportVO.olfUsageReportRequest}">
			<td class="cellStyle"><c:out value="${ row.dataSetName }" /></td>
			<td class="cellStyle" x:str>
				<c:choose>
					<c:when test="${ empty row.feedBackAppliedDate }">&nbsp;-&nbsp;</c:when>
					<c:otherwise><fmt:formatDate value="${row.feedBackAppliedDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" /></c:otherwise>
				</c:choose>
			</td>
			<td class="cellStyle"><c:out value="${ row.addFeedBackCount }" /></td>
			<td class="cellStyle"><c:out value="${ row.mapFeedBackCount }" /></td>
			<td class="cellStyle"><c:out value="${ row.moveFeedBackCount }" /></td>
			<td class="cellStyle"><c:out value="${ row.renameFeedBackCount }" /></td>
			<td class="cellStyle"><c:out value="${ row.totalFeedBackCount }" /></td>
		</c:when>
		<c:otherwise>
			<c:if test="${usageReport.usageReportVO.login}">
				<td class="cellStyle"><c:out value="${ row.totalLogins }" /></td>				
				<td class="cellStyle"><c:out value="${ row.totalDays }" /></td>
				<td class="cellStyle" x:str>
					<c:choose>
						<c:when test="${ empty row.firstLoginDate }">&nbsp;-&nbsp;</c:when>
						<c:otherwise><fmt:formatDate value="${row.firstLoginDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern}" /></c:otherwise>
					</c:choose>
				</td>
				<td class="cellStyle" x:str>
					<c:choose>
						<c:when test="${ empty row.lastLoginDate }">&nbsp;-&nbsp;</c:when>
						<c:otherwise><fmt:formatDate value="${row.lastLoginDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern}" /></c:otherwise>
					</c:choose>
				</td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.datasetAccess}">
				<td class="cellStyle"><c:out value="${ row.datasetViewedCount }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.click}">
				<td class="cellStyle"><c:out value="${ row.totalClicks }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.bookmark}">
				<td class="cellStyle"><c:out value="${ row.bookmarksCreated }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.tabulation}">
				<td class="cellStyle"><c:out value="${ row.crosstabsRun }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.dashboard}">
				<td class="cellStyle"><c:out value="${ row.dashboardsViewed }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.analytic}">
				<td class="cellStyle"><c:out value="${ row.analyticsViewed }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.feedback}">
				<td class="cellStyle"><c:out value="${ row.feedbacksSubmitted }" /></td>
			</c:if>
		</c:otherwise>
	</c:choose>
</tr>
</c:forEach>
</table>
</body>
</html>





