<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ taglib uri="http://www.springframework.org/tags" prefix="spring"%>
<%@ page language="java" contentType="text/html; charset=UTF-8"  pageEncoding="UTF-8"%>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.model3.DataSet"%>
<%@ page import="com.zeborg.expensemap.util.*,com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.emptoris.viewer.feedback.FeedbackConstants"%>
<%@ page import="com.zeborg.util.WebUtil,java.util.Locale"%>
<%@ page import="org.apache.struts.Globals,com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager" %>
<%@ page import="com.ibm.icu.text.NumberFormat" %>
<%@ page import="java.util.HashMap" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Set, com.emptoris.viewer.util.CSRFHelper" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="com.zeborg.expensemap.view.HelpUtil" %>
	<%
		ZSession zs = ZSessionUtil.getFromSession(pageContext);
		WebUtil.addType(response, request);	
		HashMap<String, Integer> groupIds=new HashMap<String, Integer>();
		ArrayList<String> masterIds=new ArrayList<String>();
		ArrayList<String> measureName = (ArrayList<String>)request.getAttribute("measureNames");
		String measureLayoutString="";
		for(int i = 0 ; i < measureName.size() ; i++){
			measureLayoutString += "{id:\'"+i+"\',field:\'" + measureName.get(i) + "\',name: \'" + measureName.get(i) + "\',headerStyles:\"cursor:pointer\",formatter:formatCurrency},";
		}
		if(measureLayoutString.lastIndexOf(',') > 1){
			measureLayoutString = measureLayoutString.substring(0, measureLayoutString.lastIndexOf(','));
		}
		String cubeName = zs.getDataSet().getDisplayName();
		pageContext.setAttribute("returnToURL","../showFeedBackListform.xhtm", PageContext.SESSION_SCOPE);
		// This is required for struts to know which locale to use for labels, messages.
		Locale locale =zs.getUser().getLocale();
		//request.getSession().setAttribute(Globals.LOCALE_KEY, locale);

		EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_FEEDBACK_RESOURCE_BUNDLE, locale);
		String skin = ExpenseMapAppProperties.getExpensemapSkin();
		String helpURL ="";
		helpURL = HelpUtil.getHelpUtil().getHelpURLString(FeedbackConstants.FEEDBACK_LIST_PAGE_HELP, locale);
		boolean enableCustomFeedback = ExpenseMapAppProperties.isEnableCustomFeedbackname();
		String typeAddLabel ="";
		String typeMoveLabel = "";
		String typeRenameLabel = "";
		String typeMapLabel = "";
		if(enableCustomFeedback){
			 typeAddLabel = ExpenseMapAppProperties.getFeedbackTypeAdd() ;
			 typeMoveLabel = ExpenseMapAppProperties.getFeedbackTypeMove() ;
			 typeRenameLabel = ExpenseMapAppProperties.getFeedbackTypeRename(); 
			 typeMapLabel = ExpenseMapAppProperties.getFeedbackTypeMap() ;
		}
	%>

<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<title><%= ExpenseMapAppProperties.getBrowserTitleSpend()%> - <fmt:message key="ui.feedback.page.title"/></title>
		<jsp:include page="/jsp/includes/commonHeaderIncludes.jsp"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit_rtl.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro_rtl.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid_rtl.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/claroGrid.css"/>
		<link rel="stylesheet" href="/expensemap/css/spendGridPageStyle.css"/>
		<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
		
		<style type="text/css">
			#dateLabel { width: 80px; }
			#statusLabel { width: 110px; }
			#pb {
				position: absolute;
				top: 200px;
				left: 200px;
			}
			#pb.yui-overlay { 
				background-image: url(/expensemap/jsp/images/dimension-viewer-progressbar/75p_white.png);
				border: 1px solid black;
				padding: 5px;
				margin: 10px;
				font-size: 13px;
				font-weight: bold;
				color: black;
			}			
		</style>

		
		<!-- Provide the base location of DOJO files -->
		<script type="text/javascript">
			dojoConfig = {
				baseUrl : "/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/"
					
			};
		</script>

		<script type="text/javascript" src="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/dojo.js" data-dojo-config="parseOnLoad: true" ></script>
		<SCRIPT type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></SCRIPT>
		<SCRIPT type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></SCRIPT>

		
		<script type="text/javascript">

			// Include OR import DOJO components.
			
			dojo.require("dojo/domReady");
			dojo.require("dojo/store/Memory");
			dojo.require("dojo/data/ObjectStore");
			dojo.require("dojox/grid/DataGrid");
			dojo.require("dojo/_base/xhr");
			dojo.require("dojo/json");
			dojo.require("dijit/layout/BorderContainer");
			dojo.require("dijit/Dialog");
			dojo.require("dijit/form/Button");
			dojo.require("dijit/form/Select");
			dojo.require("dijit/TitlePane");
			dojo.require("dijit/form/TextBox");
			dojo.require("dijit/form/CheckBox");
			dojo.require('dijit/form/NumberTextBox');
			dojo.require("dijit/form/DateTextBox");
			dojo.require("dijit/form/TimeTextBox");
			dojo.require("dijit/form/ValidationTextBox");

			
			// Global variables
			var feedback_Grid_Store, dataStore, feedback_Grid_Obj, feedback_Grid_Layout;
			var Status,startFeedbackID = 0;
			var measureNameListArray= new Array();
			var progressBar = null;

			// define the layout of grid. 
			feedback_Grid_Layout = [
										{
											noscroll: true,
											defaultCell: { width: "120px" },
											cells: 
												[
													{name: "<input id='selectAllRows' name='selectAllRows' type='checkbox' onClick='selectAll(this);' />",field :'id',formatter:addCheckBox, width: "30px"},
													{id: 'id',fields: ['embookmarkId','displayId'],name: "<fmt:message key='ui.label.ID' />",formatter:renderFeedBackId,width: "40px"},
													{id: 'additionalFeedBack',name: "<fmt:message key='ui.label.additional.feedback.id' />",field:'workFlowDisplayId',formatter:renderAdditionalFeedbackDisplayId,width: "40px"},
													{id: 'name',fields: ['name','disposition','feedBackType','id'],name: "<fmt:message key='ui.label.Name' />",formatter:renderFeedBackName,width: "240px"}
												]
										},{
											defaultCell: { width: "150px" },
											cells: 
												[
													{id:'comments',field:'comments',name: "<fmt:message key='ui.feedback.comments.label' />",formatter:renderComment},
													{id:'user',field:'user',name: "<fmt:message key='ui.feedback.requestedby.label' />"},
													{id:'dateCreatedStr',field:'dateCreatedStr',name: "<fmt:message key='ui.feedback.requestedon.label' />"},
													{id:'action',fields: ['id','feedBackType'],name: "<fmt:message key='ui.feedback.action.label' />",formatter:renderAction},
													{id:'source',fields: ['id','source','multiKeep','feedBackType'],name: "<fmt:message key='ui.label.mainViewMode.Source' />",formatter:renderSource},
													{id:'destination',field: 'destination',name: "<fmt:message key='ui.feedback.destination.label' />",formatter:renderDestination},
													{id:'drillPoint',fields:['multiKeep','drillPoints'],name: "<fmt:message key='ui.feedback.drillpoints.label' />",formatter:renderDrillPoint},
													{id:'status',field:'disposition',name: "<fmt:message key='ui.feedback.processingstatus.label' />",formatter:renderStatus},
													{id:'processComment',field:'dispositionComments',name: "<fmt:message key='ui.feedback.processingcomments.label' />",formatter:renderDispositionComment},
													{id:'dispositionUser',field:'dispositionUser',name: "<fmt:message key='ui.feedback.processedby.label' />",formatter:renderDispositionUser},
													{id:'dispositionDateStr',field:'dispositionDateStr',name: "<fmt:message key='ui.feedback.processingdate.label' />",formatter:renderDispositionDate},
													{id:'affectedByDataRefresh',field:'affectedByDataRefresh',name: "<fmt:message key='ui.feedback.affectedbydatarefresh.label' />",formatter:renderDataRefresh},
													<%=measureLayoutString%>	 									 				   
													
												]
										}
									];

			// HTML for feedback summary page 
			var summaryContent = "<table>" +
										"<tr>" +
											"<td align=\"right\">" +	
												"<label for='ID'><fmt:message key='ui.label.Name' /></label>:" +				
											"</td>" +
											"<td>{1}</td>"+
										"</tr>"+
										"<tr>"+
											"<td align=\"right\">"+
												"<label for='Name'><fmt:message key='ui.feedback.comments.label' /></label>:" +
											"</td>" +
											"<td>{2}</td>" +
										"</tr>" +
										"<tr>" +
											"<td align=\"right\"><label for='ID'><fmt:message key='ui.feedback.requestedby.label' /></label>:</td>" +
											"<td>{3}</td>" +
										"</tr>" +
										"<tr>" +
											"<td align=\"right\"><label for='Name'><fmt:message key='ui.feedback.requestedon.label' /></label>:</td>" +
											"<td>{4}</td>" +
										"</tr>" +
										"<tr>" +
											"<td align=\"right\"><label for='ID'><fmt:message key='ui.feedback.action.label' /></label>:</td>" +
											"<td>{5}</td>" +
										"</tr>" +
										"<tr>" +
											"<td align=\"right\"><label for='Name'><fmt:message key='ui.label.mainViewMode.Source' /></label>:</td>" +
											"<td>{6}</td>" +
										"</tr>" +
										"<tr>" +
											"<td align=\"right\"><label for='ID'><fmt:message key='ui.feedback.destination.label' /></label>:</td>" +
											"<td>{7}</td>" +
										"</tr>" +
										"<tr>" +
											"<td align=\"right\"><label for='Name'><fmt:message key='ui.feedback.drillpoints.label' /></label>:</td>" +
											"<td>{8}</td>" +
										"</tr>" +
										"<tr>" +
											"<td align=\"right\"><label for='ID'><fmt:message key='ui.feedback.processingstatus.label' /></label>:</td>" +
											"<td>{9}</td>" +
										"</tr>" +
										"<tr>" +
											"<td align=\"right\"><label for='Name'><fmt:message key='ui.feedback.processingcomments.label' /></label>:</td>" +
											"<td>{10}</td>" +
										"</tr>" +
										 "<tr>" +
											"<td align=\"right\"><label for='Name'><fmt:message key='ui.feedback.processedby.label' /></label>:</td>" +
											"<td>{11}</td>" +
										"</tr>" +
										"<tr>" +
											"<td align=\"right\"><label for='Name'><fmt:message key='ui.feedback.processingdate.label' /></label>:</td>" +
											"<td>{12}</td>" +
										"</tr>" +
									"</table>";

			// Once the dojo js and css is loaded with browser, it will excecute.
			dojo.ready(function(){
					progressBar = new YAHOO.widget.Overlay("pb", { fixedcenter:true, visible:false, width:"180px" } );
					progressBar.render(document.body);

					require(["dojox/grid/DataGrid", "dojo/store/Memory", "dojo/data/ObjectStore", "dojo/_base/xhr", "dojo/domReady", "dijit/form/Select"],

						function(DataGrid, Memory, ObjectStore, xhr){
									xhr.post({
										url: "/expensemap/fetchFeedbackList.jxhtm",
										handleAs: "json"									
									}).then(function(responseData){
									
									Status = new dijit.form.Select({
																			id:"search_Disposition",
																			name: "search.disposition",
																			store: new ObjectStore({ objectStore: new Memory({ data: responseData.processingStatus })}),
																			maxHeight: -1
																		 }
																		,"processingStatus");									
									Status.startup();
									Status.set("value","Open");
									feedback_Grid_Store = new dojo.store.Memory({ data: responseData.feedbackList });											 
									dataStore = new ObjectStore({ objectStore: feedback_Grid_Store });
									feedback_Grid_Obj = new DataGrid({
																		id:'feedback_Grid',
																		autoHeight:true,
																		store: dataStore,																			
																		style:"display:none",
																		canSort : canSort,																	
																		selectionMode:"single",
																		rowSelector: '0px',																	
																		structure : feedback_Grid_Layout			
																	},																		
																	"Grid_Div"
															);// End of DataGrid.
											feedback_Grid_Obj.startup();
											
									showSelectedFeedbackIfRequired();
									});
						}//End of function.
					);// End of required.

					
					// add event handler.
					require(["dojo/on", "dojo/topic", "dojo/dom-construct"],
						function(on, topic, domConstruct) {
							// All check box handler
							var feedbackType_All_Checked = dijit.byId('All_feedbackType');
								on(feedbackType_All_Checked,"click", function(){																
									 dijit.byId('Add_feedbackType').set("checked",dijit.byId('All_feedbackType').get("checked"));
									 dijit.byId('Rename_feedbackType').set("checked",dijit.byId('All_feedbackType').get("checked"));
									 dijit.byId('Move_feedbackType').set("checked",dijit.byId('All_feedbackType').get("checked"));
									 dijit.byId('Map_feedbackType').set("checked",dijit.byId('All_feedbackType').get("checked"));
								});

							var Move_feedbackType_Checked = dijit.byId('Move_feedbackType');
								on(Move_feedbackType_Checked,"click", function(){																									 
									 updateAllfeedbackTypeCheckBox();
								});

							var Map_feedbackType_Checked = dijit.byId('Map_feedbackType');
								on(Map_feedbackType_Checked,"click", function(){																									 
									 updateAllfeedbackTypeCheckBox();
								});

							var Rename_feedbackType_Checked = dijit.byId('Rename_feedbackType');
								on(Rename_feedbackType_Checked,"click", function(){																									 
									 updateAllfeedbackTypeCheckBox();
								});

							var Add_feedbackType_Checked = dijit.byId('Add_feedbackType');
								on(Add_feedbackType_Checked,"click", function(){																									 
									 updateAllfeedbackTypeCheckBox();
								});
	
					});
			});// End of dojo.ready

	// Add event handler here
	function onSearch()
	{

								if(validateSearchRequest()){
									dojo.byId("pageSize").value = dojo.byId("userInput_pageSize").value;
									dojo.byId("theAction").value="showAll";	
									showAllFeedback();
								}

	}
		
	function onOpen()
	{
								
									if(dijit.byId('open_btn').get("disabled")) return false;
	
									if(checkAtLeastOneSelected()){
										document.getElementById("dispositionComment").value = getDipositionComment();
										submitRequest("/expensemap/openFeedback.jxhtm");
									}else{
										alert("<fmt:message key='ui.feedback.validate.noselection' />");									
									}
					
	}
	function onAccept()
	{
						
									if(dijit.byId('accept_btn').get("disabled")) return false;
									
									
									if(checkAtLeastOneSelected()){
										document.getElementById("dispositionComment").value = getDipositionComment();
										submitRequest("/expensemap/acceptFeedback.jxhtm");
									}else{
										alert("<fmt:message key='ui.feedback.validate.noselection' />");
										return false;
									}												
	}
	function onReject()
	{
			
									if(dijit.byId('reject_btn').get("disabled")) return false; 
									if(checkAtLeastOneSelected()){
										document.getElementById("dispositionComment").value = getDipositionComment();
										submitRequest("/expensemap/rejectFeedback.jxhtm");
									}else{
										alert("<fmt:message key='ui.feedback.validate.noselection' />");
										return false;
									}

	}
	function onSubmit()
	{
					
									if(dijit.byId('submit_btn').get("disabled")) return false;
									if(checkAtLeastOneSelected()){
										submitRequest("/expensemap/submitFeedback.jxhtm");
									}else{
										alert("<fmt:message key='ui.feedback.validate.noselection' />");
										return false;
									}
							
	}
function onDelete()
{

									if(dijit.byId('delete_btn').get("disabled")) return false;
									if(checkAtLeastOneSelected()){
										if(confirm("<fmt:message key='ui.delete.alertmsg'/>")){
											submitRequest("/expensemap/deleteFeedback.jxhtm");								
										}							
									}else{
										alert("<fmt:message key='ui.feedback.validate.noselection' />");
										return false;
									}							
						
}
function onExportExl()
{
									
									if(dijit.byId('exportExl_btn').get("disabled")) return false;
									
									if(!checkAtLeastOneSelected()){
										alert("<fmt:message key='ui.feedback.validate.noselection' />");
										return false;
									}
	
									var theForm = document.getElementById('feedbackListModel');								
									
									var indexStr = collectFeedbackIndices();
									if(confirm("<fmt:message key='ui.confirm.message.for.export.excel'/>")){
										
										theForm.action="/expensemap/exportFeedbackAsExl.xhtm?feedbackIndexIds=" + indexStr;
										theForm.submit();
									}
									return false;

}
function onExportXml()
{
									
									if(dijit.byId('exportXml_btn').get("disabled")) return false;
	
									if(!checkAtLeastOneSelected()){
										alert("<fmt:message key='ui.feedback.validate.noselection' />");
										return false;
									}
									
									if(confirm("<fmt:message key='ui.confirm.message.for.export.xml'/>")){
										var theForm = document.getElementById('feedbackListModel');
										theForm.action="/expensemap/exportFeedbackAsXml.xhtm";
										theForm.submit();
									}
									return false;
	
}
function onApplyPageSize()
{

								var dijitApplyButton = dijit.byId("userInput_pageSize");
								if (!dijitApplyButton.isValid()) {
									dijitApplyButton.focus();
									return;
								}
							
								var pageSize = dojo.byId("userInput_pageSize").value;
								dojo.byId("pageSize").value = pageSize;		
								dojo.byId("theAction").value="showAll";
								feedback_Grid_Obj.rowsPerPage = pageSize;
								showAllFeedback();
}
function onOnlineSubmit()
{
							
										if(dijit.byId('online_feedback_submit').get("disabled")) return false;
										
										if(checkAtLeastOneSelected()){
											var maxDataSetAllowed = parseInt(document.getElementById('maxDataSetAllowed').value);
											var totalDataSetCount = parseInt(document.getElementById('totalDataSetCount').value);
											if(!(totalDataSetCount < maxDataSetAllowed)){
												alert("<fmt:message key='ui.message.max.allowed.dataset.error.message' />");
												var xhrArgs = {
																url: '/expensemap/rulemanagement/SubmitOnlineFeedBackAction.do?operation=sendMailNotification&AuthCode=' + encodeURIComponent(document.getElementById('AuthCode').value),
																handleAs: "text",
																load: function(data){/* Do nothing */},
																error: function(error){ /*Do nothing */ }
															  }
												dojo.xhrGet(xhrArgs);
												return false;
											}
											
											
											validateFeedback();
										}else{
											alert("<fmt:message key='ui.feedback.validate.noselection' />");
											return false;
										}
								
}
function showSelectedFeedbackIfRequired(){
			var feedbackId = dojo.byId("feedbackId").value;
			if(feedbackId!=null && feedbackId!=''){
				dojo.byId("pageSize").value = dojo.byId("userInput_pageSize").value;
				dojo.byId("theAction").value="showAll";	
				var gridMsgDiv = dojo.byId("errorMsg_grid");
				gridMsgDiv.style.display = "none";
				clearGrid();
				// Always scroll to top of the page for new feedbacks request
				jQuery('html, body').scrollTop(0);
				var frm = dojo.byId("feedbackListModel");
				frm.action="/expensemap/fetchFeedbackList.jxhtm?feedbackId="+feedbackId;
				showProgressBar();
				var xhrArgs = {
						form: frm,
						handleAs: "json",
						load: function(responseData){
							
							refreshGridStore(responseData);
							hideProgressBar();
						},
						error: function() {
							hideProgressBar();
							gridMsgDiv.style.display = "block";
							gridMsgDiv.innerHTML = '<b>' + "<fmt:message key='ui.message.There.was.a.problem.retrieving.data.from.server'/>" + '</b>';
						}
					}// End of xhrArgs.
				  dojo.xhrPost(xhrArgs);					
			}
		}		
		
		
		function updateAllfeedbackTypeCheckBox(){						
			if( dijit.byId('Add_feedbackType').get("checked") &&
				dijit.byId('Rename_feedbackType').get("checked") &&
				dijit.byId('Move_feedbackType').get("checked") &&
				dijit.byId('Map_feedbackType').get("checked")){
					dijit.byId('All_feedbackType').set("checked",true);
			}else{
				dijit.byId('All_feedbackType').set("checked",false);
			}
		}		

		function validateRuleTypes(){						
			var frm = document.getElementById("feedbackListModel");
			var isRenameFeedbackEnabled = document.getElementById("renameFeedbackEnabled");
			var isMapFeedbackEnabled = document.getElementById("mapFeedbackEnabled");
			var isMoveFeedbackEnabled = document.getElementById("moveFeedbackEnabled");
			var isAddFeedbackEnabled = document.getElementById("addFeedbackEnabled");						
			var ruleTypesBuffer = "";
			if(isRenameFeedbackEnabled.value!="" && isRenameFeedbackEnabled.value=="true"){
				ruleTypesBuffer += "<fmt:message key='feedback.type.rename' />" +  ',';
			}
			if(isMapFeedbackEnabled.value!="" && isMapFeedbackEnabled.value=="true"){
				ruleTypesBuffer += "<fmt:message key='feedback.type.map' />" + ',';
			}
			if(isMoveFeedbackEnabled.value!="" && isMoveFeedbackEnabled.value=="true"){
				ruleTypesBuffer += "<fmt:message key='feedback.type.move' />"+ ',';
			}
			if(isAddFeedbackEnabled.value!="" && isAddFeedbackEnabled.value=="true"){
				ruleTypesBuffer +="<fmt:message key='feedback.type.add' />" + ',';
			}
			
			var rules = ruleTypesBuffer.toString();
			rules = rules.substring(0,rules.lastIndexOf(','));
			var flag = false;
			if(frm.feedbackIds){
				if(frm.feedbackIds.checked){
					var ruleType = document.getElementById(frm.feedbackIds.value);
					if((ruleType.value == '<%=FeedbackConstants.TYPE_RENAME%>' && (isRenameFeedbackEnabled.value=="" || isRenameFeedbackEnabled.value == 'false')) 
						|| (ruleType.value == '<%=FeedbackConstants.TYPE_MAP%>' && (isMapFeedbackEnabled.value=="" || isMapFeedbackEnabled.value == 'false')) 
						|| (ruleType.value == '<%=FeedbackConstants.TYPE_MOVE%>' && (isMoveFeedbackEnabled.value == "" || isMoveFeedbackEnabled.value == 'false')) 
						|| (ruleType.value == '<%=FeedbackConstants.TYPE_ADD%>' && (isAddFeedbackEnabled.value == "" || isAddFeedbackEnabled.value == 'false'))){
						flag = true;
					}
				}else{
					for(var i=0;i<frm.feedbackIds.length;i++){
						if(frm.feedbackIds[i].checked){
							var ruleType = document.getElementById(frm.feedbackIds[i].value);
							if((ruleType.value == '<%=FeedbackConstants.TYPE_RENAME%>' && (isRenameFeedbackEnabled.value=="" || isRenameFeedbackEnabled.value == 'false')) 
							|| (ruleType.value == '<%=FeedbackConstants.TYPE_MAP%>' && (isMapFeedbackEnabled.value=="" || isMapFeedbackEnabled.value == 'false')) 
							|| (ruleType.value == '<%=FeedbackConstants.TYPE_MOVE%>' && (isMoveFeedbackEnabled.value == "" || isMoveFeedbackEnabled.value == 'false')) 
							|| (ruleType.value == '<%=FeedbackConstants.TYPE_ADD%>' && (isAddFeedbackEnabled.value == "" || isAddFeedbackEnabled.value == 'false'))){
								flag = true;
								break;
							}
						}
					}
				}
				if(flag){
					if(rules.length==0){
						rules="None";
					}  
					alert("<fmt:message key='ui.feedback.validate.online.rule.access.violation' />" + rules);
					return false;
				}
			}
			return true;
		}
		
		function openOnlineFeedBackFormWindow() {							
				if(validateRuleTypes()){
				var url = '/expensemap/rulemanagement/SubmitOnlineFeedBackAction.do?operation=loadSubmitFeedBackForm&AuthCode=' + encodeURIComponent(document.getElementById('AuthCode').value);
				var ht = 450;
				var wt = 700;
				var left = (screen.width/2)-(wt/2);
				var top = (screen.height/2)-(ht/2);      
			
				window.open(url, 'Load_SubmitOnlineFeedBack','resizable=no,width='+wt+',height='+ht+',left='+left+',top='+top);	
			}
		}
		
		function validateFeedback(){
			try {
				var url = "/expensemap/rulemanagement/SubmitOnlineFeedBackAction.do?operation=validateFeedback&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
				 jQuery.ajax({
					url: url,
					type: "POST",
					data: {feedbackIds: collectFeedbackIds()},
					success: validateMapMoveForAdd
				 });
			} catch(err) {
				 
			}
			return;
		}

		function collectFeedbackIds(){
			var theForm = document.getElementById("feedbackListModel");
			var selectedFeedbackIds
			if(theForm.feedbackIds){
				selectedFeedbackIds = "";
				if(theForm.feedbackIds.checked){
					selectedFeedbackIds += theForm.feedbackIds.value;
				}else{
					for(var i=0;i<theForm.feedbackIds.length;i++){
						if(theForm.feedbackIds[i].checked){
							selectedFeedbackIds += theForm.feedbackIds[i].value;
							if(i < theForm.feedbackIds.length-1){
								selectedFeedbackIds += ",";
							}
						}
					}
				}
			}
			return selectedFeedbackIds;
		}
		
		function validateMapMoveForAdd(ajaxResponse){
			var data = eval(ajaxResponse);
				// If there is no data in the response, ignore this
			if (data[0] == "validateFeedback") {
				if (data[1]) {
								alert(data[2]);
								return;
							}
						}
			openOnlineFeedBackFormWindow();
		}


		function selectAll(selectAllControl) {
			var theForm =  document.getElementById("feedbackListModel");
			if ( theForm.feedbackIds == null ) {
				document.getElementById("selectAllRows").checked=false;
				document.getElementById("selectAllRows").disabled=true;
				return false;	
			} 

			if ( theForm.feedbackIds.length ) {
				// There are more than one rows on this form.
				for( var i=0; i< theForm.feedbackIds.length; i++ ) {					
					theForm.feedbackIds[i].checked = selectAllControl.checked;
				}
			}else{
				// There is just a single row on this form.
				theForm.feedbackIds.checked = selectAllControl.checked;
			}				
										
		}						

		function updateSelectAll(){				
			var theForm = document.getElementById("feedbackListModel");
			var selectAllControl = document.getElementById("selectAllRows");
			var allSelected = true;
			
			if ( ! theForm.feedbackIds.length ) {
				allSelected = theForm.feedbackIds.checked;
			}else {
				for( var i=0; i< theForm.feedbackIds.length; i++ ){
					if ( theForm.feedbackIds[i].checked == false ){
						allSelected = false;
						break;
					}	
				}
			}
			selectAllControl.checked = allSelected;
		}

		function checkAtLeastOneSelected() {
			var frm = document.getElementById("feedbackListModel");
			if (frm.feedbackIds.length) { // if the checkbox group is an array (one check box is not an array)
				var noOfRows = frm.feedbackIds.length;
				for (i = 0; i < noOfRows; i++) {
					if (frm.feedbackIds[i].checked == true) {			
						return true;
					}
				}
			}else { // There is only one check box (it's not an array)
				if (frm.feedbackIds.checked) { // if the one check box is checked
					return true;
				}
			}
			return false;
		}

		function getDipositionComment(){
			var comments="";
			do {
				comments = prompt("<fmt:message key='ui.feedback.label.Please.enter.comments' />",comments);
				if(comments.length > 255){
					alert("<fmt:message key='ui.feedback.error.Length.of.comment.should.be.255.or.less.' />");
				}
			} while(comments.length > 255);
			return comments;
		}

		function clearGrid(){
			feedback_Grid_Obj.set("style","display:none");
			dojo.byId("actionButton").style.display = "none";
			dojo.byId("pagination_div").style.display="none";
		}
		
		function submitRequest(url){							
			var theForm = document.getElementById('feedbackListModel');
			var gridMsgDiv = dojo.byId("errorMsg_grid");
			gridMsgDiv.style.display = "none";
			clearGrid();
			showProgressBar();
			theForm.action= url;
			var xhrArgs = {
				form: theForm,
				handleAs: "json",
				load: function(data){
					refreshGridStore(data);
					hideProgressBar();
				},
				error: function() {
						hideProgressBar(); 
						gridMsgDiv.style.display = "block";
						gridMsgDiv.innerHTML = '<b>' + "<fmt:message key='ui.message.There.was.a.problem.retrieving.data.from.server'/>" + '</b>';
				}				
			}// End of xhrArgs.
			dojo.xhrPost(xhrArgs);							
		}


		function collectFeedbackIndices() {							
			var theForm = document.getElementById("feedbackListModel");
			var feedbackIndexIds  ="";
			if(theForm.feedbackIds) {						
				if(theForm.feedbackIds.checked) { // if there is only one feedback listed
					feedbackIndexIds += "1,";
				}else{
					for(var i=0; i<theForm.feedbackIds.length; i++) {
						if(theForm.feedbackIds[i].checked) {
							feedbackIndexIds += i+1;
							feedbackIndexIds += ",";
						}
					}
				}
			}
			return feedbackIndexIds.slice(0, -1);												
		}

		function showHideActionButton(feedbackListModel){
			dojo.byId("actionButton").style.display="block";
			dijit.byId("open_btn").set("disabled", !feedbackListModel.showOpenButton);
			dijit.byId("accept_btn").set("disabled", !feedbackListModel.showAcceptButton);
			dijit.byId("reject_btn").set("disabled", !feedbackListModel.showRejectButton);							
			if(feedbackListModel.showSubmitOLFButton){
				dojo.byId("OLFButton").style.display="block";
				dijit.byId("online_feedback_submit").set("disabled", !feedbackListModel.showSubmitOLFButton);
			}else{
				dojo.byId("OLFButton").style.display="none";
			}
			dijit.byId("submit_btn").set("disabled", !feedbackListModel.showSubmitButton);
			dijit.byId("delete_btn").set("disabled", !feedbackListModel.showDeleteButton);
			dijit.byId("exportExl_btn").set("disabled", !feedbackListModel.showExportButton);
			dijit.byId("exportXml_btn").set("disabled", !feedbackListModel.showExportButton);
		}

		function refreshGridStore(responseData){
			if(!validateUserSession(responseData)) return false; // function validateUserSession() defined with topMenu.jsp
			if(responseData.feedbackListModel.search.disposition!=null){
				Status.set("value",responseData.feedbackListModel.search.disposition);
			}else{
				Status.set("value","Open");
			}

			displayErrorIfAny(responseData);
			createHiddenElement(responseData.feedbackList);
			document.getElementById("addFeedbackEnabled").value = responseData.feedbackListModel.addFeedbackEnabled;
			document.getElementById("moveFeedbackEnabled").value = responseData.feedbackListModel.moveFeedbackEnabled;
			document.getElementById("mapFeedbackEnabled").value = responseData.feedbackListModel.mapFeedbackEnabled;
			document.getElementById("renameFeedbackEnabled").value = responseData.feedbackListModel.renameFeedbackEnabled;

			document.getElementById("addCountValue").innerHTML = responseData.feedbackListModel.search.feedbackTypeCountMap.Add;
			document.getElementById("renameCountValue").innerHTML = responseData.feedbackListModel.search.feedbackTypeCountMap.Rename;
			document.getElementById("moveCountValue").innerHTML = responseData.feedbackListModel.search.feedbackTypeCountMap.Move;
			document.getElementById("mapCountValue").innerHTML = responseData.feedbackListModel.search.feedbackTypeCountMap.Map;
			document.getElementById("allCountValue").innerHTML = responseData.feedbackListModel.search.feedbackTypeCountMap.All;

			if(responseData.feedbackList.length > 0 ){
				measureNameListArray = responseData.feedbackListModel.measureNameList;								
				feedback_Grid_Obj.set("style","display:block");
				showHideActionButton(responseData.feedbackListModel);
				configurePaginationComponent(responseData.feedbackListModel.pagination);								
				var newStore = new dojo.store.Memory({ data: responseData.feedbackList });						
				var newDataStore = new dojo.data.ObjectStore({ objectStore: newStore });
				for(var i = 0 ; i < responseData.feedbackList.length ; i++){
					var item = responseData.feedbackList[i];
					for(var j = 0 ; j < responseData.feedbackListModel.measureNameList.length; j++){
						var currentMeasureName = responseData.feedbackListModel.measureNameList[j];
						var currentMeasureValue = responseData.feedbackList[i].measureFormattedValues[currentMeasureName];
						// If a measure is created after creating feedback, fix its value
						if (currentMeasureValue == undefined) {
							currentMeasureValue = " ";
						}
						newDataStore.setValue(item, currentMeasureName, currentMeasureValue);													
					}							
				}						
				feedback_Grid_Obj.setStore(newDataStore);
			}else{
				feedback_Grid_Obj.set("style","display:none");
				dojo.byId("actionButton").style.display = "none";
				dojo.byId("pagination_div").style.display="none";
			}							
		}
						
		/*
			This method is responsible to create/delete all hidden element that is required for Status and Action col.
		*/

		function createHiddenElement(feedbackList){							
			// Clean the previous hidden Elements							
			document.getElementById("hiddenElementContainer").innerHTML = "";
														
			for (var i = 0 ; i < feedbackList.length ; i++){
				var tempSource = feedbackList[i].source;
				
				if(feedbackList[i].source==null)  tempSource  = "ALL";

				if("ADD" == feedbackList[i].feedBackType.toUpperCase()){									
					var hiddenElement_Source = document.createElement("input");
					hiddenElement_Source.setAttribute("type","hidden");
					hiddenElement_Source.setAttribute("id","sourceIds");
					hiddenElement_Source.setAttribute("name","sourceIds");
					hiddenElement_Source.setAttribute("value", feedbackList[i].id + '$' + tempSource);
					document.getElementById("hiddenElementContainer").appendChild(hiddenElement_Source);
				}
				var hiddenElement_Action = document.createElement("input");
				hiddenElement_Action.setAttribute("type","hidden");
				hiddenElement_Action.setAttribute("id",feedbackList[i].id);
				hiddenElement_Action.setAttribute("name","feedbackType");
				hiddenElement_Action.setAttribute("value",feedbackList[i].feedBackType);
				document.getElementById("hiddenElementContainer").appendChild(hiddenElement_Action);
			}
		}

		function displayErrorIfAny(responseData){
			var gridMsgDiv = dojo.byId("errorMsg_grid");
			var searchMsgDiv = dojo.byId("errorMsg_search");
			gridMsgDiv.style.display = "none";
			gridMsgDiv.innerHTML =  "";
			searchMsgDiv.style.display = "none";						
			searchMsgDiv.innerHTML = "";					
			if(responseData.errorMsg_grid != 'undefined' && responseData.errorMsg_grid != null ){
				gridMsgDiv.style.display = "block";
				gridMsgDiv.innerHTML =  "<b>"+responseData.errorMsg_grid+"</b>";
			}
			if(responseData.errorMsg_search != 'undefined' && responseData.errorMsg_search != null){
				searchMsgDiv.style.display = "block";
				searchMsgDiv.innerHTML = "<b>" + responseData.errorMsg_search + "</b>";
			}
		}

		function validateSearchRequest(){
			if(dijit.byId("search_startSearchDate").get("value")==null || dijit.byId("search_startSearchTime").get("value")==null){
				alert("<spring:message code='ui.error.startdate'/>");
				return false;
			}

			if(dijit.byId("search_endSearchDate").get("value")==null || dijit.byId("search_endSearchTime").get("value")==null){
				alert("<spring:message code='ui.error.enddate'/>");
				return false;
			}
			return true;
		}

		function showAllFeedback(){
			var gridMsgDiv = dojo.byId("errorMsg_grid");
			gridMsgDiv.style.display = "none";
			clearGrid();
			// Always scroll to top of the page for new feedbacks request
			jQuery('html, body').scrollTop(0);
			var frm = dojo.byId("feedbackListModel");
			frm.action="/expensemap/fetchFeedbackList.jxhtm";
			showProgressBar();
			var xhrArgs = {
					form: frm,
					handleAs: "json",
					load: function(responseData){
						
						refreshGridStore(responseData);
						hideProgressBar();
					},
					error: function() {
						hideProgressBar();
						gridMsgDiv.style.display = "block";
						gridMsgDiv.innerHTML = '<b>' + "<fmt:message key='ui.message.There.was.a.problem.retrieving.data.from.server'/>" + '</b>';
					}
				}// End of xhrArgs.
			dojo.xhrPost(xhrArgs);					
		}

		function trimStr(s) {
			return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
		}

		function contains (str, obj) {
			var i = str.length;
			while (i--) {
				if(str[i]){
					if (str[i].match(new RegExp(obj,'i'))) {
						return true;
					}
				}
			}
			return false;
		}

		function canSort(col){
			var sortingOrder = "desc";
			var sortingColName="SOURCE";
			var returnVal = false;
			if(col > 0)
				sortingOrder="asc";

			dojo.byId("listSortOrder").value = sortingOrder;

			if(col < -16 || col > 16){								
				if(col<0)
					col = col*-1;																							
				sortingColName = measureNameListArray[col-17];								
				returnVal = true;
			}							
			
			if(col==9 || col==-9){
				sortingColName = "SOURCE";
				returnVal = true;
			}
			if(col==10 || col==-10){
				sortingColName = "DESTINATION";
				returnVal = true;
			}
			
			dojo.byId("listSortColumnName").value = sortingColName;
			
			if(returnVal){
				dojo.byId("theAction").value="getCurrent";
				showAllFeedback();
			}
			return returnVal;
		}
				
		function addCheckBox(field){
			return "<input type='checkbox' data-dojo-type='dijit/form/CheckBox' onclick='updateSelectAll();' name='feedbackIds' value='" + field + "'/>";
		}

		function renderFeedBackId(field,inRowIndex){
			if(field!=null)
				return '<a href=/expensemap/getDimensionalView.do?bkid=' + field[0] + '&theAction=swapFeedbackView>'+ ( field[1]) +'</a>';
			return "&nbsp;";
		}

		function renderAdditionalFeedbackDisplayId(field){
			if(field!=null && field!="")
				return field;
			return "&nbsp;";
		}

		//fields: ['name','disposition','feedBackType',id]
		function renderFeedBackName(fields){					
			var feedbackType = getFeedbackTypeLocalizedMsg(fields[2]);
			feedbackType = feedbackType.replace(" ","");
			var feedbackName =  getFeedbackName(feedbackType ,trimStr(fields[0]));
			return '<a href=# onclick=showSummary(\''+ fields[3] +'\') >'+feedbackName+'</a>';					
		}

		function getFeedbackTypeLocalizedMsg(type){					
			var enableCustomFeedbackFlag = <%= enableCustomFeedback %>; 
			
			if("ADD"== trimStr(type).toUpperCase())
			{
				if(!enableCustomFeedbackFlag){
					return "<fmt:message key='feedback.type.add' />";
				}else{
					return '<%= typeAddLabel %>';
				}
			}
			else if("MOVE"== trimStr(type).toUpperCase())
			{
				if(!enableCustomFeedbackFlag){
					return "<fmt:message key='feedback.type.move' />";
				}else{
					return '<%= typeMoveLabel %>';
				}
			}
			else if("MAP"== trimStr(type).toUpperCase())
			{
				if(!enableCustomFeedbackFlag){
					return "<fmt:message key='feedback.type.map' />";
				}else{
					return '<%= typeMapLabel %>';
				}
			}
			else if("RENAME"== trimStr(type).toUpperCase())
			{
				if(!enableCustomFeedbackFlag){
				return "<fmt:message key='feedback.type.rename' />";
				}else{
					return '<%= typeRenameLabel %>';
				}
			}
			
		}
				
		function getFeedbackName(feedbackType, feedbackName){
			if("ADD"==feedbackType.toUpperCase()){
					 feedbackType = '<%=ExpenseMapAppProperties.getFeedbackTypeAdd()%>';
					 if(feedbackName!=null && feedbackName!=""){				    	   				
							feedbackName = feedbackName.replace(feedbackName.substring(0,trimStr(feedbackType).length),feedbackType);										
					 }
				}
				if("RENAME"==feedbackType.toUpperCase()){
					 feedbackType = '<%=ExpenseMapAppProperties.getFeedbackTypeRename()%>';
					 if(feedbackName!=null && feedbackName!=""){
							feedbackName = feedbackName.replace(feedbackName.substring(0,trimStr(feedbackType).length),feedbackType);
					 }
				}
				if("MOVE"==feedbackType.toUpperCase()){
					 feedbackType = '<%=ExpenseMapAppProperties.getFeedbackTypeMove()%>';
					 if(feedbackName!=null && feedbackName!=""){
							feedbackName = feedbackName.replace(feedbackName.substring(0,trimStr(feedbackType).length),feedbackType);
					 }
				}
				if("MAP"==feedbackType.toUpperCase()){
					 feedbackType = '<%=ExpenseMapAppProperties.getFeedbackTypeMap()%>';
					 if(feedbackName!=null && feedbackName!=""){
							feedbackName = feedbackName.replace(feedbackName.substring(0,trimStr(feedbackType).length),feedbackType);
					 }
				}
		   return feedbackName;
		}

		function showSummary(feedbackId){					
			var frm = dojo.byId("feedbackListModel");
			frm.action="/expensemap/showSummary.jxhtm?curFeedbackId=" + feedbackId;	
			var xhrArgs = {
					form: frm,
					handleAs: "json",
					load: function(responseData){								
						renderSummaryDiv(responseData.summaryInfo);
					}// end of load.										
				}// End of xhrArgs.
			dojo.xhrPost(xhrArgs);
		}

		function renderSummaryDiv(summaryInfo){								
			var summaryHTML = summaryContent;						
			summaryHTML = summaryHTML.replace("{1}",getFeedbackName(summaryInfo.feedBackType,summaryInfo.name));
			summaryHTML = summaryHTML.replace("{2}",handleNullAndEmptyString(summaryInfo.comments));
			summaryHTML = summaryHTML.replace("{3}",handleNullAndEmptyString(summaryInfo.user));
			summaryHTML = summaryHTML.replace("{4}",handleNullAndEmptyString(summaryInfo.dateCreatedStr));
			summaryHTML = summaryHTML.replace("{5}",getFeedbackTypeLocalizedMsg(summaryInfo.feedBackType));
			summaryHTML = summaryHTML.replace("{6}",handleNullAndEmptyString(summaryInfo.source));
			summaryHTML = summaryHTML.replace("{7}",handleNullAndEmptyString(summaryInfo.destinationHierarchy));
			summaryHTML = summaryHTML.replace("{8}",handleNullAndEmptyString(summaryInfo.drillPoints));
			summaryHTML = summaryHTML.replace("{9}",getLocalizedDisposition(summaryInfo.disposition));
			summaryHTML = summaryHTML.replace("{10}",handleNullAndEmptyString(summaryInfo.dispositionComments));
			summaryHTML = summaryHTML.replace("{11}",handleNullAndEmptyString(summaryInfo.dispositionUser));
			summaryHTML = summaryHTML.replace("{12}",handleNullAndEmptyString(summaryInfo.dispositionDateStr));
			dijit.byId("feedbackSummaryDiv").setContent(summaryHTML);
			dijit.byId("feedbackSummaryDiv").show();								
		}

		function handleNullAndEmptyString(stringVal){
			if(stringVal==null || stringVal=="" )return "&nbsp;";
			return stringVal;
		}

		function renderComment(field){
			if(field!=null && field!="")
				return field;
			return "&nbsp;";
		}

		function renderRequestedBy(field){
			if(field!=null && field!="")
				return field;
			return "&nbsp;";
		}
		
		//fields: ['id','feedBackType']
		function renderAction(fields){
			return getFeedbackTypeLocalizedMsg(fields[1]);
		}



		//fields: ['id','source','multiKeep','feedBackType']
		function renderSource(fields){
			var returnString;							
				if(fields[1]==null) fields[1] = "ALL";
				
				returnString = fields[1];
				if(fields[2])
					returnString = '<a title=\"' + fields[1] + '\"/>' + "<fmt:message key='ui.breadcrumbs.multiplekeep.only'/>" + '</a>';

			return returnString;
		}


		function renderDestination(field){
			if(field!=null && field!='')
				return field;
			return "&nbsp;";
		}
		
		//fields:['multiKeep','drillPoints'],
		function renderDrillPoint(fields){
			var returnString = fields[1]
			if(fields[0])
				returnString = "<a title=\'" + fields[1] + "\'><fmt:message key='ui.breadcrumbs.multiplekeep.only' /> </a>";
			
			return returnString;
		}
		
		//field:['disposition'],
		function renderStatus(field){
			return getLocalizedDisposition(field);
		}


		function getLocalizedDisposition(disposition){
			disposition = disposition.toLowerCase();
			if(disposition == 'open')
				return "<fmt:message key='feedback.status.open' />";
			if(disposition == 'accepted')
				return "<fmt:message key='feedback.status.accepted' />";
			if(disposition == 'rejected')
				return "<fmt:message key='feedback.status.rejected' />";
			if(disposition == 'submitted')
				return "<fmt:message key='feedback.status.submitted' />";
			if(disposition == 'applied')
				return "<fmt:message key='feedback.status.applied' />";
			if(disposition == 'notapplied')
				return "<fmt:message key='feedback.status.notapplied' />";
			if(disposition == 'deactivated')
				return "<fmt:message key='feedback.status.deactivated' />";
		}

		function renderDispositionComment(field){
			return (field!=null && field!="")?field:"&nbsp;";
		}
		function renderDispositionUser(field){
			return (field!=null && field!="")?field:"&nbsp;";
		}
		function renderDispositionDate(field){
			return (field!=null && field!="")?field:"&nbsp;";
		}
		function renderDataRefresh(field){
			return (field!=null && field!="")?field:"&nbsp;";
		}

		function configurePaginationComponent(pageData){
			startFeedbackID = pageData.startRec
			//Set all Hidden variables
			dojo.byId("startRec").value=pageData.startRec;				
			dojo.byId("pageSize").value=pageData.pageSize;
			dojo.byId("userInput_pageSize").value=pageData.pageSize;
			dojo.byId("limitRec").value=pageData.limitRec;
			dojo.byId("totalRec").value=pageData.totalRec;
			dojo.byId("listSortOrder").value=pageData.listSortOrder;
			dojo.byId("listSortColumnName").value=pageData.listSortColumnName;
			dojo.byId("lastRecord").value=pageData.lastRecord;		
			var totalObjectCount = pageData.totalRec;							
			
			if(totalObjectCount!='undefined' && totalObjectCount > 0){								
				dojo.byId("pagination_div").style.display="block";		
				dojo.byId("pagination_text").innerHTML="";
				var firstImg = dojo.byId("first");
				var prevImg = dojo.byId("prev");
				if(pageData.startRec == 1 ){									
					firstImg.src = '/expensemap/jsp/images/beginning_disabled.gif';
					firstImg.title="<fmt:message key='tooltip.you.are.at.top'/>";
					firstImg.onclick=function(){};//donothing
						
					prevImg.src = '/expensemap/jsp/images/back_disabled.gif';			
					prevImg.title="<fmt:message key='tooltip.you.are.at.top'/>"
					prevImg.onclick = function(){};//donothing
				}else{

					firstImg.src = '/expensemap/jsp/images/beginning_enabled.gif';
					firstImg.title="<fmt:message key='tooltip.go.top'/>";
					firstImg.onclick=goToFirst;

					prevImg.src = '/expensemap/jsp/images/back_enabled.gif';
					prevImg.title=getToolTip("<fmt:message key='ui.image.tooltip.movePrevious'/>",pageData.pageSize);
					prevImg.onclick = goToPrev;
				}

				var nextImg = dojo.byId("next");
				var lastImg = dojo.byId("last");		
				if(pageData.limitRec == pageData.totalRec){
					
					nextImg.src = '/expensemap/jsp/images/forward_disabled.gif';
					nextImg.title="<fmt:message key='tooltip.you.are.at.bottom' />";
					nextImg.onclick= function(){};//donothing
						
					lastImg.src = '/expensemap/jsp/images/end_disabled.gif';
					lastImg.title="<fmt:message key='tooltip.you.are.at.bottom' />";	
					lastImg.onclick = function(){};//donothing
				}else{			
					nextImg.src = '/expensemap/jsp/images/forward_enabled.gif';
					var argForToolTip = ((pageData.totalRec-pageData.limitRec)>=pageData.pageSize)? pageData.pageSize : (pageData.totalRec - pageData.limitRec);
					nextImg.title=getToolTip("<fmt:message key='ui.image.tooltip.moveNext' />", argForToolTip);
					nextImg.onclick = goToNext;
					
					lastImg.src = '/expensemap/jsp/images/end_enabled.gif';
					lastImg.title="<fmt:message key='tooltip.go.bottom' />";
					lastImg.onclick = goToLast;
				}	
				dojo.byId("pagination_text").innerHTML = getPaginationText("<fmt:message key='ui.label.pagination.text' />",pageData.startRec,pageData.limitRec,pageData.totalRec);
			}else{
				dojo.byId("pagination_div").style.display="none";
			}
		}
		
		function getToolTip(msg,arg){			
			msg = msg.replace("{0}",arg);					
			return msg;
		}
							
		function getPaginationText(msg,startRec, limitRec, totalRec){
			msg = msg.replace("{0}", startRec);			
			msg = msg.replace("{1}" , limitRec);			
			msg = msg.replace("{2}", totalRec);			
			return msg;
		}
		
		function goToFirst(){getMaxRows('getFirst', false);}
		function goToPrev(){getMaxRows('getPrev', false);}
		function goToNext(){getMaxRows('getNext', false);}
		function goToLast(){getMaxRows('getLast', false);}

		function getMaxRows(action,applied){			
			var prevPageSize =dojo.byId("pageSize").value;
			var currPageSize = dojo.byId("userInput_pageSize").value;	
			if(!applied && prevPageSize!=currPageSize){				
				alert("<fmt:message key='ui.analytics.Navigate' />");
				return false;
			}else{				
				dojo.byId("pageSize").value = currPageSize;
				dojo.byId("theAction").value = action;				
				showAllFeedback();
			}											
		}

		function formatCurrency(value){
			return "<p class='rightAlign'>"+ value+ "</p>";
		}

			function hideProgressBar() {
				if(progressBar!=null){
					progressBar.hide();
				}
			}
			
			function showProgressBar() {
				progressBar.show();
			}

		</script>
	</head>

	<body class="claro">
		<% CubeUtil.buildExpMapMastHead(out,"viewFrame_attachment.jsp",zs,true,null,locale,null); %>
		<jsp:include page="/jsp/topMenu.jsp">
			<jsp:param name="helpUrl" value="<%=helpURL%>"/>
		</jsp:include>  
		<div id="pb" style="visibility:hidden">
			<div class="hd" align="center" style="font-family: arial,helvetica,clean,sans-serif; font-size: 11px; color: darkblue;">
				<fmt:message key="ui.label.Processing.request"/>
			</div>
			<div class="bd" align="center"><img src="/expensemap/jsp/images/dimension-viewer-progressbar/rel_interstitial_loading_resized.gif" /></div>
		</div>		
		<div id="containerDiv" class="container" >	
			<form:form action="/expensemap/showFeedBackListform.xhtm" commandName="feedbackListModel" id="feedbackListModel">
				<table class="tableWithBorder">
					<tr>
						<td class="headerText"><fmt:message key="ui.usability.Feedbacks"/></td>
						<td class="headerText" align="left"><fmt:message key="ui.usability.report.heading.datasetname"/>:&nbsp;<%=cubeName.toUpperCase()%></td>	
						
					</tr>
				</table>
				<div id="errorMsg_search" class="errorMsg"></div>
				<!-- Search DIV-->
					<div id="searchDiv" class="titleText" data-dojo-type="dijit/TitlePane" data-dojo-props="title: '<fmt:message key='ui.feedback.search.table.title' />',open:true,duration:1000" >
					<table cellpadding="5" cellspacing="0" border="0">
							<tr>
								<td class="feedbackStartDateLable">
									<div>
										<table><tr>
										<td id="dateLabel"><span><fmt:message key="ui.usability.startdate"/></span></td>

										<td><input type="text" name="search.startSearchDate" id="search_startSearchDate" data-dojo-type="dijit/form/DateTextBox"
											constraints="{datePattern:'${userDatePattern}'}"
											value="${defaultStartSearchDate}"
											required="true" /></td>
										<td><input type="text" name="search.startSearchTime" id="search_startSearchTime" data-dojo-type="dijit/form/TimeTextBox" style="width: 5em;"
											constraints="{timePattern:'HH:mm'}"
											value="${defaultStartSearchTime}"
											required="true" /></td>
										</tr></table>
									</div>
								</td>
								<td class="feedbackStatusLable">
									<div>
										<table><tr>
										<td id="statusLabel"><span><fmt:message key="ui.feedback.status.label"/></span></td>
										<td><div id="processingStatus" ></div></td>
										</tr></table>
									</div>
								</td>
								<td>
									<div>
										<span><fmt:message key="ui.feedback.type.label"/></span>
										<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="Add_feedbackType" name="search.feedbackTypeSelected" value="Add"/>&nbsp;
										<% if(enableCustomFeedback) { %> <%=typeAddLabel %><% } else { %>  <fmt:message key="feedback.type.add"/><% } %><span id="addCountValue"><c:out value='${feedbackListModel.search.feedbackTypeCountMap["Add"]}'/> </span>&nbsp;	
										<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="Rename_feedbackType" name="search.feedbackTypeSelected" value="Rename"/>&nbsp;
										<% if(enableCustomFeedback) { %> <%=typeRenameLabel %><% } else { %><fmt:message key="feedback.type.rename"/><% } %><span id="renameCountValue"><c:out value='${feedbackListModel.search.feedbackTypeCountMap["Rename"]}'/></span>&nbsp;
										<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="Move_feedbackType" name="search.feedbackTypeSelected" value="Move"/>&nbsp;
										<% if(enableCustomFeedback) { %> <%=typeMoveLabel %><% } else { %><fmt:message key="feedback.type.move"/><% } %><span id="moveCountValue"><c:out value='${feedbackListModel.search.feedbackTypeCountMap["Move"]}'/></span>&nbsp;
										<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="Map_feedbackType" name="search.feedbackTypeSelected" value="Map" />&nbsp;
										<% if(enableCustomFeedback) { %> <%=typeMapLabel %><% } else { %><fmt:message key="feedback.type.map"/><% } %><span id="mapCountValue"><c:out value='${feedbackListModel.search.feedbackTypeCountMap["Map"]}'/></span>&nbsp;
										<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="All_feedbackType" name="search.feedbackTypeSelected" value="All" />&nbsp;<fmt:message key="ui.ruleform.all.label"/><span id="allCountValue"><c:out value='${feedbackListModel.search.feedbackTypeCountMap["All"]}'/></span>&nbsp;		
									</div>
								</td>
							</tr>
							<tr>
								<td>
									<div>
										<table><tr>
										<td id="dateLabel"><span class="feedbackEndDateLable"><fmt:message key="ui.usability.enddate"/></span></td>
										
										<td><input type="text" name="search.endSearchDate" id="search_endSearchDate" data-dojo-type="dijit/form/DateTextBox" 
												constraints="{datePattern:'${userDatePattern}'}"
												value="${defaultEndSearchDate}"
												required="true" /></td>
										<td><input type="text" name="search.endSearchTime" id="search_endSearchTime" data-dojo-type="dijit/form/TimeTextBox" style="width: 5em;"  
												constraints="{timePattern:'HH:mm'}"
												value="${defaultEndSearchTime}"
												required="true" /></td>
										</tr></table>
									</div>									
								</td>
								<td>
									<div>
										<table><tr>
										<td id="statusLabel"><span><fmt:message key="ui.feedback.requestedby.label"/></span></td>
										<td><input type="text" name="search.user" id="search_name" data-dojo-type="dijit/form/TextBox" data-dojo-props="trim:true" style="width:7em"/></td>
										</tr></table>
									</div>
								</td>
								<td>
									<div>
										<span><fmt:message key="ui.feedback.keyword.label"/></span>
										<input type="text" name="search.searchKeyword" id="search_searchKeyword" data-dojo-type="dijit/form/TextBox" data-dojo-props="trim:true" style="width:13.5em"/>
									</div>
								</td>
							</tr>
							<tr>								
								<td>
									<div>
										<button data-dojo-type="dijit/form/Button" class="searchButton" id="search" name="search" type="button" onClick="onSearch();">
											<fmt:message key="ui.label.search"/>
										</button>
									</div>
								</td>
							</tr>
					</table>
				</div>		
				<!-- Search DIV-->
				
				<BR>
				<div id="errorMsg_grid" class="errorMsg"></div>
				<div id="Grid_Div" name="Grid_Div" style="display:none"></div>
				<BR>
				<div id="actionContainerDiv" class="actionContainerDiv">				
					<div id="actionButton" class="actionButton" style="display:none">					
						
							<button type="button" data-dojo-type="dijit/form/Button" id="open_btn" name="open" onClick="onOpen();"><fmt:message key="feedback.status.open"/></button>
						
							<button type="button" data-dojo-type="dijit/form/Button" id="accept_btn" name="accept" onClick="onAccept();"><fmt:message key="ui.feedback.button.accept"/></button>
						
							<button type="button" data-dojo-type="dijit/form/Button" id="reject_btn" name="reject" onClick="onReject();"><fmt:message key="ui.feedback.button.reject"/></button>							
							<div id="OLFButton" class="actionButton" style="display:none">
							<button type="button" data-dojo-type="dijit/form/Button" id="online_feedback_submit" name="online_feedback_submit" onClick="onOnlineSubmit();"><fmt:message key="ui.online.feedback.submit.button" /></button>
							</div>
						
							<button type="button" data-dojo-type="dijit/form/Button" id="submit_btn" name="submit_btn" onClick="onSubmit();"><fmt:message key="button.submit"/></button>							
						
							<button type="button" data-dojo-type="dijit/form/Button" id="delete_btn" name="delete" onClick="onDelete();"><fmt:message key="ui.label.Delete" /></button>
						
							<button type="button" data-dojo-type="dijit/form/Button" id="exportExl_btn" name="exportExl" onClick="onExportExl();"><fmt:message key="ui.feedback.button.exportExcel" /></button>						
							<button type="button" data-dojo-type="dijit/form/Button" id="exportXml_btn" name="exportXml" onClick="onExportXml();"><fmt:message key="ui.feedback.button.exportXML" /></button>
						
					</div>
					<!--Paggination  -->
					<div id='pagination_div' class="paginationDiv" style="display:none">
						<img id="first" style="vertical-align:middle;"/> 
						<img id="prev" style="vertical-align:middle;"/> 
						<img id="next" style="vertical-align:middle;"/> 
						<img id="last" style="vertical-align:middle;"/> &nbsp;
						<label id="pagination_text"></label> &nbsp;
						<!--Msg need to externalized-->
						<input type="text" id="userInput_pageSize" required="true"
									   maxLength="3"									   
									   data-dojo-type="dijit/form/ValidationTextBox"
									   data-dojo-props="regExp:'[1-9]\\d{0,2}',
														style:{width:'5em'},
														promptMessage: '<fmt:message key= 'ui.bookmark.grid.pagesize.promptmessage'/>',
														invalidMessage:'<fmt:message key= 'ui.alertmsg.rowsPerPage'/>',
														missingMessage:'<fmt:message key= 'ui.alertmsg.rowsPerPage'/>'														
														" />
								
						<button type="button" data-dojo-type="dijit/form/Button" id="applyPageSize" name="applyPageSize" onClick="onApplyPageSize();"><fmt:message key="button.apply"/></button>
					</div>
				<!--Paggination -->
				</div>
				<!-- Action Buttons -->
				
				<form:hidden id="totalDataSetCount" path="totalDataSetCount"/>	
				<form:hidden id="theAction" path="theAction"/>

				<form:hidden id="startRec" path="pagination.startRec" />
				<form:hidden id="pageSize" path="pagination.pageSize" />
				<form:hidden id="limitRec" path="pagination.limitRec" />
				<form:hidden id="totalRec" path="pagination.totalRec" />
				<form:hidden id="lastRecord" path="pagination.lastRecord" />						
				<form:hidden id="listSortColumnName" path="pagination.listSortColumnName" />
				<form:hidden id="listSortOrder" path="pagination.listSortOrder" />
				

				<input type="hidden" id="maxDataSetAllowed" value="<%=ExpenseMapAppProperties.getMaxDatasetAllowed() %>"/>				
							
				<input type="hidden" id="dispositionComment" name="dispositionComment" value=""/>
				<input type ="hidden" id="defaultStartSearchDate" value="${defaultStartSearchDate}" />
				<input type ="hidden" id="defaultStartSearchTime" value="${defaultStartSearchTime}" />
				<input type ="hidden" id="defaultEndSearchDate" value="${defaultEndSearchDate}" />
				<input type ="hidden" id="defaultEndSearchTime" value="${defaultEndSearchTime}" />
				<input type ="hidden" id="feedbackId" value="${feedbackId}"/>
				

				<input type ="hidden" id="addFeedbackEnabled"  />
				<input type ="hidden" id="moveFeedbackEnabled" />
				<input type ="hidden" id="mapFeedbackEnabled"  />
				<input type ="hidden" id="renameFeedbackEnabled" />
				
				<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
				
				<!-- For hidden variables only -->
				<div id="hiddenElementContainer" ></div>
				
			</form:form>
		</div>

		<!-- Summary Content will be rendered in this DIV -->
		<div class="titleText" id="feedbackSummaryDiv" style="width: 600px" data-dojo-type="dijit/Dialog" title="<fmt:message key='ui.feedback.summary.page.title'/>"></div>


	</body>
</html>