<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ page import="java.util.*,com.zeborg.web.*,com.zeborg.expensemap.web.*,com.zeborg.expensemap.util.*,com.zeborg.util.*,com.zeborg.expensemap.web.WebPageUtil,
                 com.zeborg.expensemap.model3.DataSet,
                 com.zeborg.expensemap.model3.Model3Util,
                 com.zeborg.expensemap.model3.ExpensemapACLUtil,
                 com.zeborg.expensemap.framework.exception.ObjectNotFoundException"
%><%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle" 
%><%@ include file="../begin_page.jspf"
%>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.emptoris.service.cube.cache.PermissionCacheImpl"%>
<%
   ACManager.getManager().checkPermission(pageContext,
										  new String[]{ExpensemapACLUtil.ViewSystemManagement},
										  ACUtil.getGlobalObject(),true);
    ParamsSystemAdminUI adminUIParams = com.zeborg.expensemap.web.WebPageUtil.getParamsForSystemAdminUI(pageContext);
%>
<fmt:setBundle basename="ExpensemapMessagesBundle" />
<TABLE width="100%">
    <TR bgcolor="#E9EEF2">
        <TD width=100 nowrap align=left valign=top rowspan=2 class="systemAdminNavigationLinks">
            <%
                String cat =WebPageUtil.includeSystemAdminTree(pageContext);
                AdminSystemNodeForm f = (AdminSystemNodeForm)EMFormUtil.getUtil().getFormFactory().getForm(AdminSystemNodeForm.FORM_NAME);
                       if (cat==null)
                           cat=f.getCubeMainAction().getName();
				
					request.setAttribute("action",cat);

                       //Figure out if we need context info for the current selection.
                       boolean contextNeeded=
                               Util.contains(
                                       new String[]{
                                           f.getMeasureAction().getName(),
   										   f.getAttributesAction().getName(),
								  		   f.getPreferenceManagementAction().getName(),
                                           f.getReportAction().getName(),
                                           f.getDimensionAction().getName(),
                                           f.getSecFiltersAction().getName(),
                                           f.getPlinthOSNodeConfigListAction().getName(),
										   f.getMaintenanceModeAction().getName()
		                                },
                                       cat);
           EditorParameters params=new EditorParameters();
           params.setMode(AdminContextFormProcessor.MODE_DATASET);

		    AdminContextForm cf=(AdminContextForm)  EMFormUtil.getUtil().defaultProcess(
                                   AdminContextForm.FORM_NAME,pageContext,params);
           String dsID=null;
           DataSet ds = null;
           String analID=null;
  

           int mainRowSpan=1;//default
           if ((contextNeeded)) {
                mainRowSpan=2;
                String action="this.form."+cf.getSubmitAction().getEncodeName()+".click()";
                HashMap<String, String> atrs = new HashMap<String, String>();
                atrs.put("onSelect",action);
                atrs.put("onChange",action);
                if ( cf.getCurrentDataSetID().findFirstSelected() != null ) {
                	dsID = cf.getCurrentDataSetID().findFirstSelected().getName();
                	if( dsID != null ) {
                    	ds=Model3Util.getDataSetHome().findByPrimaryKey(dsID);
                	}
                }
%>
        </TD>
  	<%
      	if(!cat.equalsIgnoreCase(f.getPlinthOSNodeConfigListAction().getName()) &&       	  
		   !cat.equalsIgnoreCase(f.getReportAction().getName()) && 
		   !cat.equalsIgnoreCase(f.getMaintenanceModeAction().getName()))
      	 {
  	%>	
  
        <TD height=10><fmt:message key='ui.label.Dataset' />
<%

                out.println(":");
                DefaultFormRenderer.renderProperty(cf,cf.getCurrentDataSetIDMeta(),atrs,out);
                DefaultFormRenderer.renderAction(cf.getSubmitAction(),out,locale);

              %>
        </TD>
<%       }   %>        
	<%} %>
    </TR>
    <TR bgcolor="#FFFFFF" height="300">
        <TD nowrap align=left valign=top rowspan=<%=mainRowSpan%>>
        <%
			if (cat.equals(f.getCubeMainAction().getName()))
            {
				// replaced with structs based MVC as per for bug # 37106
                %>
				<iframe src="/expensemap/getDatasetList.xhtm" name="dataSet" width="100%" height="100%" frameborder="0" border="0" scrolling="auto" allowtransparency="true"></iframe>	
				<%
            }
            else if (ds != null && cat.equals(f.getMeasureAction().getName()) )
            {
                com.zeborg.cubem.web.WebPageUtil.includeAllMeasures(pageContext, ds.getCubeMeta().getId(),
                        ds.getACObject().getId(), DataSet.PERM_CREATEMEASURE, ExpensemapACLUtil.ViewSystemManagement_Measures,
                        com.zeborg.expensemap.util.EMHelpUtil.class.getName());
            }
            else if (ds != null && cat.equals(f.getReportAction().getName())){
            	%>
            		<iframe src="../../staticReportList.shtm?" name="staticReport" width="100%" height="100%" frameborder="0" border="0" scrolling="auto" allowtransparency="true" ></iframe>
            	<%
            }else if (cat.equals(f.getTopReportcategoeryAction().getName())){
            	%>
        			<iframe src="../../showCategoeryDetail.shtm" name="category" width="100%" height="100%" frameborder="0" border="0" scrolling="auto" allowtransparency="true" ></iframe>
        		<%
        	}
           else if (ds != null && cat.equals(f.getDimensionAction().getName()))
            {
                com.zeborg.cubem.web.WebPageUtil.includeAllDimensions(pageContext,
                        ds.getCubeMeta().getId(),ds.getACObject().getId(), DataSet.PERM_CREATEDIMENSION, ExpensemapACLUtil.ViewSystemManagement_Dimensions, Boolean.TRUE.toString () );
            }
            else if (ds != null && cat.equals(f.getSecFiltersAction().getName()))
            {
				if(PermissionCacheImpl.getInstance().hasApplicationPermission(ZSessionUtil.getFromSession(pageContext).getUser(),GlobalPermissions.ViewSystemManagement_SecurityFilters)){
                com.zeborg.expensemap.web.WebPageUtil.includeAllSecurityFilters(pageContext,ds.getCubeMeta().getId(),ds.getACObject().getId(),DataSet.PERM_CREATESECURITYFILTER);
				}else{
						%>
							<iframe src="../admin/common/noPerm.jsp" name="dataSet" width="100%" height="470px" frameborder="0"/>
						<%
				}
            }
            else if (ds != null && cat.equals(f.getAttributesAction().getName()))
            {
                com.zeborg.cubem.web.WebPageUtil.includeAllAttributes(pageContext,ds.getCubeMeta().getId(),ExpensemapACLUtil.ViewSystemManagement_Attributes);
            } else if (ds != null && cat.equals(f.getPreferenceManagementAction().getName()))
            {
                com.zeborg.cubem.web.WebPageUtil.includePreferenceManagementGeneral(pageContext, ds.getCubeMeta().getId(),ds.getACObject().getId(), DataSet.PERM_VIEWDATA,ExpensemapACLUtil.ViewSystemManagement_Preference_Management);
            } else if(cat.equalsIgnoreCase(f.getPlinthOSNodeConfigListAction().getName())){
            	%>
				<iframe src="../../admin/managePlinthOSNodeConfig.xhtm?op=list" name="dataSet"	width="100%" height="100%" frameborder="0" border="0" scrolling="auto" allowtransparency="true"></iframe>
				<%
            } else if (cat.equalsIgnoreCase(f.getMaintenanceModeAction().getName()) &&
					   ExpensemapACLUtil.hasConfigureMaintenanceModePermission(zs.getUser())) {
            	%>
					<iframe src="../../admin/manageMaintenanceMode.xhtm" width="100%" height="100%" frameborder="0" border="0" scrolling="auto">
					</iframe>
				<%				
            }
        %>
        </TD>
    </TR>
</TABLE>

<script language="javascript">
function doHelp()
{
    open( "<%=emHelp.getHelpURL(cat,locale)%>", "_blank" );
}
</script>

<%@ include file="../end_page.jspf"%>
