<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@ page import="com.zeborg.expensemap.model3.DataSet"%>
<%@ page import="java.util.*,java.text.*"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import ="org.apache.struts.Globals,com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties" %>
<%@ page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.view.CubeUtil,com.zeborg.expensemap.view.HelpUtil"%>
<%
		String rowStyle="";
		List reportList = (List)request.getAttribute("reportList");
		ZSession zs = com.zeborg.expensemap.view.ZSessionUtil.getFromSession(pageContext);		
		Locale locale =zs.getUser().getLocale();
		String cubeName = zs.getDataSet().getDisplayName();
		int noOfRows= reportList.size();		   
		EmResourceBundle bundle=EmLocalizationManager.getBundle(EmLocalizationManager.ANALYTICS_MESSAGEBUNDLE, locale);	
		String helpURL = HelpUtil.getHelpUtil().getHelpURLString("help.url.attachment.list.page", locale);
		pageContext.setAttribute("returnToURL","../attachment/AttachmentListAction.do",pageContext.SESSION_SCOPE);	
		EmResourceBundle baseBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_SRC_RESOURCE_BUNDLE, locale);
		String title = ExpenseMapAppProperties.getBrowserTitleSpend()+ " - "+ baseBundle.getValue("ui.label.existing.attachments");
	    int descriptionMaxLength = 30;     
    	int nameMaxLength = 30;   
%>
<!DOCTYPE html> 
<html:html>
<bean:define id="sortOrderObj" name="attachmentForm" property="listSortOrder"/>
<bean:define id="sortColObj" name="attachmentForm" property="listSortColumnName"/>
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zs.getUser().getTimeZone().getID()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	
	
<head>

<title><%=title%></title>
<jsp:include page="/jsp/includes/commonHeaderIncludes.jsp"/>
<style>
	a, A:link, a:visited, a:active, A:hover {color: #330099;}
	.clearElement { height: 0; width: 0; clear: both; }
	form { padding:0; margin: 0; }
</style>
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css">
<script language="JavaScript" src="/expensemap/jsp/analytics/scripts/commons.js"></script>
<script language="javascript">

function viewReport(reportID,reportName) {
	var frm = document.getElementById('viewAttachmentForm');
	frm.reportId.value = reportID;
	frm.reportName.value = reportName;
	frm.theAction.value='view';
	frm.method="post";
	frm.action="/expensemap/attachment/openAttachment.do";
	frm.submit();	
} 

function paginate(action){
	var frm = document.getElementById("viewAttachmentForm");
	frm.method="post";
	frm.theAction.value=action;
	frm.action="/expensemap/attachment/AttachmentListAction.do";
	frm.submit();
}

function submitFormForSorting(columnName){
	var order = '<%=sortOrderObj.toString()%>';
	if(order=='' || order==null || order=='null'){
		order = 'asc';
	}

	var frm = document.getElementById("viewAttachmentForm");
	frm.method="post";
	frm.listSortColumnName.value=columnName;
	frm.listSortOrder.value=order
	frm.theAction.value="";
	frm.action="/expensemap/attachment/AttachmentListAction.do";
	
	if(order=='asc'){
			order='desc';
		}else if(order=='desc'){
			order='asc';
	}
	
	document.getElementById("listSortOrder").value=order;
	document.getElementById("listSortColumnName").value=columnName;
	frm.submit();
}

function displayReportNamesAsPerScreen()
{
	var winSize = (document.body.offsetWidth/ 1280)*100;

	<c:forEach var="report" items="${requestScope.reportList}" varStatus="status" >
	  var name = "${report.name}";
	  var nameLenAsPerScreen =parseInt(0.3*winSize);
	  if(nameLenAsPerScreen < name.length )
	  {
	       document.getElementById( 'name'+("${status.count}"-1)).innerText =name.substring(0,nameLenAsPerScreen)+'...'	;
	  }
	  else
	  {
			document.getElementById( 'name'+("${status.count}"-1)).innerText =name.substring(0,nameLenAsPerScreen)	;
	  }
	</c:forEach>
}

function init(){
	var obj = document.getElementById("maxRowsList");
	if(obj!=null && obj!='null' && obj!='undefined'){
		obj.focus();
	}	
}

function validateSubmit(){
	if(isValidNumber()){
		document.getElementById("pageSize").value = document.getElementById("maxRowsList").value; 
	}
}

</script> 
</head>
<body onResize="displayReportNamesAsPerScreen();" onload="init();">
<% CubeUtil.buildExpMapMastHead(out,"viewFrame_attachment.jsp",zs,true,null,locale,null); %>
<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="topMenuForm" value="viewAttachmentForm"/>
</jsp:include>
<div class="clearElement"></div>
<% 
	String sortOrder = (String)sortOrderObj;
   	String sortCol =  (String)sortColObj; 
	if(sortCol == null || sortCol.equals("null") || sortCol.equals(""))
	{
		sortCol="1";
	} 
%>
<html:form  action="/AttachmentListAction.do?theAction=getCurrent" styleId="viewAttachmentForm" onsubmit="validateSubmit();">
<logic:messagesPresent message="true" property="org.apache.struts.action.GLOBAL_MESSAGE" >
<center>
<font color=#ff0000>
	<b>
	<html:messages id="msg" message="true" bundle="emMessages"> 
	      <bean:write name="msg" bundle="emMessages"/> 
	</html:messages> 
	</b>
</font></center>
</centre>
</logic:messagesPresent>
<logic:messagesPresent message="true" property="emSrcMessages" >
<center>
<font color=#ff0000>
	<b>
	<html:messages id="msg" message="true" property="emSrcMessages" bundle="emSrcMessages">
		<bean:write name="msg"/>
	</html:messages>
	</b>
</font></center>
</logic:messagesPresent>
<table class="tableWithBorder">
 	 <tr>
       	<td class="reportTitle" align="left"><bean:message key="ui.label.existing.attachments" bundle="emSrcMessages" /></td>
		<td align="center"><b><bean:message key="ui.usability.report.heading.datasetname"/><b>:&nbsp;<%=cubeName.toUpperCase()%></b></td>
		<td ><A TARGET="_blank" HREF="<%=helpURL%>"><IMG align="right" title=<bean:message  key='ui.label.Help' bundle='analytic'/>  SRC="/expensemap/jsp/cap_area/btn_help_up.gif" WIDTH="22" HEIGHT="22" BORDER="0" ></a></td>		
	</tr>
</table>
<table class="InnerTableWithBorder">
		<tr>
		<td NOWRAP class="thead" align="center"><a href="#" onclick="submitFormForSorting('byName');"><bean:message key="ui.label.Name" bundle='emMessages'/></a><%if((sortOrder != null && sortOrder.equals("desc")) && (sortCol != null && sortCol.equals("byName"))){%>
			<img src="/expensemap/jsp/images/up.gif" border="0">
			<%}else if((sortOrder != null && sortOrder.equals("asc")) && (sortCol != null && sortCol.equals("byName"))){%>
			<img src="/expensemap/jsp/images/down.gif" border="0"/><%}%>
		</td>			    
		<td NOWRAP class="thead" align="center"><bean:message key="ui.label.Description" bundle='emMessages'/>
		</td>			    	     
		<td NOWRAP class="thead" align="center"><a href="#" onclick="submitFormForSorting('dateCreated');"><bean:message key="ui.label.Date.Created" bundle='emSrcMessages'/></a><%if((sortOrder != null && sortOrder.equals("desc")) && (sortCol != null && sortCol.equals("dateCreated"))){%>
			<img src="/expensemap/jsp/images/up.gif" border="0">
			<%}else if((sortOrder != null && sortOrder.equals("asc")) && (sortCol != null && sortCol.equals("dateCreated"))){%>
			<img src="/expensemap/jsp/images/down.gif" border="0"><%}%></td>			    
		<td NOWRAP class="thead" align="center"><a href="#" onclick="submitFormForSorting('dateUpdated');"><bean:message key="ui.label.Date.Last.Updated" bundle='emSrcMessages'/></a><%if((sortOrder != null && sortOrder.equals("desc")) && (sortCol != null && sortCol.equals("dateUpdated"))){%>
			<img src="/expensemap/jsp/images/up.gif" border="0">
			<%}else if((sortOrder != null && sortOrder.equals("asc")) && (sortCol != null && sortCol.equals("dateUpdated"))){%>
			<img src="/expensemap/jsp/images/down.gif" border="0"><%}%></td>			    
		</tr>
		<logic:iterate name="reportList" type="com.zeborg.report.model.StaticReport" id="currentViewVO" indexId="ctr" >
		<tr class="<%=(ctr.intValue() % 2 == 0) ? "trEven" : "trOdd"%>">
			<td class=".tdStyle" align="left">			
			<% String name= currentViewVO.getDisplayName();
			String nameId = "name"+ctr.intValue();
			if(name.length() < nameMaxLength ){%>
			<a href="#" onclick="viewReport('<bean:write name='currentViewVO' property='id'/>','<bean:write name='currentViewVO' property='name'/>');"/><div  id="<%=nameId%>"  title="<%=name%>"><%=name%></div></a>
			<%}else{%>
			<a href="#" onclick="viewReport('<bean:write name='currentViewVO' property='id'/>','<bean:write name='currentViewVO' property='displayName'/>');"/><div  id="<%=nameId%>"  title="<%=name%>"><%=name.substring(0,nameMaxLength)%>...</div></a>
			<%}%>			
			</td>
			<td class=".tdStyle" align="left">
			<%
			String description= currentViewVO.getDescription();
			if (description.length() < descriptionMaxLength ){%>
						<bean:write name="currentViewVO" property="description"/>
			<% }else{%>
				<div  id="description" title="<%=description%>"><%=description.substring(0,descriptionMaxLength)%>...</div>
			<%}%>
			
			</td>
						
			<td class=".tdStyle" align="center">
       			<fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" value="${ currentViewVO.createdDate }" />
       		</td>
       		<td class=".tdStyle" align="center">
       			<fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" value="${ currentViewVO.lastModifiedDate }" />
       		</td>		   
		</tr>    	
  </logic:iterate>	
  
</table>
<br>
<table class="tableWithoutBorder" width="98%" >

	<tr>
		<td>
	<bean:define id="pageSizeValue" name="attachmentForm" property="pageSize"/>
	<bean:define id="totalRecValue" name="attachmentForm" property="totalRec"/>
	<bean:define id="startRecValue" name="attachmentForm" property="startRec"/>

		<c:if test="${  ! empty reportList }" >
			<jsp:include flush="true" page="reportListPagination.jsp">
				<jsp:param name="isDataPresent" value="${  ! empty reportList }" />	
				<jsp:param name="pageSize" value="<%= pageSizeValue.toString() %>" />
				<jsp:param name="totalRec" value="<%= totalRecValue.toString() %>" />
				<jsp:param name="startRec" value="<%= startRecValue.toString() %>" />
				<jsp:param name="noOfRows" value="<%= noOfRows %>" />				
			</jsp:include>
		</c:if>
		</td>
	</tr>
</table>
<br>
<html:hidden name="attachmentForm" styleId="reportId" property="reportid"/>
<html:hidden name="attachmentForm" styleId="listSortColumnName" property="listSortColumnName"/>
<html:hidden name="attachmentForm" styleId="listSortOrder" property="listSortOrder"/>
<html:hidden name="attachmentForm" styleId="theAction" property="theAction"/>
<html:hidden name="attachmentForm" styleId="reportName" property="reportName"/>
</html:form>
</body>
</html:html>