<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@page import="com.emptoris.viewer.ReportViewType"%>
<%@page import="com.zeborg.cubem.model.EMChartState,org.apache.commons.lang.StringUtils"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@include file="../includes/tlib.jspf" %>
<%@ page import="com.zeborg.web.DefaultFormRenderer, java.util.Date,java.text.SimpleDateFormat,
                 com.zeborg.cubem.model.EMGlobalPreferences,org.apache.struts.util.LabelValueBean,
				 com.zeborg.expensemap.view.HelpUtil,com.zeborg.acl.util.LocaleUtil,
                 com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.emptoris.viewer.crosstab.common.CrosstabActionConstants"%>
<%@ page import="com.zeborg.expensemap.model3.ExpensemapACLUtil, com.emptoris.viewer.util.CSRFHelper, com.zeborg.expensemap.crosstab.util.CrosstabService"%>
<%@ page import="org.owasp.esapi.ESAPI"%>
<%@ include file="../begin_page.jspf"%>
<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties" %>
<%
    String helpKey ="help.url.crosstab.view.page";
    String xDims = "";
    String yDims = "";
    String title = "";
    String altText = "";
    String imageSrc = "";
    String displayType = null;
    String newDisplayType = "";
    boolean allowExport = "true".equals(request.getParameter("allowExport"));
    String viewCrossTab = request.getParameter(CrosstabActionConstants.RequestParameter.VIEW_CROSSTAB); 

    if(request.getParameter(CrosstabActionConstants.RequestParameter.NEW_DISPLAY_TYPE) != null && !request.getParameter(CrosstabActionConstants.RequestParameter.NEW_DISPLAY_TYPE).equalsIgnoreCase("null")){
    	displayType = request.getParameter(CrosstabActionConstants.RequestParameter.NEW_DISPLAY_TYPE);
    }else{
	    displayType = (String)request.getParameter(CrosstabActionConstants.RequestParameter.DISPLAY_TYPE);
    }
    if(displayType == null || "".equalsIgnoreCase(displayType)){
        helpKey ="help.url.crosstab.create";
    }
	String columnDimensionName1 = request.getParameter("columnDimensionName1");
	String columnDimensionName2 = request.getParameter("columnDimensionName2");
	String rowDimensionName1 = request.getParameter("rowDimensionName1");
	String rowDimensionName2 = request.getParameter("rowDimensionName2");
		
		if((columnDimensionName1.equalsIgnoreCase("none") && columnDimensionName2.equalsIgnoreCase("none"))
			|| (!rowDimensionName1.equalsIgnoreCase("none")&& !rowDimensionName2.equalsIgnoreCase("none") && !columnDimensionName1.equalsIgnoreCase("none"))
			|| (!rowDimensionName1.equalsIgnoreCase("none")&& !rowDimensionName2.equalsIgnoreCase("none")&& !columnDimensionName1.equalsIgnoreCase("none")&& !columnDimensionName2.equalsIgnoreCase("none"))
			|| (!rowDimensionName1.equalsIgnoreCase("none")&& !columnDimensionName1.equalsIgnoreCase("none") && !columnDimensionName2.equalsIgnoreCase("none"))) 
		{
		viewCrossTab = null;
		}
   if(viewCrossTab!=null){
	    if(displayType.equals(ReportViewType.GRAPH.name())){
	    	newDisplayType = ReportViewType.TABLE.name();
	    	imageSrc = "/expensemap/jsp/images/report/chart_table_icon.gif";    	
	    	altText = "ui.label.toggle.table";
	    }else if(displayType.equals(ReportViewType.TABLE.name())){
	    	newDisplayType = ReportViewType.GRAPH.name();
	    	imageSrc = "/expensemap/jsp/images/report/chart_table_icon.gif";
	    	altText = "ui.label.toggle.graph";	    	
	    }
    }

String ctID = request.getParameter("ctId");
String expType = request.getParameter("ExportType");
String bkid = "";
if(request.getParameter("bkid") != null){
	bkid = request.getParameter("bkid");
	if(bkid.equalsIgnoreCase("null")){
		bkid = "";
	}
}
boolean canEditTabulation =false;
String helpURL = HelpUtil.getHelpUtil().getHelpURLString(helpKey,zs.getUser().getLocale());
boolean canCreateTabulation = ExpensemapACLUtil.hasCreateTabulationPermission(zs.getUser(), zs.getDataSet());

if(StringUtils.isNotBlank(ctID) && !("null".equalsIgnoreCase(ctID))){
 canEditTabulation = CrosstabService.canEditTabulation(zs,ctID);
}
%>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<script type="text/javascript" src="/expensemap/jsp/javascript/export_pdf.js" ></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js" ></script>
<jsp:include page="/jsp/includes/commonHeaderIncludes.jsp"/>

<SCRIPT type="text/javascript">


function submitCrosstabRequest() {
	parent.showCrossTabs('1');
}

function editCrosstabRequest() {
	parent.editCrossTabs();
}

function exportTabulation() {
    var theForm = document.getElementById("ExportForm");
    var url='';
    var displayModeCsv = document.getElementById("fileTypeCsv");
    var displayModeXls = document.getElementById("fileTypeXls");
	var unmergeXls = document.getElementById("chkunMergeCells").checked;
	var displayModeXlsx = document.getElementById("fileTypeXlsx");
	theForm.userInputFileName.value = trim(document.getElementById("fileName").value);
    //method in commons.js
    if (validateFileName(fileName, "<bean:message key='ui.error.file.name.required'/>", "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + '\n  _   -')) {
    	var numFormatObject = document.getElementById("exportNumberFormat");
		var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;						
		theForm.numberFormat.value = numFormat;
	
	    if ( displayModeCsv.checked == true ) {
	        url = "/expensemap/Export.do?operation=exportCrossTabCSV&ctId=<%=ESAPI.encoder().encodeForJavaScript(ctID)%>";
	    } else if ( displayModeXls.checked == true ) {
	        url = "/expensemap/Export.do?operation=exportCrossTabExcel&ctId=<%=ESAPI.encoder().encodeForJavaScript(ctID)%>&unmergeXls=" + unmergeXls ;
	    }else if ( displayModeXlsx.checked == true ) {
	    	if(isExportable(<%=ESAPI.encoder().encodeForJavaScript(ctID)%>))
	    	{
	    		url = "/expensemap/Export.do?operation=exportCrossTabExcelx&ctId=<%=ESAPI.encoder().encodeForJavaScript(ctID)%>&unmergeXls=" + unmergeXls;
	    	}
	    	else{
	    		alert("<bean:message key='ui.message.use.export.option.csv.for.tabulation'/>  ");
				return;
	    	}
	    }
	    theForm.action = url;
	    theForm.method="post";
		theForm.target = '_blank';
	    theForm.submit();
		theForm.target = '_self';
	    closeExportBox();
	}	
}

function isExportable(ctid){
	try {
		var url = "/expensemap/checkExportXlsxCrosstabAction.xhtm";
		var data = eval(jQuery.ajax({
			url: url,
			type: "GET",
			data: {ctid: ctid},
			async: false
		}).responseText);
		
		if (data[0]=="TRUE") {
			return true ;
		} else {
			return false ;
		} 
	} catch(e) {
		return false;
	}
}

// Returns the function name and its params as a string for calling export functionality from common export UI in commonExportUI.jsp
function getParamString(name, id, status) {
	return "javascript:exportTabulation()";
}

// Returns header string for export ui called from commonExportUI.jsp. It depends upon module its called for.
function getHeader() {
		return "<bean:message key='ui.title.exporting.tabulation'/>";
}
var enableUnmergeForXls = <%=ExpenseMapAppProperties.isEnableUnmergeForXls()%>
// Show/hide divs upon selection of csv/excel type. called from commonExportUI.jsp
function toggleOptionDiv(fileType) {
	if (document.getElementById("fileTypeXlsx").checked ){
		document.getElementById("unmergeXlsSpan").style.display = "block";
		document.getElementById("drNumberFormat").style.display = "none";
		document.getElementById("lableNumberFormat").style.display = "none";
		document.getElementById("trNumFormat").style.display = "none";
	}else if((document.getElementById("fileTypeXls").checked && enableUnmergeForXls)){
		document.getElementById("unmergeXlsSpan").style.display = "block";
		document.getElementById("drNumberFormat").style.display = "block";
		document.getElementById("lableNumberFormat").style.display = "block";
		document.getElementById("trNumFormat").style.display = "table-row";
	}else{
		document.getElementById("unmergeXlsSpan").style.display = "none";
		document.getElementById("drNumberFormat").style.display = "block";
		document.getElementById("lableNumberFormat").style.display = "block";
		document.getElementById("trNumFormat").style.display = "table-row";
	}
}

// Initialize the export UI. show/hide divs. It depends upon each module which div to show/hide. called from commonExportUI.jsp
function initDiv() {
		var dimensionOptionsDiv = document.getElementById("dimensionOptionsDiv");
		var dimensionNoOfRowsOptionsDiv = document.getElementById("dimensionNoOfRowsOptionsDiv");
		dimensionOptionsDiv.style.display = 'none';
		dimensionNoOfRowsOptionsDiv.style.display = 'none';
		document.getElementById("fileTypeXlsxSpan").style.display = "block";
		document.getElementById("fileTypeXlsx").checked=true;
		document.getElementById("drNumberFormat").style.display = "none";
		document.getElementById("lableNumberFormat").style.display = "none";
		document.getElementById("trNumFormat").style.display = "none";
		document.getElementById("unmergeXlsSpan").style.display = "block";

	}
	
	// Returns level by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
	function getLevelsBydimId(dimId) {
		return 0;
	}

	//Returns no of rows by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
	function getNoOfRowsBydimId(dimId) {
		return 0;
	}
</SCRIPT>

<fmt:setBundle basename="ExpensemapMessagesBundle" />

<FORM ID="ChartCrossTabForm" NAME="ChartCrossTabForm" ACTION="/expensemap/getDimensionalView.do" METHOD="POST" TARGET="_top">
		<INPUT TYPE="hidden" NAME="theAction" VALUE="">
</FORM>

<FORM ID="ChartCrossTabFormOff" NAME="ChartCrossTabFormOff" ACTION="/expensemap/getDimensionalView.do" METHOD="POST"   TARGET="<%=zs.getExpensemapFrame()%>">
		<INPUT TYPE="hidden" NAME="theAction" VALUE="chartCrossTabOff">
</FORM>

<FORM ID="ExportForm" NAME="ExportForm" METHOD="post" >
		<jsp:include page="/jsp/includes/commonExportUI.jsp"/>
        <INPUT TYPE="hidden" NAME="theAction" VALUE="exportCrossTabExcel">
        <INPUT TYPE="hidden" NAME="type" VALUE="<%=ESAPI.encoder().encodeForHTML(expType)%>">
        <INPUT TYPE="hidden" NAME="includeConstraints" VALUE="true">
        <INPUT TYPE="hidden" NAME="ctId" VALUE="<%=ESAPI.encoder().encodeForHTML(ctID)%>">
        <input TYPE="hidden" NAME="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
        <input TYPE="hidden" NAME="numberFormat" value="" />
		<input TYPE="hidden" NAME="userInputFileName" value="" />
		
</FORM>

<FORM ID="PrintForm" NAME="PrintForm" ACTION="/expensemap/jsp/printViewer.jsp" METHOD="post" TARGET="_blank">
        <INPUT TYPE="hidden" NAME="theAction" VALUE="printCrossTabReport">
        <INPUT TYPE="hidden" NAME="type" VALUE="<%=ESAPI.encoder().encodeForHTML(displayType)%>">
        <INPUT TYPE="hidden" NAME="includeConstraints" VALUE="true">
        <INPUT TYPE="hidden" NAME="ctId" VALUE="<%=ESAPI.encoder().encodeForHTML(ctID)%>">
        <input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</FORM>
 
	<div id="header_css" style="position: fixed !important;width:100%;z-index:1">
	<TABLE class="sp_css" WIDTH="100%" CELLSPACING="0" CELLPADDING="0" BORDER="0" bgcolor="#F2F2F2">
		<TR class="oneUITableHeading">
		   <TD WIDTH="1%" class="dimTitle" NOWRAP>&nbsp;<fmt:message key='ui.label.CrossTab.Graph' /></TD>
	    	<TD WIDTH="99%" ALIGN="right" STYLE="padding-top: 2px;" NOWRAP>
	    	<%if(canCreateTabulation){ %>
		      <A HREF="#" onclick="submitCrosstabRequest();"><IMG SRC="/expensemap/jsp/images/chart_white_bg.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<fmt:message key='ui.label.CrossTab.Graph' />"></A>
		    <%}%> 
			<%if(canEditTabulation){ %>
		      <A HREF="#" onclick="editCrosstabRequest();"><IMG SRC="/expensemap/jsp/images/edit.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<fmt:message key='ui.label.edit.tabulation' />"></A>
		    <%}%>
			  <%if(viewCrossTab!=null && !viewCrossTab.equals("null") && !viewCrossTab.equals("")){%>
			   	  	<SPAN id="toggleSpan"><A HREF="#" onclick="toggleGraphType('<%=newDisplayType%>');"><IMG SRC="<%=imageSrc%>" BORDER="0" title="<fmt:message key='<%=altText%>'/>"></A></span>
			  <% 
			  if(displayType.equals(ReportViewType.GRAPH.name())){ 
 	    	  %> 	    	  
		  	  	<SPAN id="changeSpan"><A HREF="#" onclick="openPreference();"><IMG SRC="/expensemap/jsp/images/report/prefereneces_icon.gif" BORDER="0" title="<fmt:message key='ui.label.chart.preferences'/>"></A></span>				
			  <%}}%>
	    	  	<SPAN id="exportSpan" style="display: none;">
		         <% if ( ACManager.getManager().hasPermission(zs.getUser(),new String[]{"ExportTo_CSV_OR_Excel"},ACUtil.getGlobalObject(), false) ) { %>
			         <A HREF="javascript:openExportBox('<esapi:js><c:out value="<%=request.getAttribute(CrosstabActionConstants.RequestParameter.CROSSTAB_NAME)%>"/>
					</esapi:js>');"><IMG NAME="ExportFormSubmit" SRC="/expensemap/jsp/images/excel.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<fmt:message key='ui.label.Export.Report.to.Excel' />"></A>
		         <% } %>
		         <%if(displayType.equals(ReportViewType.TABLE.name())){%> 
			         <A HREF="javascript:document.PrintForm.submit()"><IMG NAME="PrintFormSubmit" SRC="/expensemap/jsp/images/print.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<fmt:message key='ui.label.Print.Report' />"></A>
		         <% } else if(displayType.equals(ReportViewType.GRAPH.name())){%>
		         	<A HREF="#" onclick="printPreviewChart('<%=ESAPI.encoder().encodeForJavaScript(bkid)%>');"><IMG SRC="/expensemap/jsp/images/print.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<fmt:message key='ui.label.Print.Report' />"></A>
		         <% } %> 
		      </SPAN>
		      <A TARGET="_blank" HREF="<%=helpURL%>"><IMG SRC="/expensemap/jsp/images/help.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<fmt:message key='ui.label.Help' />"></A>
	    	  <A  HREF="javascript:document.ChartCrossTabFormOff.submit()"><IMG SRC="/expensemap/jsp/images/close.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<fmt:message key='ui.label.Close.CrossTab.Graph' />"></A>
		    </TD>
		</TR>
	</TABLE>
	</div>
<%@ include file="../end_page.jspf"%>