<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>
<!DOCTYPE html>
<html class='no-js'>
<head>
<meta charset='utf-8'>
<%@ include file="../includes/tlib.jspf"%>
<%@ page import="com.emptoris.charts.ChartDataSource"%>
<%@ page import="com.emptoris.viewer.chart.ChartUtil"%>
<%@ page import="com.emptoris.charts.impl.DefaultChartDataSource"%>
<%@ page import="java.util.*"%>
<%@ page import="org.apache.commons.lang.StringUtils"%>
<%@ page import="org.owasp.esapi.ESAPI"%>
<%@ page import="com.fasterxml.jackson.core.JsonProcessingException" %>
<%@ page import="com.fasterxml.jackson.databind.ObjectMapper" %>
<%@ page import="com.fasterxml.jackson.databind.SerializationFeature" %>
<%@ page import="org.apache.commons.lang.StringEscapeUtils" %>
<%@ page import="com.emptoris.viewer.chart.forms.ChartPreferencesForm"%>
<%@ page import="org.apache.struts.action.ActionForm"%>
<%@ page import="com.emptoris.charts.ChartType" %>
<%@ page import="com.zeborg.expensemap.view.LocaleUtil" %>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<link rel="stylesheet" type="text/css" media="screen" href="/expensemap/jsp/css/c3/c3-b03125fa.css" />

<script src="${pageContext.servletContext.contextPath}/jsp/javascript/c3/d3-3.5.0.min-3b564392.js" type="text/javascript"></script>
<script src="${pageContext.servletContext.contextPath}/jsp/javascript/c3/c3.js" type="text/javascript"></script>
<script src="${pageContext.servletContext.contextPath}/js/jquery-1.4.2.min.js" type="text/javascript"></script>
<script src="${pageContext.servletContext.contextPath}/js/jquery-ui-1.8.2.custom.min.js" type="text/javascript"></script>



<style>
.c3 svg {
font-family: Arial, Helvetica, sans-serif;
font-size: 13px;
}
.c3-legend-item {
  font-size: 13px;
}
.chartHeader { font-family:Arial, Helvetica, sans-serif; font-size:13px; color: #575757; }
.chartFooter { font-family:Arial, Helvetica, sans-serif; font-size:13px; color: #575757; }
</style>

<script>

<% 
		ChartPreferencesForm pref= null;
		String dashboardPanelId=request.getParameter("dashboardPanelId");
		if(dashboardPanelId == null){
		 pref=(ChartPreferencesForm)request.getAttribute("chartPref");
		} else {
		 pref=(ChartPreferencesForm)request.getAttribute("chartPref"+dashboardPanelId);
		}
		ChartType charts[] = (ChartType[])request.getAttribute("chartsSupported");
		ChartDataSource chartDataSource = (ChartDataSource)request.getAttribute("chartDataSource");;
			
		
		ObjectMapper mapper = new ObjectMapper();
		String rowNames =  mapper.writeValueAsString(chartDataSource.getRowNames());
		String xAxisLabels =  mapper.writeValueAsString(chartDataSource.getColumnNames());
		double maxStaggerValue = chartDataSource.getMaxStaggerValue();		
		//get the nodes as comma separated string
		// the nodes are going to be the same irrespective of ChartDataSource, so get it from first itself.
		String srtNodeIdList = "";
		List<Integer> nodeIds= chartDataSource.getNodeIdList();
		for(Integer nodeId : nodeIds){
				srtNodeIdList=srtNodeIdList+nodeId+",";
			}
		srtNodeIdList=srtNodeIdList.substring(0,srtNodeIdList.lastIndexOf(","));
		
		double yMax=pref.getyScaleMaxValue() == 0 ? pref.getyScaleMaxValue():0;

		// C3 supports just two Y axis of now
		//data1: 'y',
		//data2: 'y2'
		List<String> axisNameSet= chartDataSource.getRowNames();
		String	axisStr="";
		boolean showMultipleYAxis=false;
		if(axisNameSet.size()>0 && axisNameSet.get(0)!=null){
			axisStr=axisStr+axisNameSet.get(0);
			axisStr = axisStr.replaceAll("[-+*`&.^:,%#\"@ (){}\\[\\]~<>?|';!]","_");
			axisStr=axisStr+": 'y'";
		}
		if(axisNameSet.size()> 1 ){
			showMultipleYAxis=true;
			axisStr=	axisStr+","+axisNameSet.get(1);
			axisStr = axisStr.replaceAll("[-+*`&.^:,%#\"@ (){}\\[\\]~<>?|';!]","_");
			axisStr=axisStr+": 'y2'";
		}	
		
		String chartDataSourcePieData=(String)request.getAttribute("chartDataSourcePieData");
			
		List<String> measurestoDisplay_temp = (List<String>)request.getAttribute("measurestoDisplay");
		List <String> measurestoDisplay= new ArrayList<String>();
		for(String mName:measurestoDisplay_temp){
		String t = mName.replaceAll("[-+*`&.^:,%#\"@ (){}\\[\\]~<>?|';!]","_"); 
		measurestoDisplay.add(t);
		}		
%>

 var _showMultipleYAxis=<%=showMultipleYAxis%>;
 var pieChartIndex = <%= ChartType.pie.ordinal()%>;
 var donutChartIndex = <%= ChartType.donut.ordinal()%>;
 var gaugeChartIndex = <%= ChartType.gauge.ordinal()%>;	
 
 var _c3Chart ;
 var _selectedChartType;
 
 var _showLegendFlag=eval('<%=pref.isLegendVisible() %>');
 var _showLegendPosition='<%=pref.getLegendPosition()%>';
 var _selectedChartTypeNumber=eval('<%=pref.getChartType()%>');
 var _showXgrid=eval('<%=pref.isXgrid()%>');
 var _showYgrid=eval('<%=pref.isYgrid()%>'); 
 var _showPoint=eval('<%=pref.isShowDataPoints()%>');  
 var _xAxisLabel='<%=ESAPI.encoder().encodeForJavaScript(pref.getXtitle())%>';
 var _yAxisLabel='<%=ESAPI.encoder().encodeForJavaScript(pref.getYtitle())%>';
 var _xAxisTitlePosition='<%=pref.getxTitlePosition()%>';
 var _yAxisTitlePosition='<%=pref.getyTitlePosition()%>';
 var _showTooltip=eval('<%=pref.isShowTooltip()%>');
 var _groupTooltip=eval('<%=pref.isShowGroupTooltip()%>'); 
 var _xAxisLabelRotationAngle=eval('<%=pref.getxAxisLabelRotationAngle()%>');
 var _yAxisMax=eval('<%=yMax%>');
 var _yAxisMin=eval('<%=pref.getyScaleMinValue()%>');
 var _chartHeight=eval('<%=pref.getChartHeight()%>');
 var _chartWidth=eval('<%=pref.getChartWidth()%>');
 var _numberOfCharacters=eval('<%=pref.getNumberOfCharacters()%>');
 var _chartHeaderTitle='<%=ESAPI.encoder().encodeForJavaScript(pref.getHeader())%>';
 var _chartFooterTitle='<%=ESAPI.encoder().encodeForJavaScript(pref.getFooter())%>';
 var _chartFontSize=eval('<%=pref.getFontSize()%>');
 var _swapXYAxis=eval('<%=pref.isSwapXY()%>');

 var _showLabels=true;
 var _zoom=true;
 var _group='';
 var _xAxisLabelsTrimmedToSize;

 var USER_NUMBER_FORMAT= "<%=LocaleUtil.getNumberFormat(request)%>";
 var NUMBER_FORMAT1="#,###.##";
 var NUMBER_FORMAT2="#.###,##";	
 var NUMBER_FORMAT3="# ###,##";
 var NUMBER_FORMAT4="# ###.##";
 
// #,###.##
 var D3_LOCALE_NUMBER_FORMAT1 = d3.locale({
    "decimal": ".",
    "thousands": ",",
    "grouping": [3],
    "currency": ["USD", ""],
    "dateTime": "%a %b %e %X %Y",
    "date": "%d-%m-%Y",
    "time": "%H:%M:%S",
    "periods": ["AM", "PM"],
    "days": ["Zondag", "Maandag", "Dinsdag", "Woensdag", "Donderdag", "Vrijdag", "Zaterdag"],
    "shortDays": ["Zo", "Ma", "Di", "Wo", "Do", "Vr", "Za"],
    "months": ["Januari", "Februari", "Maart", "April", "Mei", "Juni", "Juli", "Augustus", "September", "Oktober", "November", "December"],
    "shortMonths": ["Jan", "Feb", "Mar", "Apr", "Mei", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dec"]
});

// #.###,##
var D3_LOCALE_NUMBER_FORMAT2 = d3.locale({
    "decimal": ",",
    "thousands": ".",
    "grouping": [3],
    "currency": ["USD", ""],
    "dateTime": "%a %b %e %X %Y",
    "date": "%d-%m-%Y",
    "time": "%H:%M:%S",
    "periods": ["AM", "PM"],
    "days": ["Zondag", "Maandag", "Dinsdag", "Woensdag", "Donderdag", "Vrijdag", "Zaterdag"],
    "shortDays": ["Zo", "Ma", "Di", "Wo", "Do", "Vr", "Za"],
    "months": ["Januari", "Februari", "Maart", "April", "Mei", "Juni", "Juli", "Augustus", "September", "Oktober", "November", "December"],
    "shortMonths": ["Jan", "Feb", "Mar", "Apr", "Mei", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dec"]
});

// # ###,##
var D3_LOCALE_NUMBER_FORMAT3 = d3.locale({
    "decimal": ",",
    "thousands": " ",
    "grouping": [3],
    "currency": ["USD", ""],
    "dateTime": "%a %b %e %X %Y",
    "date": "%d-%m-%Y",
    "time": "%H:%M:%S",
    "periods": ["AM", "PM"],
    "days": ["Zondag", "Maandag", "Dinsdag", "Woensdag", "Donderdag", "Vrijdag", "Zaterdag"],
    "shortDays": ["Zo", "Ma", "Di", "Wo", "Do", "Vr", "Za"],
    "months": ["Januari", "Februari", "Maart", "April", "Mei", "Juni", "Juli", "Augustus", "September", "Oktober", "November", "December"],
    "shortMonths": ["Jan", "Feb", "Mar", "Apr", "Mei", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dec"]
});

// # ###.##
var D3_LOCALE_NUMBER_FORMAT4 = d3.locale({
    "decimal": ".",
    "thousands": " ",
    "grouping": [3],
    "currency": ["USD", ""],
    "dateTime": "%a %b %e %X %Y",
    "date": "%d-%m-%Y",
    "time": "%H:%M:%S",
    "periods": ["AM", "PM"],
    "days": ["Zondag", "Maandag", "Dinsdag", "Woensdag", "Donderdag", "Vrijdag", "Zaterdag"],
    "shortDays": ["Zo", "Ma", "Di", "Wo", "Do", "Vr", "Za"],
    "months": ["Januari", "Februari", "Maart", "April", "Mei", "Juni", "Juli", "Augustus", "September", "Oktober", "November", "December"],
    "shortMonths": ["Jan", "Feb", "Mar", "Apr", "Mei", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dec"]
});

 var defaultNumberFormat=NUMBER_FORMAT1;

 // Fixed number format "f" because we dont want to show any precision(decimal) numbers
 // the , (comma) indicates SHOW thousands separator.
 //( NOTE:This doesn't mean that comma(,) is the thousand separartor.)
 var numberStyle_Fixed=",f";
 
 if(USER_NUMBER_FORMAT==NUMBER_FORMAT1){	 
	defaultNumberFormat=D3_LOCALE_NUMBER_FORMAT1.numberFormat(numberStyle_Fixed); 
 } else if(USER_NUMBER_FORMAT==NUMBER_FORMAT2){	
	defaultNumberFormat=D3_LOCALE_NUMBER_FORMAT2.numberFormat(numberStyle_Fixed); 
 } else if(USER_NUMBER_FORMAT==NUMBER_FORMAT3){	
	defaultNumberFormat=D3_LOCALE_NUMBER_FORMAT3.numberFormat(numberStyle_Fixed); 	
 } else if(USER_NUMBER_FORMAT==NUMBER_FORMAT4){	 
	defaultNumberFormat=D3_LOCALE_NUMBER_FORMAT4.numberFormat(numberStyle_Fixed); 
  }

  
  var colNames=''
	<%for (String name : chartDataSource.getColumnNames()){%>
		colNames=colNames+'"<%=name%>",';	
	<%}%>
	colNames=colNames.substring(0,(colNames.length-1));
	   
  var _xaxis="[\"x\","+colNames+"]";
  var _xaxisTrimmed = " ";	

  //var xAxisLabels = JSON.parse(JSON.stringify(<%=xAxisLabels%>));
  //xAxisLabels=colNames;  
  _xAxisLabelsTrimmedToSize=colNames;
  
  var yAxisArray = eval(<%=rowNames%>); 
  var nodeIdList=[<%=srtNodeIdList%>];
  var chart;
  var infinityI18N="<bean:message key='ui.label.chart.infinity' />" ; 
  var infinityPlaceholder="'i'";
  
  var _chartDataLocal="["+_xaxisTrimmed+',<%=ChartUtil.printMap(chartDataSource.getData())%>]';	  
	  var xChartData = JSON.stringify(_chartDataLocal); 
	  _chartDataLocal=xChartData.replace(/Infinity/g, infinityPlaceholder);  
	  _chartDataLocal=JSON.parse(_chartDataLocal);  	
  
  function getChartData(){  	 
	  var cd ="["+_xaxisTrimmed+',<%=ChartUtil.printMap(chartDataSource.getData())%>]';	  
	  var xChartData = JSON.stringify(cd); 
	  cd=xChartData.replace(/Infinity/g, infinityPlaceholder);  
	  cd=JSON.parse(cd);  	 
	  return cd;  
  }

  // create global variables for charts with name as  measurenames 
 <% for(String measurename : measurestoDisplay){ %>
			var chartName_<%=measurename%> = null;
		<% } %>
	
 function createChart() {
	
	_selectedChartType=getChartType(_selectedChartTypeNumber);	
	document.getElementById("chartTitle").innerHTML=_chartHeaderTitle;
	document.getElementById("chartFooter").innerHTML=_chartFooterTitle;	
	c3_changeXaxisNumberOfCharacters(_numberOfCharacters,false);
	
	
	if(_selectedChartType=='pie'||_selectedChartType=='donut'||_selectedChartType=='gauge')	{
	    if(_c3Chart != null){
			$("#chart").hide();
			$("#pieChart").show();
		}
		<%
		for(String measurename : measurestoDisplay){ %>
			 chartName_<%=measurename%> = drawChart('#<%=measurename%>',<%=measurename%>,_selectedChartType,'<%=measurename%>');
		<% } %>
	}else{
		$("#chart").show();
		$("#pieChart").hide();
		     	
	_c3Chart = c3.generate({
	   size: {
			height: _chartHeight,
			width: _chartWidth
		},
	   data: { 				
				x : "x",
		        columns: eval(_chartDataLocal),
				type: _selectedChartType,
				groups: eval(_group),
				labels: {
					format: function (x) {
											if(_showPoint){
												if(x!= null){
													return formatAbbreviation(x);
												} else {
													return infinityI18N;
												}
											}																		
										}
				},
				axes: {
					<%=axisStr%>
				},
				onclick: function (d, element) {								    
									reRender(nodeIdList[d.x]);								
				}//onclick,
				
			},
	   grid: {
				x: {show: _showXgrid},
				y: {show: _showYgrid}
			},
	   axis: {	
				x: {
					type: 'categories',
					categories: _xAxisLabelsTrimmedToSize,
					tick: {
							rotate: _xAxisLabelRotationAngle,
							multiline: false
					},
					label: {
							text : _xAxisLabel,
							position: _xAxisTitlePosition
							}
				},
				y: {
					//max: _yAxisMax,
					//min: _yAxisMin,
					padding: {bottom:0},
					label:{
							text : _yAxisLabel,
							position: _yAxisTitlePosition
							},
					tick:{
							format: function (x) {																		
												if(x!=infinityPlaceholder){
													return formatAbbreviation(x);
												}else {
													return infinityI18N;
												}							
									}
						}
				},
				y2: {
					show:_showMultipleYAxis,
					tick:{
							format: function (x) {																		
												if(x!=infinityPlaceholder){
													return formatAbbreviation(x);
												}else {
													return infinityI18N;
												}							
									}
						}
				},
				rotated:_swapXYAxis
		},		
		legend: {
			show: _showLegendFlag,
			position: _showLegendPosition
		},		
		point: {
			show: _showPoint
		},		
		tooltip: {
			show: _showTooltip,
			grouped: _groupTooltip,	
			format: {
					value: function (value, ratio, id) {					
										if(value!= null){
												return defaultNumberFormat(value);
										} else {
												return infinityI18N;
										}										
							}					
				}
    	},
		zoom: {
				enabled: _zoom
			}
	});	
	}// not pie or donut 
	chart = _c3Chart;	
	// call this after chart is rendered.
	c3_changeFontSize(_chartFontSize);
}

	
function getChartType(chartTypePrefNumber){	
	
	var charts=[];
	<% for (ChartType chartType : charts ){ %>
	charts[<%=chartType.getIntValue()%>]= '<%=chartType.name()%>';		
	<%
	}
	%>	
	var chart_type= charts[chartTypePrefNumber];	
	if(!chart_type){
		chart_type='bar';		
	}else{
		if(chart_type=='stacked_bar'){
				chart_type='bar';
				_yAxisMax=eval('<%=maxStaggerValue%>');					
				//  get the names as array;					
				_group = new Array(1);
				_group[0]=yAxisArray;				
				_showMultipleYAxis=false;					
		} else {
			_group='';
			_yAxisMax=eval('<%=pref.getyScaleMaxValue()%>');
			_showMultipleYAxis= <%=showMultipleYAxis%>;
		}		
		if (chart_type=='area_spline'){
			chart_type='area-spline';
		} else if (chart_type=='area_step'){
			chart_type='area-step';
		}
	}
	return chart_type;
}//getChartType

function c3_changeChartType(selectedChartOption) {	
	_selectedChartTypeNumber=selectedChartOption;	
	createChart();
}

function c3_changeXAxisLabelRoationAngle(xAxisLabelRoationAngle) {	
   _xAxisLabelRotationAngle=xAxisLabelRoationAngle; 
   createChart();
}

function c3_changeYAxisRange(yAxisMax,yAxisMin){
	_yAxisMax=yAxisMax;
	_yAxisMin=yAxisMin;	
	createChart();
}

function c3_showLegend( showLegendFlag,legendPoistion){
	_showLegendFlag = showLegendFlag
	var div_showLegendPosition = legendPoistion
	if(_showLegendFlag) {		
		if(_c3Chart){
			_c3Chart.legend.show();
		} 
		<% for(String measurename : measurestoDisplay){ %>
		if(chartName_<%=measurename%>){
			chartName_<%=measurename%>.legend.show();
		}
		<% } %>
		
	} else{		
		
		if(_c3Chart){
			_c3Chart.legend.hide();
		} 
		<% for(String measurename : measurestoDisplay){ %>
		if(chartName_<%=measurename%>){
			chartName_<%=measurename%>.legend.hide();
		}
		<% } %>
	} //_showLegendFlag
	c3_changeLegendPosition(legendPoistion)		
}

function c3_changeLegendPosition(legendPoistion){	
	_showLegendPosition=legendPoistion;		
	createChart();
}

function c3_showXGrid( flagShowXGrid){	
	_showXgrid=flagShowXGrid;
	createChart();
}

function c3_showYGrid(flagShowYGrid){	
	_showYgrid=flagShowYGrid;
	createChart();
}

function c3_swapXY(swap) {
	_swapXYAxis=swap;	
	createChart();
}

function c3_showPoints(flagShowPoints) {
	_showPoint=flagShowPoints;
	createChart();
}

function c3_showTooltips(showTooltip) {	
	_showTooltip=showTooltip;	
	createChart();
}

function c3_groupTooltips(groupTooltip) {	
	_groupTooltip=groupTooltip;	
	createChart();
}

function c3_applyChartTitles(xAxisLabel,yAxisLabel,chartHeaderTitle,chartFooterTitle){
	_xAxisLabel=xAxisLabel;
	_yAxisLabel=yAxisLabel;
	_chartHeaderTitle=chartHeaderTitle;
	_chartFooterTitle=chartFooterTitle;	
	createChart();	
}

function c3_changeXAxisTitlePosition(xAxisTitlePosition){
	_xAxisTitlePosition=xAxisTitlePosition;	
	createChart();
}

function c3_changeYAxisTitlePosition(yAxisTitlePosition){
	_yAxisTitlePosition=yAxisTitlePosition;	
	createChart();  
}

function c3_changeFontSize(fontSize){
	_chartFontSize=fontSize
	var elements = document.getElementsByTagName("svg");
	for(i = 0;i < elements.length; i++)
	{	
	    elements[i].style.fontSize = _chartFontSize + "px";
	}
	    jQuery(".c3-legend-item text").css("font-size", _chartFontSize+"px");
		jQuery(".c3-tooltip td").css("font-size", _chartFontSize+"px");
		jQuery(".c3-tooltip th").css("font-size", _chartFontSize+"px");
		jQuery(".c3-chart-arc text").css("font-size", _chartFontSize+"px");	
		jQuery("#chartTitle").css("font-size", _chartFontSize+"px");
		jQuery("#chartFooter").css("font-size", _chartFontSize+"px");		
		jQuery(".c3-title text").css("font-size", _chartFontSize+"px");	
	
}

function c3_changeXaxisNumberOfCharacters(numberOfCharacters,refreshChart){
		_numberOfCharacters=numberOfCharacters;		
		var xaxisArray=eval(_xaxis);
		_xaxisTrimmed="[";
			for (var i = 0; i < xaxisArray.length; i++) {		
				var x = xaxisArray[i];
				var y=null;
				if(x.length>_numberOfCharacters){
					 y = x.substring(0,_numberOfCharacters)+'...';
				}else{
					y=x;
				}	
				_xaxisTrimmed=_xaxisTrimmed+"\""+y+"\",";			
			}	
		_xaxisTrimmed=_xaxisTrimmed.substring(0,(_xaxisTrimmed.length-1));
		_xaxisTrimmed=_xaxisTrimmed+"]";
		_chartDataLocal=getChartData();		
		if(refreshChart){
			createChart();  
		}
}

var formatNumber = d3.format("f");
var formatBigNumber = d3.format("0.1f");
formatQuadrillion = function(x) { return formatBigNumber(x / 1e15) + "Q"; },
formatTrillion = function(x) { return formatBigNumber(x / 1e12) + "T"; },
formatBillion = function(x) { return formatBigNumber(x / 1e9) + "B"; },
formatMillion = function(x) { return formatBigNumber(x / 1e6) + "M"; },
formatThousand = function(x) { return formatBigNumber(x / 1e3) + "K"; };
formatOther = function(x) { return formatNumber(x); };

function formatAbbreviation(x) {
var v = Math.abs(x);
var retValue = (
	v >= .9995e15 ? formatQuadrillion
  :	v >= .9995e12 ? formatTrillion
  :	v >= .9995e9 ? formatBillion
  : v >= .9995e6 ? formatMillion
  : v >= .9995e3 ? formatThousand
  : formatOther)(x); 
return retValue ;
}
<!-- data for pie/donut chart -->
<%=chartDataSourcePieData%>

var _chartHeightPie=_chartHeight;
var _chartWidthPie=_chartWidth;

function formatValue(value,ratio,id) {
	//console.log(" value :"+value +" formatAbbreviation :"+formatAbbreviation(value));
	if(_showPoint){
				if(value!= null){					
					return formatAbbreviation(value) +" ("+ d3.format('%')(ratio)+")" ;
				} else {
					return infinityI18N;
				}
			}
	}
			
function drawChart(divName, chartData,chartType,chartTitle){
 
	    var myChart = c3.generate({
			size: {
					height: _chartHeightPie,
					width: _chartWidthPie
			},
			title: {
				text: chartTitle
			},
			bindto: divName,
			data: {
				columns:chartData,    
				type : chartType,			
				onclick: function (d, element) {								    						
							reRender(nodeIdList[d.index]);								
					}//onclick,
			},
			legend: {
				show: _showLegendFlag,
				position: _showLegendPosition
			},			
			pie: {
				        label: {
				            format: function (value, ratio, id) {			                
					            	return formatValue(value,ratio,id)
				            }
				        }
			},
			donut: {
						label: {
				            format: function (value, ratio, id) {			                
				            	return formatValue(value,ratio,id)
				            }
				        }
			},
			gauge: {
						label: {
				            format: function (value, ratio, id) {			                
				            	return formatValue(value,ratio,id)
				            }
				        }
			},
			tooltip: {
				show: _showTooltip,
				grouped: _groupTooltip,	
				format: {
						value: function (value, ratio, id) {					
											if(value!= null){	
													if(_selectedChartType=='pie'||_selectedChartType=='donut'||_selectedChartType=='gauge'){
	    												return defaultNumberFormat(value) +" ("+ d3.format('%')(ratio)+")" ;
													  }else{
														  return defaultNumberFormat(value);	  
													  }
													
											} else {
													return infinityI18N;
											}										
								}					
					}
	    	},
	  });
	  return myChart;
	}


</script>


	<body onload="createChart()">
		<div class='container' >
			<b><div  align="center" id="chartTitle" class="chartHeader"></div></b>			
			<div id='chart' align="center"></div>
			<div id="pieChart" >
				<hr>
				<%								
				for(String measurename : measurestoDisplay){ %>			
				<div id="<%=measurename%>"></div>
				<hr>
				<p>
				<% } %>
			</div>
			<p>
			<b><div  align="center" id="chartFooter" class="chartFooter"></div></b>
		</div>
	</body>
</html>