<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@page import="com.emptoris.viewer.bookmark.service.BookmarkServiceFactory"%>
<%@page import="com.zeborg.cubem.model.EMBookmarkType"%>
<%@page import="com.zeborg.cubem.model.EMBookmarkStatus"%>
<%@page import="java.util.Date"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@page import="com.zeborg.expensemap.model3.ExpensemapACLUtil"%>
<%@page import="com.zeborg.cubem.model.EMBookmark"%>
<%@page import="com.emptoris.viewer.feedback.FeedbackConstants"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>
<%@page import="com.zeborg.expensemap.view.CubeUtil, com.zeborg.acl.util.LocaleUtil"%>
<%@page import="com.zeborg.expensemap.view2.TableView, org.apache.struts.util.LabelValueBean"%>
<%@page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.zeborg.expensemap.util.HelpLocaleUtil, com.zeborg.cubem.model.DimensionMeta"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties,java.util.ArrayList"%>
<%@page import="com.emptoris.viewer.reports.logic.TopnReportsLogic"%>
<%@ page import="com.zeborg.cubem.model.DimensionColor"%>

<%@page import="com.emptoris.viewer.reports.ReportMeta"%>
<%@ page import="java.net.URLDecoder,java.util.Set, java.util.List"%>
<%@include file="includes/tlib.jspf" %>

<%    
	ZSession zs = ZSessionUtil.getFromSession(pageContext);

	EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, zs.getUser().getLocale());
	
	String helpURL = HelpUtil.getHelpUtil().getHelpURLString("tableGrid", zs.getUser().getLocale());
	List<String> allDimNames = new ArrayList<String>();
	List<Integer> allDimLevels = new ArrayList<Integer>();
	List<Integer> allDimNoOfRowsToDisplay = new ArrayList<Integer>();
	List<Boolean> allDimNameFrozen = new ArrayList<Boolean>();
	// Store max char for all dimensions
	List<Integer> dimMaxChar = new ArrayList<Integer>();
	for (TableView tv : zs.getContextView().getTableViews() ) {
		DimensionMeta dimMeta = tv.getDimension();
		allDimNames.add(dimMeta.getName());
	    allDimLevels.add(dimMeta.getLevels());
	    allDimNoOfRowsToDisplay.add(tv.getDimensionPreferences().getTopN());
		allDimNameFrozen.add(tv.getDimensionPreferences().isNameFrozen());	
		dimMaxChar.add(tv.getDimensionPreferences().getMaxNoOfCharacters());
	}
	
	String bkid = (String)request.getAttribute("bkid");
	String viewType = (String)request.getAttribute("viewSelected");
	String newAction = (String)request.getAttribute("newAction");
	
	viewType  = (viewType == null)  ? "" : viewType.trim();
	newAction = (newAction == null) ? "" : newAction.trim();
	bkid	  = (bkid==null)        ? "" : bkid.trim();
	boolean isBookmarkIdNotNull = false;
	if((bkid!=null) && (!bkid.trim().equals("null")) && (!bkid.trim().equals(""))){
		isBookmarkIdNotNull = true;
	}
	String bookmarkName = "";
	EMBookmark objBookmark = null;
    boolean isPublicBookMark = false;
	if(isBookmarkIdNotNull){
			objBookmark = BookmarkServiceFactory.getBookmarkService().getBookmarkById(bkid);
			List<String> publicBookMarkId = TopnReportsLogic.getInstance().getPublicTopReportBookMarkIds(zs.getDataSet().getId(), ReportMeta.TOP_N_BOOKMARK);
			isPublicBookMark = publicBookMarkId.contains(bkid);
		  //(Top report bookmark is visible to user having permission to view top report and that bookmark should be public) or (User have view permission on that particular bookmark )		  
		  if(objBookmark!=null && (( TopnReportsLogic.getInstance().canViewTopReports(zs) && isPublicBookMark ) || ExpensemapACLUtil.hasViewBookmarkPermission(zs.getUser(),objBookmark))){
			  bookmarkName = objBookmark.getName();
		  }
		  else{// else part is executed when bookmark is deleted, but bkId is in URL.
				 // if the required bkId is equals to last bkId , but bookmark is null or
				 // if bookmark is not null but user does not have permission to view bookmark 
				 // set last bookmark Id to null and viewType="null".					 
				isBookmarkIdNotNull=false;
				if(bkid.equalsIgnoreCase(zs.getLastBookmarkID()))
					zs.setLastBookmarkID(null);
					viewType="";
				}
	}

%>
<!DOCTYPE html>
<html>
<head>
<!--Renders document in IE8 mode in IE browser. This is required for IE9 not showing scrollbars for scrollable table divs. -->

<fmt:setBundle basename="ExpensemapMessagesBundle" />
<title><%=ExpenseMapAppProperties.getBrowserTitleSpend()%> - <%=bundle.getValue("ui.label.expensemap.title.viewdimensions")%></title>
<jsp:include page="/jsp/includes/commonHeaderIncludes.jsp" />
<link REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/macromap.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/export.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/dynamicView.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/css/fixedColumns.css" />
<style type="text/css" media="screen">

.divider {
	cursor: pointer;
	cursor: w-resize;
}

#pb.yui-overlay { 
	position: absolute;
	background-image: url(/expensemap/jsp/images/dimension-viewer-progressbar/75p_white.png);
	border: 1px solid black;
	padding: 5px;
	margin: 10px;
	font-size: 13px;
	font-weight: bold;
	color: black;
}

.columnHeadingStyle {
	border-left: 1px solid #c8cccf;
	background-image: url(/expensemap/jsp/images/dimension_table_header_bg.png);
	height: 20px;
}

.columnHeadingStyle td {
	padding-left: 5px;
	padding-right: 5px;
}

.rowheadingstyle {
	font-size: 11px !important;
}

.cellStyle {
	font-size: 11px !important;
}

.cellStyle a:link, .columnHeadingStyle a:link {
	color: black !important;
}

.cellStyle a:hover, .columnHeadingStyle a:hover {
	color: blue !important;
}

.cellStyle a:visited, .columnHeadingStyle a:visited {
	color: black !important;
}

.highlightedRow {
	background-image: url(/expensemap/jsp/images/highlighted_row_bg.png) !important;
}
#bkConfirmStyle{
	color: #0000FF;
    font-family: arial,helvetica,sans-serif;
    font-size: 12px;
    font-weight: bold;
    text-align: center;
	margin-top: 4%;
}
</style>

<script type="text/javascript" src="/expensemap/jsp/javascript/export_pdf.js" ></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js" ></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/header.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/preloadImg.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/stringbuffer.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/menu/menu-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/button/button-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="/expensemap/scripts/loadingPanel.js"></script>

<link rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/renderdashboard.css">

<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />

<link rel="stylesheet" type="text/css" href="/expensemap/jsp/css/yui-tooltip-override.css" />

</head>

<body class="yui-skin-sam" onunload="sendRequest('CancelCubeRollupIfRequired');"
	style="margin-left: 0px; margin-right: 0px;" link="#000000" vlink="#000000">
	<c:if test="${ showError }">
		<div id="sysAlertMessage" style="position:absolute; visibility:visible; z-index:10; left:580; top:0;">
        <table border="0" cellpadding="2" cellspacing="0" bgcolor="#FF0000" width="197">
        <tr>
        	<td width="191">
        	<table border="0" cellpadding="2" cellspacing="0" bgcolor="#FFFFFF">
        	<tr>
        		<td class="system-message"><fmt:message key='ui.label.Setting.a.Session.Filter.has.cleared.the.current.context.filters' /></td>
      			<td valign="top">
      				<a href="javascript:closeSysAlertMessage()">
      					<img src="/expensemap/jsp/images/close.gif" width="16" height="16" border="0" title="<fmt:message key='ui.message.Close.Alert.Window' />">
      				</a>
      			</td>
        	</tr>
        	</table>
        	</td>
 		</tr>
        </table>
		</div>
	</c:if>
	
<%
        String viewName = viewType.equals("")?"viewFrame.jsp":"viewFrame_"+viewType+".jsp";
		CubeUtil.buildExpMapMastHead(out,viewName,zs,true,null,zs.getUser().getLocale(),null);
        boolean displayBookmark = false;

		if(viewType.equals("") || viewType.equals("dimension")){
			request.setAttribute("viewType",viewType);
			request.setAttribute("displayBookmark",new Boolean(displayBookmark));
			%> 
		<%}%>
		
<%-- jQuery is included from CubeUtil.java --%>
<script type="text/javascript" src="/expensemap/jsp/javascript/fixedColumns.js"></script>

<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="helpUrl" value="<%=helpURL%>"/>
	<jsp:param name="dimensionViewPage" value="true"/>
</jsp:include>

<table width="100%" border="0" cellpadding="0" cellspacing="0">	
<tr>
	<td width="86%">
	<table>	
 		<tr>
			<td></td>
			<td colspan="3" style="font-family : Arial, Helvetica, sans-serif;font-size: 11px;font-wightT:normal; color: #030063">
			<div id="currentview">
        	<%
        	if(viewType.equalsIgnoreCase("bookmark")||viewType.equalsIgnoreCase("dimension")||displayBookmark){
            	if((isBookmarkIdNotNull)&&(EMBookmarkStatus.STATUS_VISIBLE.equals(objBookmark.getStatus())) ) {
              	%>
              		<b><fmt:message key='current'/>&nbsp;<fmt:message key='ui.label.bookmark'/>:&nbsp;</b>
                	<font color='#0000FF'>
					<b><c:out value='<%=bookmarkName%>' /></b>
					</font>
					&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;
					<a href="/expensemap/showBookmarkListPage.xhtm"><font color='#0000FF'><fmt:message key='ui.label.Show.All.Bookmarks' /></font></a>
			   <% 
               	} else if((isBookmarkIdNotNull)&&(EMBookmarkStatus.STATUS_HIDDEN.equals(objBookmark.getStatus()))&&(EMBookmarkType.CROSSTAB_DEFINED.equals(objBookmark.getType()))){ %>
               <b><fmt:message key='current'/>&nbsp;<fmt:message key='ui.label.crosstab'/>:&nbsp;</b>
               <font color='#0000FF'><b><c:out value='<%=bookmarkName%>' /></b></font>
               &nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;<a href="/expensemap/showTabulationPage.xhtm"><fmt:message key='ui.label.crosstabs.showall'/></a>
              <%
            	}
        	}%>
		</div> <!-- end currentDiv -->
	</td>
	<td></td><td></td><td></td>
	<td align="right" style="font-family:Arial; font-weight:bold; font-size:11px; color:#003163"></td>
</tr>
</table></td>

<td width="1%">&nbsp;&nbsp;&nbsp;</td>

</tr>
<tr>
	<td  colspan="4" align="center" width="100%">
		<div id="sysmsg" STYLE="font-family:Arial, Helvetica, sans-serif; font-size:10pt; font-weight:bold; color: red; background-color : transparent; align=right;"></div>
	</td>
</tr>
</table>
<!--  DIV FOR BREADCRUMBS starts here -->
<DIV id="breadCrumbContainer">
<TABLE WIDTH = "100%" BORDER = "0">
<TR><TD ALIGN = "left"><DIV ID = "breadCrumbDiv"></DIV></TD>
<TD ALIGN = "right"><DIV ID="olapLoadTable"></DIV></TD>
</TABLE>
</DIV>

<%
	String message="";
	if(zs.getFeedbackMessage()!=null){
		message = (String)zs.getFeedbackMessage();
%> 
<DIV id="systemMessageHeader">
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
<tr>
	<td width="30%"></td>
	<td  align="center" width="70%">
	 	<P ID="systemMessageHeaderText" STYLE='font-family:Arial, Helvetica, sans-serif; font-size:10pt; font-weight:bold; color: #0000FF; background-color : transparent; align:right'><%=message%></P>
	</td>
</TR>
</TABLE>
</DIV>
<%	
		if(newAction != null){
			if(newAction.equalsIgnoreCase("ys")){
				zs.setFeedbackMessage(null);
			}
		}
	}
%>
<FORM ID = "primaryForm">
<jsp:include page="/jsp/includes/commonExportUI.jsp"/>

<div id="pb" style="visibility:hidden">
	<div class="hd" align="center" style="font-family: arial,helvetica,clean,sans-serif; font-size: 11px; color: darkblue;">
	<fmt:message key="ui.label.Processing.request"/>
	<span id="progressLoadPercent"></span>
	</div>
	<div class="bd" align="center"><img src="/expensemap/jsp/images/dimension-viewer-progressbar/rel_interstitial_loading_resized.gif" /></div>
</div>
<div id="mainDropMenuDiv"></div>
<div id="mainContainerDiv" style="height: 100%;">
<!--  DIV containing all dimension treenode divs -->
<div id="treeNodeDiv" style="overflow:hidden; border: 3px"></div>
<div id="hourGlassPane" style="position: absolute; left: 0px; top: 0px; width: 100%; height: 100%; background: #FFFFFF; visibility: hidden;"></div>
<div id="crossTabDiv" style="position: absolute; left:${mainViewLeftOffset}%; width:${mainViewPercent}%; height:100%; background: #FFFFFF; display: none;">
	<iframe id="crossTabFrame" height="100%" width="100%" frameborder="0" src="/expensemap/jsp/blank.html"></iframe>
</div>

<div id="feedbackDiv" style="position: absolute; left: ${mainViewLeftOffset}%; width: ${mainViewPercent}%; height:100%; background: FFFFFF; display: none;">
	<iframe id="feedbackFrame" height="100%" width="100%" frameborder="0" src="/expensemap/jsp/blank.html"></iframe>
</div>
</div> <!-- end of mainContainerDiv -->

<div class='yui-skin-sam'><div id='bkConfirm'></div></div>

<input type="hidden" name="hiddenCapArea" id="hiddenCapArea"  value="<%=zs.getResizeCapArea()%>">
<input type="hidden" name="hiddenDimId" id="hiddenDimId" />
<input type="hidden" name="hiddenType" id="hiddenType" />
<input type="hidden" name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>' />
<%for(int i=0;i<allDimNames.size();i++) {
	String dimName = allDimNames.get(i);	
	dimName = dimName.toUpperCase() + "_HIDDEN";
%>
<input type="hidden" id="<%=dimName%>" name="<%=dimName%>" value="<c:out value='${requestScope.dimName}'/>">
<%}%>

<input type="hidden" name="numberFormat" value="" />
</FORM> 
<script type="text/javascript">

// Number of fixed columns for data grid tables, first column contains checkbox and the next one typically contains FULL_NM
var NO_OF_FIXED_COLUMNS = 2;
var EVEN_ROW_BG = 'url(/expensemap/jsp/images/white_row_bg.png)';
var ODD_ROW_BG = 'url(/expensemap/jsp/images/alt_row_bg.png)';
var HIGHLIGHTED_ROW_BG = 'url(/expensemap/jsp/images/highlighted_row_bg.png)';

function openEditBookmark() {
	// calculating coordinates in display the new window in center of the user's browsers.
	var midOfthescreen=screen.width/7;  		// modified for larger window size needed based on updates for PR 42498
	var midbotOfthescreen=screen.height/7;  	// modified for larger window size needed based on updates for PR 42498
	var halfOfthescreen=screen.width/1.4;   	// modified for larger window size needed based on updates for PR 42498
	var halfbotOfthescreen=screen.height/1.5;  	// modified for larger window size needed based on updates for PR 42498
	window.open('/expensemap/manageDimensionDisplayOrder.shtm?bkId=<%=bkid%>','editWin','width='+halfOfthescreen+',height='+halfbotOfthescreen+',resizable,scrollbars,left='+midOfthescreen+',top='+midbotOfthescreen);
	return false;
}
</script>
<form id="viewTransactionForm">
<input type="hidden" name="includeConstraints" id="includeConstraints" value="false">
<input type="hidden" name="dimension" id="dimension" value="">
<input type="hidden" name="selectedNodeId" id="selectedNodeId" value="">
</form>
<FORM NAME="PrintForm" id="PrintForm" ACTION="/expensemap/jsp/printViewer.jsp" METHOD="post" TARGET="_blank">
        <INPUT TYPE="hidden" NAME="theAction" VALUE="printReport">
        <INPUT TYPE="hidden" NAME="printTitle" value="">
        <INPUT TYPE="hidden" NAME="dimension" value="">
        <input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</FORM>

<!-- breadcrumb code start -->
<SCRIPT LANGUAGE = "JavaScript">
var Dom = YAHOO.util.Dom,
	Event = YAHOO.util.Event;
var progressBar;
var disappeardelay=250;
var multikeepTextMap = {};
var multikeepTooltipMap = {};

function highlightRow(id) {
	document.getElementById(id).style.backgroundImage = HIGHLIGHTED_ROW_BG;
}

function unHighlightRow(id, img) {
	document.getElementById(id).style.backgroundImage = img;
}

function replaceText(s, t, u) {
  /*
  **  Replace a token in a string
  **    s  string to be processed
  **    t  token to be found and removed
  **    u  token to be inserted
  **  returns new String
  */
  //alert("s = "+s);alert("t = "+t);alert("u = "+u);
  i = s.indexOf(t);
  r = "";
  if (i == -1) return s;
  r += s.substring(0,i) + u;
  if ( i + t.length < s.length)
    r += replaceText(s.substring(i + t.length, s.length), t, u);
    
  return r;
}


function sendBreadCrumbRequest(argStr) {
	try {
		var url = "/expensemap/jsp/ajaxRequest.jsp";
		if ( argStr != null && argStr.length > 0 ) {
			url = url + "?" + argStr;
		}
		jQuery.ajax({
			url: url,
			type: "GET",
			success: breadCrumbResponseHandler,
			error: function(xhr, status, error) {
				alert('<%=bundle.getValue("ui.message.There.was.a.problem.retrieving.data.from.server")%> ' + xhr.statusText);
				return false;
			}
		});
		
	} catch(e) {
		 alert(e);
	}
}

function breadCrumbResponseHandler(response) {
	var data = eval(response);
	
	// If there is no data in the response, ignore this
	if (data == null) {
	   return;
	}
	if (data[0] == "Error") {
		var errorCode = data[1];
		if(errorCode == "session.timeout")
		{
		   var timeoutURL = data[3];
		   parent.location.href=timeoutURL;
		   return;
		}else{
			//handle error
			var htmlStrBuf = new StringBuffer();
			htmlStrBuf.append('<font size="2" face="Arial, Helvetica, sans-serif" color="red">')
			htmlStrBuf.append(data[2]);
			htmlStrBuf.append('</font>');
			document.getElementById("breadCrumbDiv").innerHTML =htmlStrBuf.toString();
		}
	} else if(data[0] == "RefreshBreadcrumbs" || data[0] == "RefreshDeltaUpdate") {
		var str = "requestMap = "+data[data.length - 2];
		eval(str);
		for(key in requestMap){
			multikeepTextMap[key] = requestMap[key];		   		
		}
		if ( data[0] == "RefreshBreadcrumbs" ) {
			// Reset existing breadcrumb elements PR: 41892
			tableRowMap = new Array();
			rowIdMap = new Array();
			rowIndex = 0;
		}
		if(data[0] == "RefreshDeltaUpdate") {
			hideSystemMessage();
		}
		var isBreadCrumbHidden = data[data.length - 1];
		if(isBreadCrumbHidden != 'true'){
			renderBreadCrumbs(data);
		}
		//adjust mainContainerDiv height and top, to avoid extra scollbar.	
		updateMainContainerDivHeight();	
	} else if( data[0]=="RemoveSingleFilterNodeRequest") {
		sendBreadCrumbRequest('RefreshBreadcrumbs');
		sendRequest('GetRootNodesRequest'); 
		hideCurrentView(data[2]);
		hideSystemMessage();
	} else if(data[0] == "ShowBreadCrumb") {
		var breadCrumbContainer = document.getElementById("breadCrumbContainer"); 
		if( breadCrumbContainer && breadCrumbContainer.style.visibility=='visible'){
			renderBreadCrumbs(data);
		} 
		document.getElementById("breadCrumbContainer").style.height = 'auto';
		updateMainContainerDivHeight();
	} else if(data[0] == "HideBreadCrumb" ) {
		updateMainContainerDivHeight();
	}
}

function removeFilter(arg){
	args=arg.split('~');
	var feedbackFrame = document.getElementById("feedbackFrame");
	if(feedbackFrame){
		if(feedbackFrame.visibility!='hidden'){
				if(feedbackFrame.contentWindow.document.forms[0]){
					if(feedbackFrame.contentWindow.document.forms[0].elements['previousDim']){
						dimStr=feedbackFrame.contentWindow.document.forms[0].elements['previousDim'].value;
						if(dimStr==args[0]){
							alert('You are in <%=ExpenseMapAppProperties.getAdditionalFeedbackLabelName()%> workflow.This Dimension cannot be removed from the Filters')
							return false
						}
				}
			}
		}
	}
	sendBreadCrumbRequest("RemoveSingleFilterNodeRequest," + args[0] + "," + args[1] + ",${param.bkid}");	
}

function hideSystemMessage(){
	if (document.getElementById("systemMessageHeader") != null) {		    	
		document.getElementById("systemMessageHeader").style.visibility = "hidden";
		document.getElementById("systemMessageHeader").innerHTML = "";
	}
}

function renderBreadCrumbs(data) {
	var newHeight = data[1];
	for (var i = 2; i < data.length - 2; i += 2) {
        addRow(data[i], data[i + 1]);
	}	
	renderBreadcrumbTable(newHeight);
}

var tableRowMap = new Array();
var rowIdMap = new Array();
var rowIndex = 0;

function addRow(dimId, rowHTML) {
    // if nothing there for this dim, add new row in maps and index
    if (tableRowMap[dimId] == null) {
        rowIdMap[rowIndex] = dimId;
        rowIndex++;
    }
    // Add/replace
    tableRowMap[dimId] = rowHTML;
}

//remove 'px' from height and width value
function trimPx(val){
	if(!val){
		return val;
	}
	var res = val.substring(0,val.indexOf('p'));
	return res;
}

function renderBreadcrumbTable(newHeight) {
	// destroy existing tooltips
	for (key in multikeepTooltipMap ) {
		multikeepTooltipMap[key].destroy();
	}
	multikeepTooltipMap = {};
   	for(key in multikeepTextMap){
   		Event.onAvailable("tt_" + key, function(dim) {
   			var text = replaceText(multikeepTextMap[dim],'|','<br>');
   			var tooltip = new YAHOO.widget.Tooltip("tt" + dim, { context : "tt_" + dim, text : text, width : '200px' });
   			multikeepTooltipMap[dim] = tooltip;   			
   		}, key);   		
   	}

    var htmlStrBuf = new StringBuffer();
    htmlStrBuf.append('<TABLE ID="breadCrumbTable" BORDER="0" CELLPADDING="0" CELLSPACING="0">');
    var intersectionStr = '';
	var breadCrumbDivElt = document.getElementById("breadCrumbDiv");
    for (var i = 0; i < rowIdMap.length; i++) {
        if (rowIdMap[i] == 'bcIntersectionTotals') {
        	intersectionStr = tableRowMap[rowIdMap[i]];
        } else {
        	htmlStrBuf.append( tableRowMap[rowIdMap[i]] );
        }
    }    
    htmlStrBuf.append( intersectionStr );
    htmlStrBuf.append('</TABLE>');
    breadCrumbDivElt.innerHTML = htmlStrBuf.toString();   
    

    //new height is set if this is a full refresh page; in this scenario avoid
    //resetting the height again. This is esp. critical if there is feedback message
    //to be displayed.	
	document.getElementById("mainContainerDiv").style.top = newHeight + "px";	
}

var pendingRequest = false;
var pendingRequestTime = 0;
var isIntegrationEnv=<%=(zs.getExpensemapFrame().equals("_top")?"false":"true")%>;

function fnHideBreadCrumb(){
	var breadCrumbContainer = document.getElementById("breadCrumbContainer");
	breadCrumbDivElt = document.getElementById("breadCrumbDiv");
	var olapLoadTable = document.getElementById("olapLoadTable");
	if(breadCrumbContainer){
		breadCrumbContainer.style.visibility='hidden';
		var bcMenu = document.getElementById("toggleBreadcrumb");
		var bcMenuImg = YAHOO.util.Dom.getFirstChild(YAHOO.util.Dom.getFirstChild(bcMenu));
		bcMenuImg.src = '/expensemap/jsp/cap_area/btn_resize_enabled.gif';	
		
		bcMenu.title = "<%=bundle.getValue("ui.label.showbreadcrumb")%>";
		hideSystemMessage();
		sendBreadCrumbRequest('hideBreadCrumb,true');
		breadCrumbDivElt.innerHTML = '';
		olapLoadTable.innerHTML = '';
	}
	if(document.getElementById("systemMessageHeader")){
		str=document.getElementById("systemMessageHeader").innerText;
		document.getElementById("systemMessageHeader").innerText = "";
		document.getElementById("sysmsg").left=(screen.width/2);
		document.getElementById("sysmsg").innerText=str;
	}
}

function toggleBreadCrumb(){ 
	var isCapHidden = eval(document.getElementById("hiddenCapArea").value);	
	var totalHt = document.body.clientHeight;
	totalHt = parseInt(totalHt);
	var mainContainerDiv = document.getElementById("mainContainerDiv");
	var mainConTop = parseInt(trimPx(mainContainerDiv.style.top));
	var breadCrumbContainer = document.getElementById("breadCrumbContainer");
	breadCrumbDivElt = document.getElementById("breadCrumbDiv");

	var bcMenu = document.getElementById("toggleBreadcrumb");
	
	var olapLoadTable = document.getElementById("olapLoadTable");
	document.getElementById("sysmsg").innerText='';
	if (breadCrumbContainer.style.visibility=='hidden'){
		breadCrumbContainer.style.visibility='visible';
		var bcMenu = document.getElementById("toggleBreadcrumb");
		var bcMenuImg = YAHOO.util.Dom.getFirstChild(YAHOO.util.Dom.getFirstChild(bcMenu));
		bcMenuImg.src = '/expensemap/jsp/cap_area/btn_resize_up.gif';
		bcMenu.title = "<%=bundle.getValue("ui.label.hidebreadcrumb")%>";
		hideSystemMessage();
		sendBreadCrumbRequest('hideBreadCrumb,false');		
	 } else { 	
	 	breadCrumbContainer.style.visibility='hidden';
	 	hideSystemMessage();
	 	breadCrumbContainer.style.height = "0px";
	 	sendBreadCrumbRequest('hideBreadCrumb,true');
	 	var bcMenu = document.getElementById("toggleBreadcrumb");
		var bcMenuImg = YAHOO.util.Dom.getFirstChild(YAHOO.util.Dom.getFirstChild(bcMenu));
		bcMenuImg.src = '/expensemap/jsp/cap_area/btn_resize_enabled.gif';	
	 	
		bcMenu.title = "<%=bundle.getValue("ui.label.showbreadcrumb")%>";
		breadCrumbDivElt.innerHTML = '';
		olapLoadTable.innerHTML = '';
		
		//adjust mainContainerDiv height and top, to avoid extra scollbar.	
		var ht = mainConTop - 60;
		mainContainerDiv.style.top = ht + "px";
		ht = totalHt - 125;
		if(isCapHidden){
			//if header is hidden increase height by 75px.
			ht = ht + 75;
		}
		mainContainerDiv.style.height = ht + "px";
	 }  
}


function openCustomizeView() {
	// calculating coordinates in display the new window in center of the user's browsers.
	var midOfthescreen=screen.width/7;  		// modified for larger window size needed based on updates for PR 42498
	var midbotOfthescreen=screen.height/7;  	// modified for larger window size needed based on updates for PR 42498
	var halfOfthescreen=screen.width/1.4;   	// modified for larger window size needed based on updates for PR 42498
	var halfbotOfthescreen=screen.height/1.5;  	// modified for larger window size needed based on updates for PR 42498
	window.open('/expensemap/manageDimensionDisplayOrder.shtm?cubeId=${cubeId}','changePrefWin','width='+halfOfthescreen+',height='+halfbotOfthescreen+',resizable,scrollbars,left='+midOfthescreen+',top='+midbotOfthescreen);
	return false;
}

function createUpdateBookMark(){	
	var url = '/expensemap/show.shtm';
	  var ht = 475;
      var wt = 610;
      var left = (screen.width/2)-(wt/2);
      var top = (screen.height/2)-(ht/2);       
      window.open(url, 'SA_UpdateBookMark', "resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
}

function createPGMRequest(){	
	var url = '/expensemap/PGMRequestForm.shtm';
	 var ht = 370;
     var wt = 645;
     var left = (screen.width/2)-(wt/2);
     var top = (screen.height/2)-(ht/2);       
     window.open(url, 'PGM Request Form', "resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
}

function MT_localUndoLastChange() {
	MT_showUndoLastChange('<%=session.getId()%>');
}


function hideCurrentView(data) {
	if (data == 1) {
		document.getElementById('currentview').innerHTML='';
	}
}

/* breadcrumb javascript code ends */

//this will have key=dimId, value = isPaging available.
var dimPageMap = {};

function trim(s) {
    return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}


var clearSess = "";


function receiveResponse(response) {
	pendingRequest = false;	
	hideHourglass();	
		
	// try to parse the response into a JS array. We may get outofmemory error when the
	// array contains more than 65535 elements. In that case, we trap the error and show
	// an error message.
	var data = null;
	try {
		data = eval(response);
	} catch (e) {
		if ( e.message == 'Out of memory' ) {
			alert('<%=bundle.getValue("ui.message.js.out.of.memory")%>');
		} else {
			alert('<%=bundle.getValue("ui.message.There.was.a.problem.retrieving.data.from.server")%>' + e.message);
		}
		return;
	}
	// If there is no data in the response, ignore this
	if (data == null) {
		return;
	}
	
	if (data[0] == "Error"){
		var errorCode = data[1];
		if(errorCode == "session.timeout") {
			var timeoutURL = data[3];
			//for intg environment the location should be expensemap frame
			parent.location.href=timeoutURL;
			return;
		}else{
			renderCube(data);
		}
	} else if(data[0] == "GetRootNodesRequest") {
		// set the global flag
		cubeRollupInProgress = true;	
		renderCube(data);
		if(clearSess=="true"){
    		sendRequest('clearSession');	
   		}
		if (typeof allNameArray != 'undefined') {
			for(i in allNameArray){
				setCheckBoxStatus(allNameArray[i]);
			}
		}
	} else if(data[0] == "FeedbackRequest") {			
		sendRequest('GetRootNodesRequest');
	} else if(data[0] == "ShowCrosstabForm") {			
		sendRequest('GetRootNodesRequest');				
	} else if(data[0] == "EditCrosstabForm") {			
		sendRequest('GetRootNodesRequest');				
	} else if (data[0] == "AddSingleFilterNodeRequest") {			
		refreshBreadCrumb("single");
		hideCurrentView(data[1]);
		clearSess="true";
		sendRequest('GetRootNodesRequest');
	} else if (data[0] == "SwapDimensionRequest") {
		sendRequest('GetRootNodesRequest');
		hideCurrentView(data[1]);
	} else if (data[0] == "AddSingleKeepFilterForTotalSpendRequest"){
		// PR 41892 : When a single keep is applied on Total Spend link,
		// we need to reset the breadcrumb as other context filters are being removed
		refreshBreadCrumb("reset");
		hideCurrentView(data[1]);
		sendRequest('GetRootNodesRequest');
	} else if(data[0]=="doPaging"){
		hideProgressBar();
		removeChildrenNodes(data[1], data[2]);
		setXofY(data[4],data[1]);			
		var dimId = data[1];
		var selVal = document.getElementById(dimId.toUpperCase()+'_HIDDEN').value;    			
		if(selVal == 'selectAcrossPage'){
			document.getElementById('checkbox_'+dimId + "_0").checked = true;
		}else{
			document.getElementById('checkbox_'+dimId + "_0").checked = false;
		}
		renderExpandedNode(data);	
		setCheckBoxStatus(dimId);	
	}else if (data[0] == "AddMultipleFilterNodesRequest") {	
		var dimInFilter = data[1];
		if(dimInFilter.length == 0){
			alert('<%=bundle.getValue("ui.label.Please.select.atleast.one.checkbox")%>');
			return false;
		}					
		refreshBreadCrumb("multiple",data[1]);
		hideCurrentView(data[2]);
		// IMPORTANT: THESE MUST BE RESET AFTER THE CALL TO refreshBreadCrumb, 
		// OTHERWISE IT DOESN'T KNOW WHICH DIMS WERE SELECTED	
		clearSess="true";			
		sendRequest('GetRootNodesRequest'); 						
	} else if ( data[0] == "ScrollNodeRequest" ) {
		hideProgressBar();
		renderExpandedNode(data);			
	} else if (data[0] == "ExpandNodeRequest") {
		hideProgressBar();
		renderExpandedNode(data);
	} else if (data[0] == "ExpandToNextLevelRequest") {
		hideProgressBar();
		var dimId = data[1];
		var nodeId = data[2];
		removeChildrenNodes(dimId, nodeId);
		renderExpandedNode(data);
		if(document.getElementById('checkbox_'+dimId + "_0").checked){
			callMeBeforeRegisterNodeFilter(false, dimId, 0, -1,document.getElementById('checkbox_'+dimId + "_0"),true)
		}			
	} else if (data[0] == "CollapseToTopofDrillRequest") {
		hideProgressBar();
		removeChildrenNodes(data[1], data[2]);
		renderExpandedNode(data);
		checkboxobj=document.getElementById('checkbox_'+data[1]+'_0');
		if(isRootSelected){
			checkboxobj.checked=true;
			callMeBeforeRegisterNodeFilter(false, data[1], 0,-1,checkboxobj,true)
			isRootSelected=false;
		}
	}else if (data[0] == "SortAsPerMeasure") {
		removeChildrenNodes(data[1], data[2]);
		renderDimNode(data);	
	}else if (data[0] == "ShowAttributeValuesRequest") {
		displayAttributesValues(data);	
	}else if (data[0] == "MaximizeDimensionRequest") {
		processDimensionRollup(data);
		var dimId = data[3];
		document.getElementById("dim_" + dimId).style.height = dimIdToDimHeight[dimId]+"px"; // std size	
 		offsetPlayersOnMinMax(false,dimId);
 		setCheckBoxStatus(dimId);
	}
}

function sendRequest(argStr) {
	if (pendingRequest) {
		// Ignore this request if another request is pending within the request timeout time:
		if ((getTimeInSeconds() - pendingRequestTime) < requestTimeout) {
			alert('<%=bundle.getValue("ui.message.Another.request.is.pending")%>');
			return;
		}
	}
	if(argStr=='GetRootNodesRequest'){
		renderProgressBarDiv(0);
		if((location.href.indexOf("bkid")>0) && (location.href.indexOf("viewSelected=dimension")>0)){
				var bkid='<%=request.getParameter("bkid")%>';
				var param = 'false';
				if(bkid!='null' || bkid!='' || bkid!=null){
					param = 'true';
				}
				argStr = argStr + "," + param;
		}				
	}
	try {
		var url = "/expensemap/jsp/ajaxRequest.jsp?" + argStr;
		jQuery.ajax({
			url: url,
			type: "GET",
			success: receiveResponse,
			error: function(xhr, status, error) {
				alert('<%=bundle.getValue("ui.message.There.was.a.problem.retrieving.data.from.server")%> ' + 			xhr.statusText);
				hideProgressBar();
				return false;				
			}
		});
		pendingRequest = true;
		pendingRequestTime = getTimeInSeconds();
		// showHourglass();
		if (argStr.indexOf('GetRootNodesRequest') >= 0 && progressBarEnabled) {
			progressLoop(0);
		}
	} catch(e) {
		 alert(e);
	}
}

function getTimeInSeconds() {
	var now = new Date();
	return (now.getTime() / 1000); // Convert from Milliseconds to Seconds
}

function showHourglass() {
	document.body.style.cursor = 'wait';    
	var s = document.getElementById('hourGlassPane').style;
	s.cursor = 'wait';
	s.visibility = 'visible';
	s.opacity = 1;
    s.filter = 'alpha(opacity=.9)';	
}

// Returns the cursor to the default pointer
function hideHourglass(){
	document.body.style.cursor = 'default';
	var s = document.getElementById('hourGlassPane').style;
	s.visibility = 'hidden';
}

// Progress Bar Code
function hideProgressBar() {
	progressBar.hide();
	document.getElementById("progressLoadPercent").innerHTML = "";
	updateAllScrollableTableSizes();
}

function renderProgressBarDiv(percent) {
	if( progressBarWithPercenatageEnabled ) {
		progressBar.show();
		var textElm = document.getElementById("progressLoadPercent");
     	textElm.innerHTML = Math.round(percent * 100) + "%";
	 } else {
	 	//For PR # 41993
     	if ( progressBarEnabled ) {
     		progressBar.show();
		}
	}
}

function sendProgressRequest() {
	try {
		var url = "/expensemap/jsp/ajaxRequest.jsp?RollupStatus";
		jQuery.ajax({
			url: url,
			type: "GET",
			success: receiveProgResponse,
			error: function(xhr, status, error) {
				alert('<%=bundle.getValue("ui.message.There.was.a.problem.retrieving.data.from.server")%> ' + xhr.statusText);
				return false;				
			}
		});
		
	} catch(e) {
		 alert('<%=bundle.getValue("ui.message.Browser.does.not.support.AJAX.type.request")%>');
	}
}

function receiveProgResponse(response) {
	var data = eval(response);
	if (data == null) {
	   return;
	}
	
	if (data[0] == "Error") {
		renderCube(data);
	} else if (data[0] == "RollupStatus"){
		progressLoop(parseFloat(data[1]));
	}
}


function progressLoop(percent){
	if (percent >= 1) {
		if(pendingRequest){
    		setTimeout("sendProgressRequest()", 1000);
		}else{
			hideProgressBar();
        }
	}else if (percent == 0) {
		setTimeout("sendProgressRequest()", 3000);
	} else {				
		renderProgressBarDiv(percent);
		setTimeout("sendProgressRequest()", 3000);
	}
}
// End Progress Bar Code

function insertAfter(dimId, parent, node, referenceNode) {
	fixVirtualNodeIds(node.childNodes, dimId, false);

	updateTables = false;
	// Need to add rows to fixed and scrollable tables first because insertBefore consumes cells
	if (isNameFrozenForDimension(dimId)) {
		updateTables = true;
		// insert new rows to fixed and scrollable tables
		addRowstoFixedScrollableTables(dimId, referenceNode, node.childNodes);
		$(parent).parent().fixTableAlternateRowHighlighting();
	}
	
    parent.insertBefore(node, referenceNode.nextSibling);
	
	if (updateTables) {
		updateScrollableTableSize(dimId, false);
	}
}

function prependChild(parent, node) {
    parent.insertBefore(node, parent.firstChild);
}

function swapReport(dimId) {
	sendRequest('SwapDimensionRequest'+ "," + dimId + ",${param.bkid}" );
}

//to keep the selection of root level node before collaps top of the cube
isRootSelected=false;
function selectTheChildren(isLargeNode, dimId,nodeId, checkboxObj){
	nodeIdindex=('checkbox_'+dimId).length+1;
	var elementArray = document.forms[0].elements;
	var elementArrayLength = elementArray.length;
	var nodeIdStr = new StringBuffer();
	for(i=0;i<elementArrayLength;i++){
		if(elementArray[i].type=='checkbox' && elementArray[i].id.indexOf(dimId)>1 && elementArray[i].name.substr(7+dimId.length+1)==nodeId){
			elementArray[i].checked=true;
			chknodeId=elementArray[i].id.substr(nodeIdindex);
			checkbox=elementArray[i];
			nodeIdStr.append(chknodeId);
			nodeIdStr.append(':');
				// select the children of this element start
				for(k=0;k<elementArrayLength;k++){
					if(elementArray[k].type=='checkbox' && elementArray[k].id.indexOf(dimId)>1 && elementArray[k].name.substr(7+dimId.length+1)==chknodeId){
						elementArray[k].checked=true;
						chkboxnodeId=elementArray[k].id.substr(nodeIdindex);
						check_box=elementArray[k];
						nodeIdStr.append(chkboxnodeId);
						nodeIdStr.append(':');
					}
				}
		}
	}
	registerNodeFilter(isLargeNode, dimId, nodeIdStr.toString(), true);
}

function deselectAllChildren(dimId, nodeId,checkboxObj){
	nodeIdindex=('checkbox_'+dimId).length+1;
	var elementArray = document.forms[0].elements;
	var elementArrayLength = elementArray.length;
	if(!checkboxObj.checked){	
		var nodeIdStr = new StringBuffer();
		childfinder=nodeId;
		for(i=0;i<elementArrayLength;i++){
			var temp=elementArray[i].id.substr(9);
			temp=temp.substr(0,temp.lastIndexOf('_'))
			parentIdOfthis=elementArray[i].name.substr(elementArray[i].name.lastIndexOf('_')+1)
			if(elementArray[i].type=='checkbox' && temp==dimId){	
				if(parentIdOfthis==childfinder){
					// unregister only when its checked else do nothing
					if(elementArray[i].checked){
						elementArray[i].checked=false;
						//we have to take the each check box's node id by substring here
						chknodeId=elementArray[i].id.substr(nodeIdindex);
						Objcheckbox=elementArray[i];
						nodeIdStr.append(chknodeId);
						nodeIdStr.append(':');
					}
				}
			}
		}
		registerNodeFilter(false, dimId, nodeIdStr.toString(), false);
	}else{
		var nodeIdStr = new StringBuffer();
		childfinder=nodeId;
		for(i=0;i<elementArrayLength;i++){
			var temp=elementArray[i].id.substr(9);
			temp=temp.substr(0,temp.lastIndexOf('_'))
			parentIdOfthis=elementArray[i].name.substr(elementArray[i].name.lastIndexOf('_')+1)
			if(elementArray[i].type=='checkbox' && temp==dimId){	
				if(parentIdOfthis==childfinder){
					elementArray[i].checked=false;
					//we have to take the each check box's node id by substring here
					chknodeId=elementArray[i].id.substr(nodeIdindex);
					Objcheckbox=elementArray[i];
					nodeIdStr.append(chknodeId);
					nodeIdStr.append(':');
				}
			}
		}
		registerNodeFilter(false, dimId, nodeIdStr.toString(), false);
	}
}

var firstpass = true;
var allchildobjList= new Array();
var allobjList = new Array();
function callMeBeforeRegisterNodeFilter(isLargeNode, dimId, nodeId, parentNodeId,checkbox,rootnode){
	showHourglass();
	
	// replicate status of current checkbox across fixed and normal column tables
	checkboxId = $(checkbox).attr("id");
	replicatedCheckboxId = (checkboxId.search("_fixed$") == -1) ? checkboxId + "_fixed" : checkboxId.replace("_fixed", "");
	$("#" + replicatedCheckboxId).attr("checked", $(checkbox).attr("checked"));
	
	var nodeIdindex=('checkbox_'+dimId).length+1;
	if(parentNodeId!=-1){
		registerNodeFilter(false, dimId, nodeId, checkbox.checked);
	}
	if(rootnode){
		var nodeIdStr = new StringBuffer();
		var elementArray = document.forms[0].elements;
		var elementArrayLength = elementArray.length;
		if(checkbox.checked){
			//this section check all children
			for(i=0;i<elementArrayLength;i++){
				var childChkBox = elementArray[i];
				//this if check is important since there will be dim namely commodity and commodityrule
				var temp=childChkBox.id.substr(9);
				var fixedCheckbox = false;
				// in case of fixed column checkbox, we need to take substr twice to figure out which dimension it belongs,
				// because we are taking substr on the basis of last occurance of '_'
				if (temp.search("_fixed$") != -1) {
					temp=temp.substr(0,temp.lastIndexOf('_'));
					fixedCheckbox = true;
				}
				temp=temp.substr(0,temp.lastIndexOf('_'));
				if( childChkBox.type=='checkbox' && temp == dimId ) {
					childChkBox.checked=true;
					// fixedCheckbox - we do not need to append to nodeIdStr, it will be taken care by normal checkboxes
					if (fixedCheckbox) {
						continue;
					}
					//we have to take the each check box's node id by substring here
					chknodeId=childChkBox.id.substr(nodeIdindex);
					if ( childChkBox.name.indexOf('-1') == -1 ) {
						nodeIdStr.append(chknodeId);
						nodeIdStr.append(':');
					}
				}
			}
			registerNodeFilter(isLargeNode, dimId, nodeIdStr.toString(), true);
		}else{
			for(i=0;i<elementArrayLength;i++){
				var childChkBox = elementArray[i];
				//this if check is important since there will be dim namely commodity and commodityrule
				var temp=childChkBox.id.substr(9);
				var fixedCheckbox = false;
				if (temp.search("_fixed$") != -1) {
					temp=temp.substr(0,temp.lastIndexOf('_'));
					fixedCheckbox = true;
				}
				temp=temp.substr(0,temp.lastIndexOf('_'));
				if( childChkBox.type=='checkbox' && temp == dimId ) {
					childChkBox.checked=false;
					if (fixedCheckbox) {
						continue;
					}					
					//we have to take the each check box's node id by substring here
					chknodeId=childChkBox.id.substr(nodeIdindex);
					nodeIdStr.append(chknodeId);
					nodeIdStr.append(':');
				}
			}
			registerNodeFilter(isLargeNode, dimId, nodeIdStr.toString(), false);
		}
	} else {
		var nodeIdStr = new StringBuffer();
		getChildren(dimId,nodeId);
		var listLength = allobjList.length;
		if(document.getElementById(checkboxId).checked){			
			for(i=0;i<listLength;i++){
				allobjList[i].checked=true;
				chknodeId=allobjList[i].id.substr(nodeIdindex)
				nodeIdStr.append(chknodeId);
				nodeIdStr.append(':');
			}
			registerNodeFilter(false, dimId, nodeIdStr.toString(), true);
		}else{			
			for(i=0;i<listLength;i++){
				allobjList[i].checked=false;
				chknodeId=allobjList[i].id.substr(nodeIdindex)
				nodeIdStr.append(chknodeId);
				nodeIdStr.append(':');
			}
			registerNodeFilter(false, dimId, nodeIdStr.toString(),false);
			// by recursive mode we can find the children, for parent we just go thru this loop and unregister them
			parentid=parentNodeId;
			uncheckParentNodes(dimId, parentid);
		}
	}
	hideHourglass();
	allchildobjList= new Array();
	allobjList = new Array();
	firstpass = true;
}

/* Returns DimensionId from checkbox */
// TODO: use this function at applicable places
function getDimIdFromCheckbox(checkbox) {
	// example checkbox id: checkbox_DIMTIME_119907720_fixed
	dimId = checkbox.id.replace("_fixed", "");
	// strip "checkbox_" from id
	dimId = dimId.substr(9);
	return dimId.substr(0,dimId.lastIndexOf('_'));
}
	
function uncheckParentNodes(dimId, parentid) {
	while(parentid >-1){	
		checkboxes = [];
		checkboxes.push(document.getElementById('checkbox_'+dimId+'_'+parentid));
		// TODO: check for fixed column dimension before checking for fixed node
		checkboxes.push(document.getElementById('checkbox_'+dimId+'_'+parentid+'_fixed'));
		$.each(checkboxes, function(index, checkbox) {
			if(checkbox){
				checkbox.checked=false;
				//we have to take the each check box's node id by substring here
				// here nodeid is equal to parentid!! think a while!!!!						
				nextparentid=checkbox.name.substr((7+dimId.length+1));
				if(nextparentid>-1){
					//pr#65311 : do not send ajax request as, it it unselecting parent's all children
					//registerNodeFilter(isLargeNode, dimId,parentid, checkbox);
				}
				//select the children of this element ends
				parentid=nextparentid;
			}else{
				parentid=-2;
			}
		});
	}	
}	

function getChildren(dimId,nodeId){
	var nodeIdindex=('checkbox_'+dimId).length+1;
	var tempLst = document.getElementsByName('chkbox_'+dimId+'_'+nodeId);
	if( tempLst ) {			
		if(!firstpass){
			allchildobjList.pop();
		}
		var tempLength = tempLst.length;
		for(i=0;i<tempLength;i++){
			firstpass=false;
			allobjList[allobjList.length]=tempLst[i];
			allchildobjList.push(tempLst[i]);
		}
	}		
	var chilObjLngth = allchildobjList.length;
	if(chilObjLngth>0){
		getChildren(dimId,allchildobjList[chilObjLngth-1].id.substr(nodeIdindex,allchildobjList[chilObjLngth-1].id.length));
	}
}

function registerNodeFilter(isLargeNode, dimId, nodeId, isCheckboxChecked) {
    if((isLargeNode == true) && isCheckboxChecked){
   		var answer = confirm('<%=bundle.getValue("ui.dimension.message.confirm.large.node.drill2")%>'); 
   		if(!answer){
    	   checkbox.checked = false;
   	   	   return;
   		}
   	}
    if(!isCheckboxChecked){
   		document.getElementById(dimId.toUpperCase()+"_HIDDEN").value = '';
    }	
    if(nodeId.length > 0){
    	renderProgressBar();
    	/*fix for EXP-6347 : calling setCheckBoxStatus(dimId) method, before sending request, rather than after processing request.*/
    	setCheckBoxStatus(dimId);
		modifiedNodeId = "";
		delimiter = ":";
		$.each(nodeId.split(delimiter), function(index, node) {
			if (node.search("_fixed$") != -1) {
				modifiedNodeId += node.replace("_fixed", "") + delimiter;
			} else {
				modifiedNodeId += node + delimiter;
			}
		});
		// remove last ":"
		modifiedNodeId = modifiedNodeId.slice(0, -1);
    	sendRequestForNodeUpdate('updateSelectedNodes'+","+dimId+","+modifiedNodeId+","+isCheckboxChecked);
    }
}

function addMultipleFilterNodes() {
 	sendRequest('AddMultipleFilterNodesRequest,${param.bkid}');         
    return false;
}


var lastSingleKeepDimId = "";

function addSingleFilterNode(isLargeNode,dimId, treeId) {
    if(isLargeNode == true){
    	var answer = confirm('<%=bundle.getValue("ui.dimension.message.confirm.large.node.drill")%>');
    	if(!answer){
    	   return;
    	}
    }
    lastSingleKeepDimId = dimId;
	sendRequest("AddSingleFilterNodeRequest," + dimId + "," + treeId + ",${param.bkid}");	
}	

function addSingleKeepFilterForTotalSpend(isLargeNode, dimId, treeId) {
    if(isLargeNode == true){
    	var answer = confirm('<%=bundle.getValue("ui.dimension.message.confirm.large.node.drill")%>');
    	if(!answer){
    	   return;
    	}
    }
	    
    lastSingleKeepDimId = dimId;
	sendRequest("AddSingleKeepFilterForTotalSpendRequest," + dimId + "," + treeId + ",${param.bkid}");
}

function expandToNextLevel(dimId) {
	var dimState = document.getElementById("minmaxlink_dim_" + dimId);
	// send the request only for expanded dimensions.
	if ( dimState == null || dimState.getAttribute("refMinimized") == "false" ) {
		var value = "ExpandToNextLevelRequest," + dimId ;
		renderProgressBar();
		sendRequest( value);
	}
}

function collapseToTopofDrill(dimId) {
	var dimState = document.getElementById("minmaxlink_dim_" + dimId);
	// send the request only for expanded dimensions.
	if ( dimState == null || dimState.getAttribute("refMinimized") == "false" ) {
		renderProgressBar();
		var value = "CollapseToTopofDrillRequest," + dimId ;
		sendRequest(value);
	}
}

function doPaging(dimId, treeId, action) {
	var dimState = document.getElementById("minmaxlink_dim_" + dimId);
	// send the request only for expanded dimensions.
	if ( dimState == null || dimState.getAttribute("refMinimized") == "false" ) {
		var value = "doPaging,"+ dimId + ",0" + ","+action;
		renderProgressBar();
		sendRequest(value);
	}
}

function showCrossTabs(isFromCrosstabPage) {
	document.getElementById('currentview').innerHTML='';
	var argStr = 'ShowCrosstabForm,' + isFromCrosstabPage;
	sendRequest(argStr);	
	
	hideSystemMessage();
	return false;
}

function editCrossTabs() {
	document.getElementById('currentview').innerHTML='';
	var argStr = 'EditCrosstabForm,' ;
	sendRequest(argStr);	
	
	hideSystemMessage();
	return false;
}

function sortAsPer(dimId,prop, propType, sortOrder){
	sendRequest("SortAsPerMeasure," + dimId + "," + prop+ "," + propType+ "," + sortOrder);
}

function sendFeedback(p_sType, p_aArgs, p_oValue) {
	sendRequest('FeedbackRequest,' + p_oValue[0] + ',' + p_oValue[1]);
	hideSystemMessage();
}
var feedbackMenu = new YAHOO.widget.Menu("fbMenu", { position: "dynamic", keepopen : false });
var mapText = '<%=!ExpenseMapAppProperties.isEnableCustomFeedbackname()?bundle.getValue("feedback.suggest.mapping") : bundle.getValue("ui.feedback.suggest")+ " " +ExpenseMapAppProperties.getFeedbackTypeMap()%>';
var renameText = '<%=!ExpenseMapAppProperties.isEnableCustomFeedbackname()?bundle.getValue("feedback.suggest.rename") : bundle.getValue("ui.feedback.suggest")+ " " +ExpenseMapAppProperties.getFeedbackTypeRename()%>';
var addText = '<%=!ExpenseMapAppProperties.isEnableCustomFeedbackname()?bundle.getValue("feedback.suggest.add") : bundle.getValue("ui.feedback.suggest") + " " + ExpenseMapAppProperties.getFeedbackTypeAdd()%>';
var moveText = '<%=!ExpenseMapAppProperties.isEnableCustomFeedbackname()?bundle.getValue("feedback.suggest.move") : bundle.getValue("ui.feedback.suggest")+ " " +ExpenseMapAppProperties.getFeedbackTypeMove()%>';

function showFeedbackMenu(dimId, sourceElement, event, bMap, bRen, bMov, bAdd) {
	feedbackMenu.clearContent();
	// 42508 if enable custom names for feedback options is true display custom name else display localized default name
	if (bMap == 1) {
		feedbackMenu.addItem({ text: mapText, onclick: { fn: sendFeedback, obj : [dimId, '<%=FeedbackConstants.TYPE_MAP%>' ] } });
	}
	if (bRen == 1) {
		feedbackMenu.addItem({ text: renameText, onclick: { fn: sendFeedback, obj : [dimId, '<%=FeedbackConstants.TYPE_RENAME%>' ] } });
	}
	if (bMov == 1) {
		feedbackMenu.addItem({ text: moveText, onclick: { fn: sendFeedback, obj : [dimId, '<%=FeedbackConstants.TYPE_MOVE%>' ] } });
	}
	if (bAdd == 1) {
		feedbackMenu.addItem({ text: addText, onclick: { fn: sendFeedback, obj : [dimId, '<%=FeedbackConstants.TYPE_ADD%>'] } });
	}
	feedbackMenu.render("mainDropMenuDiv");
	feedbackMenu.cfg.setProperty("context", [sourceElement, "tl", "bl"]) ;
	feedbackMenu.show();
	return false;
}

function expandCollapse(linkElement, dimId, nodeId, isLargeNode) {
	if (linkElement.getAttribute("refExpanded") == "true") {
		linkElement.innerHTML = '<IMG SRC="'+savIcons[8].src+'" WIDTH="9" HEIGHT="9" BORDER="0" title="<%=bundle.getValue("ui.label.Expand")%>">'; //"[+];
		linkElement.setAttribute("refExpanded", "false");	
		collapseNode(dimId, nodeId);	
	} else {
		if(isLargeNode=="true"){
			var answer = confirm('<%=bundle.getValue("ui.dimension.message.confirm.large.node.drill")%>');
			if(!answer){
			   return;
			}
		}
		linkElement.innerHTML = '<IMG SRC="'+savIcons[3].src+'" WIDTH="9" HEIGHT="9" BORDER="0" title="<%=bundle.getValue("ui.label.Collapse")%>">';//"[-]";
		linkElement.setAttribute("refExpanded", "true");
		expandNode(dimId, nodeId);
	}
}

/**Send req to scroll within a node*/
function scrollWithinNode(dimId, nodeId, beginIndex) {
	renderProgressBar();
	sendRequest("ScrollNodeRequest," + dimId + "," + nodeId + "," + beginIndex);
}

/**Send req to exapnd a node.*/
function expandNode(dimId, nodeId) {
	renderProgressBar();
	sendRequest("ExpandNodeRequest," + dimId + "," + nodeId);
}

//For PR# 41993
function renderProgressBar() {
	if ( progressBarEnabled ) {
		progressBar.show();
	}
}

function removeChildrenNodes(dimId, nodeId) {
	// do 2 more passes, one for fixed table and another for scrollable table
	nodeIds = [nodeId];
	if (isNameFrozenForDimension(dimId)) {
		nodeIds.push(nodeId + "_fixed");
		nodeIds.push(nodeId + "_scrollable");
	}
	
	$.each(nodeIds, function(index, nodeId) {
		var rowNode = document.getElementById(dimId + "" + nodeId);
		var level =	parseInt(rowNode.getAttribute("refNodeLevel")) + 1; // For children, level is this plus 1
		var rowParent = rowNode.parentNode;	
		var nextSiblingNode = rowNode.nextSibling;

		// Remove everything below this level
		while (nextSiblingNode != null && parseInt(nextSiblingNode.getAttribute("refNodeLevel")) >= level) {		
			var n = nextSiblingNode.nextSibling;
			rowParent.removeChild(nextSiblingNode);	
			nextSiblingNode = n;	
		}
	});
	
	if (isNameFrozenForDimension(dimId)) {
		updateScrollableTableSize(dimId, false);
	}
	$("#table_" + dimId).fixTableAlternateRowHighlighting();
}

function collapseNode(dimId, nodeId) {
	checkboxObj=document.getElementById('checkbox_'+dimId+'_'+nodeId);
	sendRequest("CollapseNodeRequest," + dimId + "," + nodeId);
	removeChildrenNodes(dimId, nodeId);
}

function setXofY(xofy, dimId){
	var xofyEle = document.getElementById("xofy_"+dimId);
	if(xofyEle != null){
		xofyEle.innerHTML = xofy;
	}
}

function shrinkGrowDimDiv(shrink, dimId){
	// If dimensional div is minimized, ignore this
	if (document.getElementById("minmaxlink_dim_" + dimId).getAttribute("refMinimized") == "true"){ 
		return;	
	}
	var delta = 30;
	var dimDiv = document.getElementById("dim_" + dimId);
	if (shrink) {
		delta = -delta;
	}
	// Don't let this happen if doing it makes us smaller than the handle (plus a buffer)
	if (shrink && parseInt(dimDiv.style.height) + delta < 24 + 5) {
		return;
	}
	
	updateCurrentDiv = true;
	// On next shrink, only scrollbars will remain so take care of those
	if (shrink && parseInt(dimDiv.style.height) + delta * 2 < 24 + 5  && isNameFrozenForDimension(dimId)) {
		updateCurrentDiv = false;
	}
	
	// Resize the outer div as well as the scrollable treenode container
	dimDiv.style.height = (parseInt(dimDiv.style.height) + delta)+"px";
	document.getElementById("dim_treenode_container_" + dimId).style.height = (parseInt(document.getElementById("dim_treenode_container_" + dimId).style.height) + delta)+"px";
	// Update lookup table for "maximized height" (could be in tags too)
	dimIdToDimHeight[dimId] = parseInt(dimDiv.style.height);
	var index = 0;
	for (var i = 0; i < dimIndexToDimId.length; i++ ) {
		if ( dimIndexToDimId[i] == dimId ) {
			index = i+1;
			break;
		}
	}
	for (var i = index; i < dimIndexToDimId.length; i++ ) {
		currentDimDiv = document.getElementById("dim_" + dimIndexToDimId[i]);
		if (currentDimDiv) {
			currentDimDiv.style.top = (parseInt(currentDimDiv.style.top) + delta)+"px";
		}
	}
	
	if (updateCurrentDiv) {
		updateScrollableTableSize(dimId, false);
	}
}

function offsetPlayersOnMinMax(minimize, dimId){
	var delta = dimIdToDimHeight[dimId] - 24;
	if (minimize) delta = -delta;
	var index = 0;
	for (var i = 0; i < dimIndexToDimId.length; i++ ) {
		if ( dimIndexToDimId[i] == dimId ) {
			index = i+1;
			break;
		}
	}
	for (var i = index; i < dimIndexToDimId.length; i++ ) {
		document.getElementById("dim_"+dimIndexToDimId[i]).style.top=(parseInt(document.getElementById("dim_"+dimIndexToDimId[i]).style.top )+ delta)+"px";
	}
}

function minDimensionalDiv(dimId){	
	sendRequest("MinimizeDimensionRequest," + dimId);
 	document.getElementById("dim_" + dimId).style.height = "24px"; // handle size
 	offsetPlayersOnMinMax(true,dimId);
}

function maxDimensionalDiv(dimId){
	sendRequest("MaximizeDimensionRequest," + dimId);
}

function renderMinMaxLink(isMinimized,htmlStrBuf,dimId){
	htmlStrBuf.append('<A ID=minmaxlink_dim_');
	htmlStrBuf.append(dimId);	
	htmlStrBuf.append(' refMinimized = ');
	if (isMinimized) htmlStrBuf.append('true');
	else htmlStrBuf.append('false');
	htmlStrBuf.append(' HREF=javascript:minMaxDimensionalDiv(this,');
	htmlStrBuf.append("\'"+dimId+"\'");
	htmlStrBuf.append(')>');
	if (!isMinimized) htmlStrBuf.append('<IMG SRC='+savIcons[16].src+' WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.minimize.dimensional.window")%>">');
	else htmlStrBuf.append('<IMG SRC='+savIcons[17].src+' WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.maximize.dimensional.window")%>">');
	htmlStrBuf.append('</A>');
	htmlStrBuf.append("&nbsp;");
}

function minMaxDimensionalDiv(linkElement, dimId) {
	linkElement = document.getElementById("minmaxlink_dim_"+dimId);
	if (linkElement.getAttribute("refMinimized") == "true") {
		linkElement.innerHTML = '<IMG SRC="'+savIcons[16].src+'" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.minimize.dimensional.window")%>">';
		linkElement.setAttribute("refMinimized", "false");	
		maxDimensionalDiv(dimId);
	} else {
		linkElement.innerHTML = '<IMG SRC="'+savIcons[17].src+'" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.maximize.dimensional.window")%>">';
		linkElement.setAttribute("refMinimized", "true");		
		minDimensionalDiv(dimId);	
	}
}

function renderExpandedNode(data){
	var dimId = data[1];
	var treeNodeId = data[2];
	var rowSnapShot = data[3];
	removeChildrenNodes(dimId, treeNodeId);
	//Read heading properties metadata
	//[[prop1_name,prop1_linkType,prop1_isSortable],[prop2_name,prop2_linkType,prop2_isSortable],....] 
   	var properties = data[8]; 
  	columnHeadingLinkTypes = new Array();//store link type for columns
  	columnSortableInformation = new Array(); //is column sortable?
  	columnDisplayName = new Array(); // column display name
  	var propLen = properties.length;
   	for(p=0;p<propLen;p++){
   	    var propHeadings = properties[p];
   	    columnDisplayName[p] = propHeadings[0]; // display name	
   		columnHeadingLinkTypes[p] = propHeadings[1]; //link type
   		columnSortableInformation[p] = 	propHeadings[2]; // sortable
   	}
   	expandNodeCommon(dimId, treeNodeId, data, rowSnapShot);
	checkboxObj=document.getElementById('checkbox_'+dimId+'_'+treeNodeId);
	if(checkboxObj.checked){
		selectTheChildren(false, dimId,treeNodeId, checkboxObj)
	}		
}

function renderDimNode(data){	
	var dimId = data[1];
	var treeNodeId = data[2];
	var rowSnapShot = data[3];
	var tableNode = document.getElementById("table_"+dimId);
	tableNode.tHead.deleteRow(0);
	var tr = tableNode.tHead.insertRow(0);
	// Space for checkboxes starts
	var th = document.createElement('th');
	th.className = "columnHeadingStyle";	
	tr.appendChild(th);

	//[[prop1_name,prop1_linkType,prop1_isSortable],[prop2_name,prop2_linkType,prop2_isSortable],....] 
	var properties = data[8]; 
  	columnHeadingLinkTypes = new Array();//store link type for columns
  	columnSortableInformation = new Array(); //is column sortable?
  	columnDisplayName = new Array();
	var propLen = properties.length;
	for(p=0;p<propLen;p++){
	  	 var htmlStrBuf = new StringBuffer();
	   	 var propHeadings = properties[p];	  	 	
	   	 var th = document.createElement('th');
		 th.className = "columnHeadingStyle";
		 th.noWrap = true;			
		 if(propHeadings[2] == 1 && propHeadings[1]!=3 && propHeadings[1]!=4){
	   		htmlStrBuf.append('<A href="javascript:sortAsPer(\''+dimId+'\', \''+propHeadings[4]+'\',\''+propHeadings[3]+'\',\''+propHeadings[5]+'\')">');	
	   	  }
		  htmlStrBuf.append('&nbsp;&nbsp;');
		  if(propHeadings[1]==3 || propHeadings[1]==4){
		  	htmlStrBuf.append("<bean:message key='ui.label.Total'/>");
		  	htmlStrBuf.append('&nbsp;');	
		  }
		  htmlStrBuf.append(propHeadings[0]);			
		  if(propHeadings[2] == 1 && propHeadings[1]!=3 && propHeadings[1]!=4){
	   		htmlStrBuf.append('</A>');
			htmlStrBuf.append('&nbsp;&nbsp;');
	   		if(propHeadings[6] == 1){
		   		if(propHeadings[5] == 1){	
		   			htmlStrBuf.append('<IMG SRC="'+savIcons[43].src+'">');
		   		} else {
		   			htmlStrBuf.append('<IMG SRC="'+savIcons[44].src+'">');
		   		}
	   		}
		   }
		   th.innerHTML = htmlStrBuf.toString();
		   tr.appendChild(th);
		   columnDisplayName[p] = propHeadings[0]; // property display name
		   columnHeadingLinkTypes[p] = propHeadings[1]; //link type
	   	   columnSortableInformation[p] = propHeadings[2]; // sortable
		}		
		
		// newly created TR need to be added to both fixed and scrollable tables
		if (isNameFrozenForDimension(dimId)) {
			replaceFirstRowOfDimensionTable("table_" + dimId, tr);
		}
		
		expandNodeCommon(dimId, treeNodeId, data, rowSnapShot);
}

function processPaging(data) {
	// We should skip rendering of navigation icons when we just expand a single node
	var requestType = data[0];
	if ( requestType == 'ExpandNodeRequest' || requestType == 'ExpandToNextLevelRequest' || requestType == 'ScrollNodeRequest' ) {
		return;
	}
	var dimId = data[1];
	var pageEnb = data[5];
	var pageInfo = data[6];
	if(pageEnb=='true'){
		var cell = document.getElementById("paging_cell_"+dimId);
		if(cell != null){
			cell.innerHTML = renderPaging(dimId, pageEnb, pageInfo);	
		}
	}
}

function expandNodeCommon(dimId, treeNodeId, data, rowSnapShot) {	   	
	processPaging(data);
	var rowDocFragment = document.createDocumentFragment();
	var rowNode = document.getElementById(dimId + "" + treeNodeId);	
	var bgColor = rowNode.style.backgroundColor;
	if(bgColor == '#FFFFFF' || bgColor == '#ffffff') {
	  bgShadeBlue = true;
	}else{
	  bgShadeBlue = false;
	}
	var level =	parseInt(rowNode.getAttribute("refNodeLevel")) + 1; // For children, level is this plus 1
	var rowParent = rowNode.parentNode;
	// Skip the request id info and the current node info, get right to the kids
	var t = 12 + 1+1+1+3; // Normal 12 for moving past expanded treenode info and 1 for extra dimId/nodeId info
 	var nextTraversal = null;
	var parentsIdStack = new Array();

	while (t < data.length) { // t + 1 for -1 at end of array
	 	// If this is the first treenode in the dimension
		if (nextTraversal == null) {
			parentsIdStack.push(treeNodeId);
		}
 		if (nextTraversal == null) {
			if(data[t+2]==-1){
				parentsIdStack.push(data[t+1])
			}
 			t = createDynamicTreeNodes(data, t, rowDocFragment, level, dimId,rowSnapShot,treeNodeId);  
 		}else{ 			
			// Next node is child
			if(nextTraversal == 1){ 
				level++;
				parentsId=parentsIdStack[parentsIdStack.length-1];
				if(data[t+6]==-1){
					parentsIdStack.push(data[t+5])
				}
				t = createDynamicTreeNodes(data, t + 1 + 3, rowDocFragment, level, dimId, rowSnapShot,parentsId); 
			} // Next node is peer
			else if (nextTraversal == 0) { // Jump 1 to actual treenode info
				parentsId=parentsIdStack[parentsIdStack.length-1];
				if(data[t+3]==-1){
					parentsIdStack.push(data[t+2])
				}
				t = createDynamicTreeNodes(data, t + 1, rowDocFragment, level, dimId,rowSnapShot,parentsId);
			} // Traverse up the tree one level
			else if (nextTraversal == -1) { 
				parentsIdStack.pop();
				level--;
				// In this case, scan for further traversal info, add 1 for next element of info, subtract 1 from level
				// Short circuit evaluation, scan for any more -1s
				while(t + 1 < data.length && data[t + 1] == -1) {
					level--;
					parentsIdStack.pop()
					t++;							  
				}									
				// Now we're at the last -1 in this sequence of -1s, take it from here, and let the loop continue
				// Advance 1 more, since -1 tells us nothing, we need the next info
				t++;				
			}
 		} 		
 		nextTraversal = data[t];	
	}
	insertAfter(dimId, rowParent, rowDocFragment, rowNode);
}

function renderExpandLink(expanded,htmlStrBuf,dimId,nodeId,isLargeNode){
	//if node is zero ie top level node, do not allow to collapse it. disable the hyper link
	if(nodeId != '0'){
		htmlStrBuf.append('<A refExpanded = "');
		htmlStrBuf.append(expanded);
		htmlStrBuf.append('" HREF = "#" ID = "');
		htmlStrBuf.append(dimId);
		htmlStrBuf.append(nodeId);
		htmlStrBuf.append('LinkElement');
		htmlStrBuf.append('" onClick = "expandCollapse(this, \'');
		htmlStrBuf.append(dimId);
		htmlStrBuf.append('\',\'');
		htmlStrBuf.append(nodeId);
		htmlStrBuf.append('\',\'');
		htmlStrBuf.append(isLargeNode);
		htmlStrBuf.append('\')">');
	}
	if (expanded) {
		if(nodeId != '0'){
			htmlStrBuf.append('<IMG SRC="'+savIcons[3].src+'" WIDTH="9" HEIGHT="9" BORDER="0" title="<%=bundle.getValue("ui.label.Collapse")%>">');
		}	
	}else {
		htmlStrBuf.append('<IMG SRC="'+savIcons[8].src+'" WIDTH="9" HEIGHT="9" BORDER="0" title="<%=bundle.getValue("ui.label.Expand")%>">');
	}
	if(nodeId != '0'){
		htmlStrBuf.append("</A>");
	}	
	htmlStrBuf.append("&nbsp;");
}


function createDynamicTreeNodes(data, i, rowDocFragment, level, dimId, rowSnapShot,parentNodeId) {
	// Render name, props
	var treeName = data[i];
	var treeId = data[i + 1];
	var treeChildrenStatus = data[i + 2];
	var nodeType = data[i+3];
	var checked = false;
	//to avoid adding this in multikeep
	if(parentNodeId == -1 ) {
		parentNodeId = -2;
	}
		
	var propValues = data[i + 4];
	var propLen = propValues.length;
	/*propValues[]'s last element will be checked node id*/
	var checkedNodeId = propValues[propLen-1];
	if(checkedNodeId != ''){
		checked = true;	
	}
	
	var tr = document.createElement('TR');
	tr.setAttribute("id", dimId + "" + treeId);
	tr.setAttribute("refNodeLevel", level);
	// TODO: this was 22px before, had to change to 23px for FF. Figure out why FF renders some rows 22px and some 23px
	tr.setAttribute("height", '23px');
	tr.onmouseover = function() { highlightRow(this.id); };
	if ( globalBgColorShadeBlue ) {
		//alternate shade
		tr.style.backgroundImage = EVEN_ROW_BG;
		tr.onmouseout = function() { unHighlightRow(this.id, EVEN_ROW_BG); };
	  	globalBgColorShadeBlue = false;
	} else {
		tr.style.backgroundImage = ODD_ROW_BG;
		tr.onmouseout = function() { unHighlightRow(this.id, ODD_ROW_BG); };
	  	globalBgColorShadeBlue = true;
	}
	// Checkboxes for multiple keep
	var td = document.createElement('TD');
	td.className = "checkStyle";
	td.setAttribute("valign", "top"); 
	td.setAttribute("noWrap", "true");
	var htmlStrBuf = new StringBuffer();

	var isLargeNode = (nodeType == 2)?true:false;
	// Checkboxes for multiple keep
	if ( nodeType > 2 ) {
		if ( level == 0 ) {
			htmlStrBuf.append('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE = "checkbox" CLASS="checkBoxStyle"');
			if( treeId == '0' && dimPageMap[dimId] == 'true' ) {
				//if dim has paging then only show select across page menu
				var xlStr="showCheckBoxMenu('"+dimId+"', this);";
				htmlStrBuf.append('onClick = "'+xlStr+'"');
			}else{			
				htmlStrBuf.append('onClick = "callMeBeforeRegisterNodeFilter(');
				htmlStrBuf.append(isLargeNode);
				htmlStrBuf.append(',\'');	
				htmlStrBuf.append(dimId);
				htmlStrBuf.append('\',\''); 
				htmlStrBuf.append(treeId);
				htmlStrBuf.append('\',\''); 
				htmlStrBuf.append(parentNodeId);
				htmlStrBuf.append('\', this,true);"');
			}
			if(checked){	
				htmlStrBuf.append(' checked ');				
			}
			htmlStrBuf.append(' ID="checkbox_'+dimId+'_'+treeId+'"  name="chkbox_'+dimId+'_'+parentNodeId+'">');
		}
		htmlStrBuf.append('&nbsp;&nbsp;');
	} else {
		htmlStrBuf.append('&nbsp;<INPUT TYPE = "checkbox" CLASS="checkBoxStyle"');
		htmlStrBuf.append('onClick = "callMeBeforeRegisterNodeFilter(');
		htmlStrBuf.append(isLargeNode);
		htmlStrBuf.append(',\'');	
		htmlStrBuf.append(dimId);
		htmlStrBuf.append('\',\''); 
		htmlStrBuf.append(treeId);
		htmlStrBuf.append('\',\''); 
		htmlStrBuf.append(parentNodeId);
		htmlStrBuf.append('\', this,false);"');
		if( checked ) {	
			htmlStrBuf.append(' checked ');				
		}		
		htmlStrBuf.append(' ID="checkbox_'+dimId+'_'+treeId+'" name="chkbox_'+dimId+'_'+parentNodeId+'">');
	}
	td.innerHTML = htmlStrBuf.toString();
	tr.appendChild(td);	
	
	/*propValues[]'s last element will be checked node id*/
   	for(var p = 0; p < propLen - 1; p++) {
   		//SORTABLE COLUMN = 1
        var sortable = columnSortableInformation[p];
        //URL_LINK_NONE = 0;
	    //URL_LINK_TRANSACTION = 1;
	    //URL_LINK_DRILLDOWN = 2;
	    //URL_LINK_TOTALSPEND_DRILLDOWN=3
	    //URL_LINK_TOTAL_TRANSACTION=4;
        var linkType = columnHeadingLinkTypes[p];  
        var propertyDisplayName = columnDisplayName[p];
	   	var tdp = document.createElement('TD');
        tdp.className = p == 0 ? "rowHeadingStyle" : "cellStyle";
		tdp.noWrap = true;
        
		htmlStrBuf = new StringBuffer();
		// Identify as child at given level
		
   		if (p == 0) { 
   			for (var s = 1; s < level; s++) {
   				htmlStrBuf.append("&nbsp;&nbsp;&nbsp;&nbsp;");
   			}
   			if(treeId!=0){
			   	htmlStrBuf.append("&nbsp;&nbsp;&nbsp;&nbsp;");
   			}
   			if (treeChildrenStatus == 1) {
   				renderExpandLink(false, htmlStrBuf, dimId, treeId, isLargeNode);
   			} else if (treeChildrenStatus == -1) {
   				renderExpandLink(true, htmlStrBuf, dimId, treeId, isLargeNode);
   			} else {
   				if(level >1 && nodeType!=4 && nodeType!=5){
				   htmlStrBuf.append("&nbsp;----");
				}else if(nodeType==4 ||nodeType==5){
				   htmlStrBuf.append("&nbsp;");
   				}
   				htmlStrBuf.append('<IMG SRC="'+savIcons[31].src+'" ALIGN="bottom" WIDTH="9" HEIGHT="9" BORDER="0">');
   				if(level==1 && nodeType!=4 && nodeType!=5 ){
				   htmlStrBuf.append("&nbsp;");
   				}
   			}
   			if ( rowSnapShot == 1 && treeId != 0 && treeId != "sumOfVisible" && treeId != "sumOfHidden") {
   				htmlStrBuf.append('<A NAME="TEST" href="javascript:void(0)">');
   				htmlStrBuf.append('<IMG class="snapshotImg" SRC="'+savIcons[45].src+'" BORDER="0" '); 
				htmlStrBuf.append('onClick="getAttributesValues(\''+treeId+'\',\''+dimId+'\')"'); 
				htmlStrBuf.append(' title="<%=bundle.getValue("tooltip.Attribute")%>:&nbsp;'+propValues[p]+'"></IMG></A>');
   			}
   			if(treeId!=0){
				htmlStrBuf.append("&nbsp;");
   			}
   		}
   		
   		if ((linkType == 1)&& (nodeType <= 3)) { // Transaction link
   			htmlStrBuf.append('<a href="#" onclick="return viewTransactionData(\'');
   			htmlStrBuf.append(dimId);
   			htmlStrBuf.append("\',\'");   			
   			htmlStrBuf.append(treeId);   		
   			htmlStrBuf.append('\',\'true\');"');
   			htmlStrBuf.append(' title="');
			htmlStrBuf.append(getMeasureTooltip(propertyDisplayName, treeName));
			htmlStrBuf.append('">&nbsp;');
			htmlStrBuf.append(propValues[p]);
   			htmlStrBuf.append('&nbsp;&nbsp;</A>');
   		}else if((linkType == 2)&& ((nodeType == 1) || (nodeType == 2))) {
   		 	// Standard single node filter link
 			htmlStrBuf.append('<A HREF = "javascript:sendRequestForNodeUpdate(\'');
 			htmlStrBuf.append('maxNodeValidation,singlekeep,'+isLargeNode+','+dimId+','+treeId);
	   		htmlStrBuf.append('\');" ');
	   		htmlStrBuf.append('title="');
			htmlStrBuf.append( getMeasureTooltip(propertyDisplayName, treeName) );
			htmlStrBuf.append('">&nbsp;');    	
	   		htmlStrBuf.append(propValues[p]);
   			htmlStrBuf.append('&nbsp;&nbsp;</A>');
	   	}else if ((linkType == 3) && ((nodeType == 1) || (nodeType == 2))) { 
	   		// filter link on total spend 
   			htmlStrBuf.append('<A HREF = "javascript:addSingleKeepFilterForTotalSpend(');
			htmlStrBuf.append(isLargeNode);
			htmlStrBuf.append(',\'');
	   		htmlStrBuf.append(dimId);  
	   		htmlStrBuf.append('\',\'');   		   		   		
	   		htmlStrBuf.append(treeId);   		   		   		
	   		htmlStrBuf.append('\')"');
	   		htmlStrBuf.append('title="');
	   		htmlStrBuf.append(getTotalMeasureTooltip(propertyDisplayName, treeName));
			htmlStrBuf.append('">&nbsp;');    	
	   		htmlStrBuf.append(propValues[p]);
   		    htmlStrBuf.append('&nbsp;&nbsp;</A></TD>');
	 	}else if ((linkType == 4)&& (nodeType <= 3)) { // Transaction link for TOTAL COUNT
	 		htmlStrBuf.append('<a href="#" onclick="return viewTransactionData(\'');
   			htmlStrBuf.append(dimId);
   			htmlStrBuf.append("\',\'");   			
   			htmlStrBuf.append(treeId);   		
   			htmlStrBuf.append('\',\'false\');"');
   			htmlStrBuf.append(' title="');
   			htmlStrBuf.append(getTotalMeasureTooltip(propertyDisplayName, treeName));
			htmlStrBuf.append('">&nbsp;');
   			htmlStrBuf.append(propValues[p]);
   			htmlStrBuf.append('&nbsp;</A>');			
  			htmlStrBuf.append('&nbsp;&nbsp;</A>');
   		}else{
		   	htmlStrBuf.append('<span title="');
   			htmlStrBuf.append(propValues[p]);
   			htmlStrBuf.append('" ');   			
		   	htmlStrBuf.append(' >');
   			if(p == 0 && nodeType == 6 ) {
   		  		htmlStrBuf.append(propValues[p]);
   		  	} else {
	   		  	appendShortenText(htmlStrBuf, propValues[p], dimId);
   		  	}
   			htmlStrBuf.append('&nbsp;&nbsp;');
   			if ( parentNodeId > 0 && nodeType == 5 && p == 0 ) {
   				// extract the paging info
   				var pageInfo = treeName.split(":");
   				renderPagingForNode(pageInfo, htmlStrBuf, dimId, parentNodeId);
  			}
  			htmlStrBuf.append('</span>');
   		}
		tdp.innerHTML = htmlStrBuf.toString();
		tr.appendChild(tdp);	   		
   	} 
   	rowDocFragment.appendChild(tr);
	return i + 5; // Add 5 here to get to next traversal info and return that index
}

function getMeasureTooltip(measureName, nodeName) {
	// alert(1 + ' ' + measureName + ' ' + nodeName);
	var spendLinkToolTip = '<%=bundle.getValue("tooltip.for.measure")%>';
	return spendLinkToolTip.replace(/\{0\}/gi, measureName).replace(/\{1\}/gi, nodeName);
}

function getTotalMeasureTooltip(measureName, nodeName) {
	// alert(2 + ' ' + measureName + ' ' + nodeName);
	var spendLinkToolTip = '<%=bundle.getValue("tooltip.for.total.measure")%>';
	return spendLinkToolTip.replace(/\{0\}/gi, measureName).replace(/\{1\}/gi, nodeName);
}

function renderPagingForNode(pageInfo, htmlStrBuf, dimId, nodeId){
	var beginIndex = parseInt(pageInfo[0]);
	var pageSize = parseInt(pageInfo[1]);
	var nodeTotal = parseInt(pageInfo[2]);

	if(beginIndex == 1){
		// we're on the first page, so disable the first/prev page.
		htmlStrBuf.append('<img style="border: 0" title="<%=bundle.getValue("tooltip.you.are.at.top")%>" src="/expensemap/jsp/images/first_page_list_ovr.gif"  >&nbsp;');
		htmlStrBuf.append('<img style="border: 0" title="<%=bundle.getValue("tooltip.you.are.at.top")%>" src="/expensemap/jsp/images/previous_page_list_ovr.gif" >&nbsp;');
	}else{
		htmlStrBuf.append('<a href="javascript:void(0)" onClick="scrollWithinNode(\'');
  		htmlStrBuf.append(dimId);
  		htmlStrBuf.append('\',');
  		htmlStrBuf.append(nodeId);
  		htmlStrBuf.append(',1);" ><img style="border: 0" title="<%=bundle.getValue("tooltip.go.top")%>" src="/expensemap/jsp/images/first_page_list_up.gif"></a>&nbsp;');
		htmlStrBuf.append('<a href="javascript:void(0)" onClick="scrollWithinNode(\'');
  		htmlStrBuf.append(dimId);
  		htmlStrBuf.append('\',');
  		htmlStrBuf.append(nodeId);
  		// calculate beginIndex for the prev page
  		var prevPageIndex = beginIndex - pageSize;
  		htmlStrBuf.append(',');
  		htmlStrBuf.append(prevPageIndex);
  		htmlStrBuf.append(');" ><img style="border: 0" title="<%=bundle.getValue("tooltip.go.previous")%>" src="/expensemap/jsp/images/previous_page_list_up.gif"></a>&nbsp;');
 	}
 
	if((beginIndex + pageSize)>nodeTotal){
		// we're on the last page, so disable the next/last page.
		htmlStrBuf.append('<img style="border: 0" title="<%=bundle.getValue("tooltip.you.are.at.bottom")%>" src="/expensemap/jsp/images/next_page_list_ovr.gif">&nbsp;');
		htmlStrBuf.append('<img style="border: 0" title="<%=bundle.getValue("tooltip.you.are.at.bottom")%>" src="/expensemap/jsp/images/last_page_list_ovr.gif">&nbsp;');
	} else {
		htmlStrBuf.append('<a href="javascript:void(0)" onClick="scrollWithinNode(\'');
  		htmlStrBuf.append(dimId);
  		htmlStrBuf.append('\',');
  		htmlStrBuf.append(nodeId);
  		// calculate beginIndex for the next page
  		var nextPageIndex = beginIndex + pageSize;
  		htmlStrBuf.append(',');
  		htmlStrBuf.append(nextPageIndex);
		htmlStrBuf.append(');" ><img style="border: 0" title="<%=bundle.getValue("tooltip.go.next")%>" src="/expensemap/jsp/images/next_page_list_up.gif"></a>&nbsp;');
		htmlStrBuf.append('<a href="javascript:void(0)" onClick="scrollWithinNode(\'');
  		htmlStrBuf.append(dimId);
  		htmlStrBuf.append('\',');
  		htmlStrBuf.append(nodeId);
  		// calculate beginIndex for the last page
  		var numPages = Math.ceil(nodeTotal/pageSize);
  		var lastPageIndex = ((numPages-1)*pageSize)+1;  		
  		htmlStrBuf.append(',');
  		htmlStrBuf.append(lastPageIndex);
  		htmlStrBuf.append(');" ><img style="border: 0" title="<%=bundle.getValue("tooltip.go.bottom")%>" src="/expensemap/jsp/images/last_page_list_up.gif"></a>&nbsp;');
	}
	return htmlStrBuf.toString();
}

// i should be index of first treenode name in data, level is children level
// returns i, which should be the indedx of the next traversal info
function renderTreeNodes(data, i, htmlStrBuf, level, dimId, rowSnapShot,parentNodeId) {	
	// Render name, props
	var treeName = data[i];
	var treeId = data[i + 1];
	var treeChildrenStatus = data[i + 2];
	var nodeType = data[i+3];	
	var propValues = data[i + 4];
	var isLargeNode = (nodeType == 2)?true:false;
	//to avoid adding this in multikeep	
	var checked = false;
	/*propValues[]'s last element will be checked node id*/
	var propLen = propValues.length;
	var checkedNodeId = propValues[propLen-1];
	if(checkedNodeId != ''){
		checked = true;	
	}
	
	htmlStrBuf.append('<TR ID = "');
	htmlStrBuf.append(dimId);
	htmlStrBuf.append(treeId);
	htmlStrBuf.append('" ');
	htmlStrBuf.append('refNodeLevel = "');
	htmlStrBuf.append(level);
	if(globalBgColorShadeBlue){ 
		//alternate shade
		// TODO: revert both following heights to original 22px; had to make it 23px for FF
		htmlStrBuf.append('" STYLE="background-image:' + EVEN_ROW_BG +'; height: 23px;"');
		htmlStrBuf.append('onMouseOut = "unHighlightRow(this.id, EVEN_ROW_BG);" ');
	  	globalBgColorShadeBlue = false;
	} else {
		htmlStrBuf.append('" STYLE="background-image:' + ODD_ROW_BG +'; height: 23px;"');
		htmlStrBuf.append('onMouseOut = "unHighlightRow(this.id, ODD_ROW_BG);" ');
	  	globalBgColorShadeBlue = true;
	}
	htmlStrBuf.append(' onMouseOver = "highlightRow(this.id);" ');
	htmlStrBuf.append('>');
	// Checkboxes for multiple keep
	htmlStrBuf.append('<TD WIDTH="2%" VALIGN="MIDDLE" CLASS="checkStyle" NOWRAP>');
	if( nodeType > 2 ) {
		if ( level == 0 ) {					
			htmlStrBuf.append('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE = "checkbox" CLASS="checkBoxStyle"');
			if(treeId == '0'){				
			//if dim has paging then only show select across page menu
				if(dimPageMap[dimId] == 'true'){
						var xlStr="showCheckBoxMenu('"+dimId+"', this);";
						htmlStrBuf.append('onClick = "'+xlStr+'"');
				}else{
					htmlStrBuf.append('onClick = "callMeBeforeRegisterNodeFilter(');
					htmlStrBuf.append(isLargeNode);
					htmlStrBuf.append(',\'');
					htmlStrBuf.append(dimId);
					htmlStrBuf.append('\',\''); 
					htmlStrBuf.append(treeId);
					htmlStrBuf.append('\',\''); 
					htmlStrBuf.append(parentNodeId);			
					htmlStrBuf.append('\', this,true);" ');			
				}		
			}else{
				htmlStrBuf.append('onClick = "callMeBeforeRegisterNodeFilter(');
				htmlStrBuf.append(isLargeNode);
				htmlStrBuf.append(',\'');
				htmlStrBuf.append(dimId);
				htmlStrBuf.append('\',\''); 
				htmlStrBuf.append(treeId);
				htmlStrBuf.append('\',\''); 
				htmlStrBuf.append(parentNodeId);			
				htmlStrBuf.append('\', this,true);" ');
			}
			if(checked){	
				htmlStrBuf.append(' checked ');				
			}
			htmlStrBuf.append(' ID="checkbox_'+dimId+'_'+treeId+'" name="chkbox_'+dimId+'_'+parentNodeId+'">');
		}
		htmlStrBuf.append('&nbsp;&nbsp;&nbsp;&nbsp;');
	} else {
		htmlStrBuf.append('&nbsp;<INPUT TYPE = "checkbox" CLASS="checkBoxStyle"');
		htmlStrBuf.append('onClick = "callMeBeforeRegisterNodeFilter(');
		htmlStrBuf.append(isLargeNode);
		htmlStrBuf.append(',\'');
		htmlStrBuf.append(dimId);
		htmlStrBuf.append('\',\''); 
		htmlStrBuf.append(treeId);
		htmlStrBuf.append('\',\''); 
		htmlStrBuf.append(parentNodeId);
		htmlStrBuf.append('\', this,false);"');
		if(checked){	
			htmlStrBuf.append(' checked ');				
		}
		htmlStrBuf.append(' ID="checkbox_'+dimId+'_'+treeId+'" name="chkbox_'+dimId+'_'+parentNodeId+'">');
	}
	htmlStrBuf.append('</TD>');	
	// Expand collapse
	var cellURL; 
	/*propValues[]'s last element will be checked node id*/
   	for (var p = 0; p < propLen -1 ; p++) {   		
   		htmlStrBuf.append('<TD ');
   		htmlStrBuf.append(' CLASS="');
   		htmlStrBuf.append(p == 0 ? "rowHeadingStyle" : "cellStyle");
   		htmlStrBuf.append('" nowrap>');   		
	    //SORTABLE COLUMN = 1
        var sortable = columnSortableInformation[p];
        var propertyDisplayName = columnDisplayName[p];
        //URL_LINK_NONE = 0;
	    //URL_LINK_TRANSACTION = 1;
	    //URL_LINK_DRILLDOWN = 2;
		//URL_LINK_TOTALSPEND_DRILLDOWN=3
        var linkType = columnHeadingLinkTypes[p];
        if (p == 0) { // First column, also indent
   			for (var s = 1; s < level; s++)
   			{
   				htmlStrBuf.append("&nbsp;&nbsp;&nbsp;&nbsp;");
   			}
   			if(treeId!=0){
   			htmlStrBuf.append("&nbsp;&nbsp;&nbsp;&nbsp;");
   			}
   			if (treeChildrenStatus == 1) {
   				renderExpandLink(false, htmlStrBuf, dimId, treeId, isLargeNode);
   			} else if ( treeChildrenStatus == -1 ) {
   				renderExpandLink(true, htmlStrBuf, dimId, treeId, isLargeNode);
   			} else {
   				if(level >1 && nodeType!=4 && nodeType!=5){
				   htmlStrBuf.append("&nbsp;----");
				}else if(nodeType==4 ||nodeType==5){
				   htmlStrBuf.append("&nbsp;");
   				}
   				htmlStrBuf.append('<IMG SRC="'+savIcons[31].src+'" ALIGN="bottom" WIDTH="9" HEIGHT="9" BORDER="0">');
   				if(level==1 && nodeType!=4 && nodeType!=5 ){
				   htmlStrBuf.append("&nbsp;");
   				}
   			}
   			if ( rowSnapShot == 1 && treeId != 0 && treeId != "sumOfVisible" && treeId != "sumOfHidden") {
   				htmlStrBuf.append('<A NAME="TEST" href="javascript:void(0)">');
   				htmlStrBuf.append('<IMG class="snapshotImg" SRC="'+savIcons[45].src+'" BORDER="0" ');
   				// TODO SLOW!!!!! 
				htmlStrBuf.append('onClick="getAttributesValues(\''+treeId+'\',\''+dimId+'\')"');
				htmlStrBuf.append(' title="<%=bundle.getValue("tooltip.Attribute")%>&nbsp;:'+propValues[p]+'"></IMG></A>');
   			}
   			if(treeId!=0){
			   	htmlStrBuf.append("&nbsp;");
   			}
   		}   		
   		
   		if ((linkType == 1) && nodeType <= 3) { // Transaction link for dimension and the total node
   			htmlStrBuf.append('<a href="#" onclick="return viewTransactionData(\'');
   			htmlStrBuf.append(dimId);
   			htmlStrBuf.append("\',\'");   			
   			htmlStrBuf.append(treeId);   		
   			htmlStrBuf.append('\',\'true\');"');
   			htmlStrBuf.append(' title="');
			htmlStrBuf.append( getMeasureTooltip(propertyDisplayName, treeName) );
			htmlStrBuf.append('">&nbsp;');  
   			htmlStrBuf.append(propValues[p]);
   		    htmlStrBuf.append('&nbsp;&nbsp;</A></TD>');
   		}else if ((linkType == 2) && ((nodeType == 1) || (nodeType == 2))) {
   			// Standard single node filter link
 			htmlStrBuf.append('<A HREF = "javascript:sendRequestForNodeUpdate(\'');
 			htmlStrBuf.append('maxNodeValidation,singlekeep,'+isLargeNode+','+dimId+','+treeId);
	   		htmlStrBuf.append('\');" ');
	   		htmlStrBuf.append('title="');
			htmlStrBuf.append(getMeasureTooltip(propertyDisplayName, treeName));
			htmlStrBuf.append('">&nbsp;');  
	   		htmlStrBuf.append(propValues[p]);
   		    htmlStrBuf.append('&nbsp;&nbsp;</A></TD>');
   		    	
   		}else if ((linkType == 3) && ((nodeType == 1) || (nodeType == 2))) {
   			// filter link on total spend 
   			htmlStrBuf.append('<A HREF = "javascript:addSingleKeepFilterForTotalSpend(');
			htmlStrBuf.append(isLargeNode);
			htmlStrBuf.append(',\'');
	   		htmlStrBuf.append(dimId);   		   		
	   		htmlStrBuf.append('\',\'');   		   		   		
	   		htmlStrBuf.append(treeId);   		   		   		
	   		htmlStrBuf.append('\')"');
	   		htmlStrBuf.append('title="');
	   		htmlStrBuf.append(getTotalMeasureTooltip(propertyDisplayName, treeName));
			htmlStrBuf.append('">&nbsp;');      
	   		htmlStrBuf.append(propValues[p]);
   		    htmlStrBuf.append('&nbsp;&nbsp;</A></TD>');
   		}else if ((linkType == 4) && nodeType <= 3) { // Transaction link for TOTAL COUNT   			
   			htmlStrBuf.append('<a href="#" onclick="return viewTransactionData(\'');
   			htmlStrBuf.append(dimId);
   			htmlStrBuf.append("\',\'");   			
   			htmlStrBuf.append(treeId);   		
   			htmlStrBuf.append('\',\'false\');"');
   			htmlStrBuf.append(' title="');
   			htmlStrBuf.append(getTotalMeasureTooltip(propertyDisplayName, treeName));
			htmlStrBuf.append('">&nbsp;');
   			htmlStrBuf.append(propValues[p]);
   			htmlStrBuf.append('&nbsp;&nbsp;</A></TD>');
   		}else{
   			htmlStrBuf.append('<span title="')
   		  	htmlStrBuf.append(propValues[p]);
   		  	htmlStrBuf.append('" >');
   		  	appendShortenText(htmlStrBuf, propValues[p], dimId);
   			htmlStrBuf.append('&nbsp;&nbsp;');
  			if ( parentNodeId > 0 && nodeType == 5 && p == 0 ) {
  				var pageInfo = treeName.split(":");
   				renderPagingForNode(pageInfo, htmlStrBuf, dimId, parentNodeId);
  			}
  			htmlStrBuf.append('</span></TD>');  			
   		}
   	}	   	
	htmlStrBuf.append('</TR>'); 
	return i + 5; // Add 5 here to get to next traversal info and return that index
}

function appendShortenText(strBuf, str, dimId) {
    var maxLength = getMaxCharactersBydimId(dimId);
	var string = unEscapeQuots(str);		
	if (string.length > maxLength) {
		strBuf.append(string.substring(0, maxLength));
		strBuf.append('...');
	} else {
		strBuf.append(str);
	}
}

function unEscapeQuots( str) {
    var from = "&quot;";
    var to = "\"";
    var idx = str.indexOf( from );
    while ( idx > -1 ) {
        str = str.replace( from, to ); 
        idx = str.indexOf( from );
    }
    return str;
}


function renderPaging(dimId, pageEnb, pageInfo) {
	if(pageEnb == 'false') {
		return '';
	}
	var htmlStrBuf = new StringBuffer();
	htmlStrBuf.append('');
	var beginIndex = pageInfo[0];
	var pageSize = pageInfo[1];
	var nodeTotal = pageInfo[2];
	htmlStrBuf.append('<TD ID="paging_cell_'+dimId+'" WIDTH="100%" VALIGN="top" STYLE="font-size:6px; padding-top: 4px;" NOWRAP>');
	if(beginIndex == 1){
		// we're on the first page, so disable the first/prev page.
		htmlStrBuf.append('&nbsp;<IMG ID="img_bk_dis_'+dimId+'" SRC="/expensemap/jsp/images/beginning_disabled.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.you.are.at.top")%>">');
		htmlStrBuf.append('&nbsp;<IMG ID="img_bk_dis_'+dimId+'" SRC="/expensemap/jsp/images/back_disabled.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.you.are.at.top")%>">');
	} else {
		htmlStrBuf.append('<A HREF = "javascript:doPaging(\'');
	 	htmlStrBuf.append(dimId);   		   		
	 	htmlStrBuf.append('\',\'');   		   		   		
	 	htmlStrBuf.append(0);   		   		   		
	 	htmlStrBuf.append('\',\'first\')"><IMG SRC="/expensemap/jsp/images/beginning_enabled.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.go.top")%>"></A>');	 	
	 	htmlStrBuf.append('&nbsp;<A HREF = "javascript:doPaging(\'');
		htmlStrBuf.append(dimId);   		   		
		htmlStrBuf.append('\',\'');   		   		   		
		htmlStrBuf.append(0);  
 		htmlStrBuf.append('\',\'prev\')"><IMG ID="img_bk_enb_'+dimId+'" SRC="/expensemap/jsp/images/back_enabled.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.go.previous")%>"></A>');	 	
 	} 
	if((beginIndex + pageSize)>nodeTotal){
		// we're on the last page, so disable the next/last page.
 		htmlStrBuf.append('&nbsp;<IMG ID="img_fd_dis_'+dimId+'" SRC="/expensemap/jsp/images/forward_disabled.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.you.are.at.bottom")%>">');
 		htmlStrBuf.append('&nbsp;<IMG ID="img_fd_dis_'+dimId+'" SRC="/expensemap/jsp/images/end_disabled.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.you.are.at.bottom")%>">');
	} else {
		htmlStrBuf.append('&nbsp;<A HREF = "javascript:doPaging(\'');
		htmlStrBuf.append(dimId);   		   		
		htmlStrBuf.append('\',\'');   		   		   		
		htmlStrBuf.append(0); 
 		htmlStrBuf.append('\',\'next\')"><IMG ID="img_fd_enb_'+dimId+'" SRC="/expensemap/jsp/images/forward_enabled.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.go.next")%>"></A>');
	 	htmlStrBuf.append('&nbsp;<A HREF = "javascript:doPaging(\'');
	 	htmlStrBuf.append(dimId);   		   		
	 	htmlStrBuf.append('\',\'');   		   		   		
	 	htmlStrBuf.append(0); 		   		   		
	 	htmlStrBuf.append('\',\'last\')"><IMG SRC="/expensemap/jsp/images/end_enabled.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.go.bottom")%>"></A>');
	}
 	htmlStrBuf.append('&nbsp;&nbsp;&nbsp;&nbsp;</TD>');
	return htmlStrBuf.toString();
}


var allDimLevelHashMap = {};
//Stores max characters to display for dimension.
var allDimMaxCharHashMap = {};
var allDimNoOfRowsHashMap = {};
// Stores information of all dimensions and their FULL_NM frozen preference
var allDimNameFrozenHashMap = {};

<%
	for ( int i=0; i < allDimNames.size(); i++ ) {
%>
	allDimLevelHashMap['<%= allDimNames.get(i) %>'] = <%= allDimLevels.get(i) %>;
	allDimMaxCharHashMap['<%= allDimNames.get(i) %>'] = '<%= dimMaxChar.get(i) %>';
	allDimNoOfRowsHashMap['<%= allDimNames.get(i) %>'] = '<%= allDimNoOfRowsToDisplay.get(i)%>';
	allDimNameFrozenHashMap['<%= allDimNames.get(i) %>'] = '<%= allDimNameFrozen.get(i)%>';
<%
}
%>

/*Used for CSV export at specific level starts.Returns levels for a given dimension.*/
function getLevelsBydimId(dimId) {
	return allDimLevelHashMap[dimId];
}

/*Used for CSV export at specific level starts.Returns levels for a given dimension.*/
function getNoOfRowsBydimId(dimId) {
	return allDimNoOfRowsHashMap[dimId];
}

/*Used for truncation of the node names.Returns maximum characters to display for a given dimension.*/
function getMaxCharactersBydimId(dimId) {
	return allDimMaxCharHashMap[dimId];
}

/* Returns true if FULL_NM has to be frozen for given dimension */
function isNameFrozenForDimension(dimId) {
	return (allDimNameFrozenHashMap[dimId] == "true") ? true: false;
}
   	   
function renderCube(data) {
	// Reset the lookup tables for dimension info
	leftSideIndexToDimId = new Array();
	leftSideIndexLength = 0;
	dimIdToDimHeight = new Array();
	dimIdToLeftSideIndex = new Array();
	
	// Reset the sum of prev dimension heights
 	sumPrevDimPixelHeights = 0;	
	var htmlStrBuf = new StringBuffer();
    if(data[0] == "Error"){
        htmlStrBuf.append('<font size="2" face="Arial, Helvetica, sans-serif" color="red"> ');
		htmlStrBuf.append(data[2]);
		htmlStrBuf.append('</font>');
		document.getElementById("treeNodeDiv").innerHTML = htmlStrBuf.toString();
		return;
	}else{

		if ( data[1] == 0 ) { // 0 is neither crosstab nor feedback
			feedbackOrCrossTab = false;
			// reset crosstab form
			document.getElementById("crossTabDiv").style.display = "none";					
			document.getElementById("crossTabFrame").src == '/expensemap/jsp/blank.html';
			// reset feedback form
			document.getElementById("feedbackDiv").style.display = "none";					
			document.getElementById("feedbackFrame").src == '/expensemap/jsp/blank.html';
		} else if (data[1] == 1) { // 1 is flag for crosstab
	 		feedbackOrCrossTab = true;
	 		var crossTabFormUrl = '/expensemap/crosstab/preCreateCrosstab.do';   
			var crossTabEditFormUrl = '/expensemap/crosstab/preCreateCrosstab.do?edit=true';
			var crossTabURL = data[2]; 
			document.getElementById("crossTabDiv").style.display = "block";			
			
			// fix for bug no. 38174. crosstabframe's src is not refreshed.(this is not a proper fix this
			// causes crosstab request submission twice hence reverting this fix)
			//document.getElementById("crossTabFrame").src = crossTabURL;			
			//Fix for PRs : 41471 and 41472(root cause of these prs was fix made for 38174)
			if (document.getElementById("crossTabFrame").src.indexOf('/expensemap/jsp/blank.html') >= 0 || crossTabURL == crossTabFormUrl ||  crossTabURL ==  crossTabEditFormUrl) {
				document.getElementById("crossTabFrame").src = crossTabURL;
			}					
		} else if (data[1] == 2) {// 2 is flag for feedback		    
		    feedbackOrCrossTab = true;
		    var feedbackURL = data[2];
			document.getElementById("crossTabDiv").style.display = "none";
			document.getElementById("feedbackDiv").style.display = "block";
			document.getElementById("feedbackFrame").src = feedbackURL;
		}
		// Render dimensions
		var d = 2;
		if ( feedbackOrCrossTab ) {
			d = 3;
		}
		initMainWindow(feedbackOrCrossTab);
		var dimIndex = 0;
		dimIndexToDimId = new Array();
		// re-initialize
		dimensionsList = [];
		dimensionIndex = 0;
		while ( d < data.length ) {
			var dimId = data[d][0];
			dimensionsList.push(dimId);
			buildDimensionWindow(data[d], dimIndex, feedbackOrCrossTab);
			d++;
			dimIndex++;
		}
		requestDimensionRollup();
		initDivider();
	}
}


function initMainWindow(isFeedbackOrCrossTab ) {
	var treeNodeDiv = document.getElementById("treeNodeDiv");
	treeNodeDiv.innerHTML = '';
	if ( ! isFeedbackOrCrossTab ) {
		var htmlStrBuf = new StringBuffer();
		htmlStrBuf.append('<div id="mainPaneDiv" style="position: absolute; z-index: 0; left: ${mainViewLeftOffset}%; overflow-x:hidden; overflow-y:hidden; width:${mainViewPercent}%; height:100%" >');		
		htmlStrBuf.append('<div id="mainPaneInnerDiv" style="width: 100%; height: 100%; border: 2px solid FFFFFF"></div>');
		htmlStrBuf.append('</div>');
		treeNodeDiv.innerHTML += htmlStrBuf.toString();
	}
	htmlStrBuf = new StringBuffer();
	htmlStrBuf.append('<div id="leftScrollDiv" style="position: absolute; z-index: 0; left: ${leftViewLeftOffset}%; overflow-x:auto; overflow-y:auto; width:${leftViewPercent}%; height:100%" >');
	htmlStrBuf.append('<div id="leftScrollInnerDiv" style="width: 100%; height: 100%;"></div>');
	htmlStrBuf.append('</div>');
	treeNodeDiv.innerHTML += htmlStrBuf.toString();
}

function buildDimensionWindow(dimensionInfo, dimIndex, feedbackOrCrossTab) {
	var dimId = dimensionInfo[0];
	dimIndexToDimId[dimIndex] = dimId;
	var target = null;
	var isMainView = false;
	var mainViewRight = ${mainViewRight};
	var isMinimized = dimensionInfo[1];
 	var pixHeight = dimensionInfo[2];
 	var leftMargin;
	if ( dimIndex == 0 && (! feedbackOrCrossTab) ) {
		isMainView = true;
		target = document.getElementById("mainPaneInnerDiv");
		leftMargin = mainViewRight ? 5 : 0;
	} else {
		target = document.getElementById("leftScrollInnerDiv");
		leftMargin = mainViewRight ? 0 : 5;
	}

	var htmlStrBuf = new StringBuffer();
	// Calculate top margin
	var topMargin = isMainView ? "0" : sumPrevDimPixelHeights;
	htmlStrBuf.append('<div id="dim_container_').append(dimId).append('">');
	htmlStrBuf.append('<DIV ID = "dim_').append(dimId).append('" STYLE = "border-bottom: 1px solid #E8E8E8; position: absolute; z-index: 0; left: ');
   	htmlStrBuf.append(leftMargin);
 	htmlStrBuf.append('px; top: ');
 	htmlStrBuf.append(topMargin);
 	htmlStrBuf.append('px; width:100%; height:');
 	
 	if ( isMainView ) {
 		htmlStrBuf.append('100%');
 	} else {
 		if (isMinimized == 1) {
 			htmlStrBuf.append('24px'); // Height of handle
 		} else {
 			htmlStrBuf.append(pixHeight);
 			htmlStrBuf.append('px');
 		}
 		htmlStrBuf.append('; overflow:hidden;');
 	}

 	if ( ! isMainView ) {
 		// Add this now that we've positioned ourselves
 		if (isMinimized == 1) {
 			sumPrevDimPixelHeights += 24;
 		} else {
 			sumPrevDimPixelHeights += pixHeight;
 		}
 	}
 	htmlStrBuf.append('" ></div>');
 	htmlStrBuf.append('<div>');
	target.innerHTML += htmlStrBuf.toString();
}

/**
 * Requests dimension rollup for the next available dimension.
 */
function requestDimensionRollup() {
	if ( dimensionIndex == dimensionsList.length) {
		// no more dimensions left to process.
		alert('All dimensions are over');
		return;
	}
	// Get the first dimension from the list and send rollup request.
	var dimId = dimensionsList[dimensionIndex++];
	try {
		var url = "/expensemap/jsp/ajaxRequest.jsp?GetDimensionRollup," + dimId;
		jQuery.ajax({
			url: url,
			type: "GET",
			success: renderDimension,
			error: function(xhr, status, error) {
				alert('<%=bundle.getValue("ui.message.There.was.a.problem.retrieving.data.from.server")%> ' + xhr.statusText);
				return false;
			}
		});
		
	} catch(e) {
		 alert(e);
	}
}

// i should be the dimension traversal info index
function renderDimension(response) {
	var data = eval(response);
	if ( data[1] == 'REQUEST_CANCELLED' ) {
		// the request has been canceled. return.
		return;
	}
	var dimId = data[3];
	if ( dimensionIndex == dimensionsList.length) {
		cubeRollupInProgress = false;
	} else {
		requestDimensionRollup();
	}
	processDimensionRollup(data);
	setCheckBoxStatus(dimId);
}

var dimensionBackgroundImagesRoot = '/expensemap/jsp/images/dimension-backgrounds/'
var dimensionBackgroundImagesMap = {};
// Populate background images to be used for individual dimension bars
<%
	for (DimensionColor dc : DimensionColor.values()) {
%>	
	dimensionBackgroundImagesMap['<%= dc.getColorCode() %>'] = dimensionBackgroundImagesRoot + '<%= dc.getImageName() %>';
<%	
	}
%>

function processDimensionRollup(data) {
	// data is available, stop the poller.
	var dimId = data[3];
	var i = 2; // field index
	var dimDisplayName = data[2];
	
	var dimColor = data[4];
	var dimError = data[5][0];
	var dimErrorMessage = data[5][1];
	
	var isMinimized = 0;
	var pixHeight = 300;
	var  propertyHeadings = null;
	var xofy = "";
	var desc = "";
	if (dimError == 0) {
		dimPageMap[dimId] = data[6];
		xofy = data[10];
	   	isMinimized = data[12];
	   	pixHeight =   data[13];
	   	dimIdToDimHeight[dimId] = pixHeight;
	   	propertyHeadings = data[14]; // used to check null properties
		desc = data[8];	
   	}
		
	var isMainView = false;
	
	var htmlStrBuf = new StringBuffer();
	
 	htmlStrBuf.append('<DIV ID = "dim_handle_');
 	htmlStrBuf.append(dimId);
 	htmlStrBuf.append('" STYLE = "background-image: url(')
 	htmlStrBuf.append(dimensionBackgroundImagesMap[dimColor]);
 	htmlStrBuf.append('); overflow:hidden; width:100%; height:24px;">'); 	
 	htmlStrBuf.append('<TABLE WIDTH="100%" HEIGHT="24px" BORDER="0" CELLPADDING="2" CELLSPACING="0">');
 	htmlStrBuf.append('<TR ID="title_row_'+dimId+'" CLASS = "dimTitle">');
 	htmlStrBuf.append('<TD CLASS="dimTitle" WIDTH="100%" VALIGN="middle" NOWRAP>');
 	htmlStrBuf.append('<span id="tt_' + dimId+ '" title="' + desc +'">'+dimDisplayName+'</span>');
 	htmlStrBuf.append('<span id=xofy_'+dimId+'>'+xofy+'</span>');
	htmlStrBuf.append('</TD>');

	if (dimError == 0) {			
		// paging
		var  pageEnb = data[6];
		var pageInfo = data[7];	
		var rowSnapShot = data[9];
		htmlStrBuf.append(renderPaging(dimId, pageEnb, pageInfo));
		
		// printer icon contained in main dimension's header is clipped in non-IE browsers
		if (jQuery.browser.msie) {
			htmlStrBuf.append('<TD width="100%" valign="top" style="font-size:6px; padding-top: 4px;" nowrap>');
		} else {
			htmlStrBuf.append('<TD width="100%" valign="top" style="font-size:6px; padding-right: 5px; padding-top: 4px;" nowrap>');
		}
		
		// process feedback links
		var feedbackInfo = data[11];
		if ( feedbackInfo[0] == 1) {
			if( feedbackInfo[1]!=0 || feedbackInfo[2]!= 0 || feedbackInfo[3] !=0 || feedbackInfo[4] != 0 ) {
				htmlStrBuf.append('<img src="'+savIcons[48].src+'" style="cursor: pointer;" onClick="showFeedbackMenu(\'');
				htmlStrBuf.append(dimId); 
				htmlStrBuf.append('\', this, event, ');
				htmlStrBuf.append(feedbackInfo[1]);
				htmlStrBuf.append(",");
				htmlStrBuf.append(feedbackInfo[2]);
				htmlStrBuf.append(",");
				htmlStrBuf.append(feedbackInfo[3]);
				htmlStrBuf.append(",");
				htmlStrBuf.append(feedbackInfo[4]);
				htmlStrBuf.append(');" width="16" height="16" border="0" title="<%=bundle.getValue("tooltip.launch.feedback.form")%>">');	
	  		}
	  	}
		htmlStrBuf.append('<A TARGET="_self" HREF = "javascript:void(0)" onClick = "expandToNextLevel(\'');
		htmlStrBuf.append(dimId); 
		htmlStrBuf.append('\'');
		htmlStrBuf.append(');"><IMG SRC="'+savIcons[7].src+'" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.expand.to.next.level")%>"></A> ');
		htmlStrBuf.append('<A TARGET="_self" HREF = "javascript:void(0)" onClick = "collapseToTopofDrill(\'');
		htmlStrBuf.append(dimId); 
		htmlStrBuf.append('\'');
		htmlStrBuf.append(');"><IMG SRC="'+savIcons[2].src+'" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.collapse.top.drill")%>"></A> ');			
		// Multiple Filter Add
		htmlStrBuf.append('<A HREF = "#" onClick = "sendRequestForNodeUpdate(\'maxNodeValidation,multikeep\');">');
		htmlStrBuf.append('<IMG SRC="'+savIcons[12].src+'" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.keep.only.selected.row")%>"></A> ');			
		// TODO If we are in the main view add icons for CT and Export
		
		if ( (! feedbackOrCrossTab) && dimIndexToDimId[0] == dimId ) {
			// Is this dimension displayed in the main window?
			if(hasCreateTabulationPermission){
				htmlStrBuf.append('<A HREF = "#" onClick = "showCrossTabs(\'');
				htmlStrBuf.append('0'); 
				htmlStrBuf.append('\');"><IMG SRC="'+savIcons[1].src+'" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("ui.label.crosstab")%>"></A>');	
			}
			if ( hasExportPermission ) {
				var xlStr="openExportBox('" + dimId + "')"; 
				htmlStrBuf.append('<IMG SRC="'+savIcons[6].src+'" WIDTH="16" style="cursor:pointer" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("ui.tooltip.export")%>" onclick="'+ xlStr+'"');  htmlStrBuf.append('</A> ');		
			}
			htmlStrBuf.append('<A HREF="#" onClick="printDimension(\'');
			htmlStrBuf.append(dimDisplayName);
			htmlStrBuf.append('\', \'');
			htmlStrBuf.append(dimId);
			htmlStrBuf.append('\');"><IMG SRC="'+savIcons[32].src+'" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("ui.tooltip.print")%>"></A> ');
		} else {
			htmlStrBuf.append('<A HREF=javascript:shrinkGrowDimDiv(false,\'');
			htmlStrBuf.append(dimId);		
			htmlStrBuf.append('\');><IMG SRC="'+savIcons[10].src+'" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.grow.dimensional.window")%>"></A> ');
			htmlStrBuf.append('<A HREF=javascript:shrinkGrowDimDiv(true,\'');
			htmlStrBuf.append(dimId);	
			htmlStrBuf.append('\');><IMG SRC="'+savIcons[42].src+'" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.shrink.dimensional.window")%>"></A> ');			
			renderMinMaxLink(isMinimized, htmlStrBuf, dimId);
			htmlStrBuf.append('<A href="javascript:void(0)" onClick="swapReport(\'' + dimId + '\');"><IMG SRC="'+savIcons[33].src+'" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=bundle.getValue("tooltip.swap.with.main.dimensional.window")%>"></A> ');			
		}
		htmlStrBuf.append('</TD>');
	}
	htmlStrBuf.append('</TR></TABLE>');
	htmlStrBuf.append('</DIV>');	
	// start treenode scrollable container
 	htmlStrBuf.append('<DIV ID = "dim_treenode_container_');
 	htmlStrBuf.append(dimId);
 	
	if ( document.getElementById('mainPaneDiv') && dimId == dimIndexToDimId[0] ){
	 	htmlStrBuf.append('" STYLE="width: 100%; height: 100%; overflow-y: auto; position: relative; ');
	}else{
	 	htmlStrBuf.append('" STYLE="width: 100%; position: relative; height:');
   	    htmlStrBuf.append(pixHeight - 23);
		htmlStrBuf.append('px; ');	
	}
	
	if (isNameFrozenForDimension(dimId)) {
		htmlStrBuf.append('overflow-x: hidden; overflow-y: hidden;">');
	} else {
		htmlStrBuf.append('overflow-x: auto; overflow-y: scroll;">');
	}

    if(dimError == 0){
	    // Render TreeNodes 
	    htmlStrBuf.append('<TABLE id="table_'+dimId+'" WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">');   
		htmlStrBuf.append("<THEAD>");
		htmlStrBuf.append('<TR CLASS = "columnHeadingStyle">');
		// Space for checkboxes
		htmlStrBuf.append('<TH ></TH>');	  	
	  	// Render property headings
	  	//[[prop1_name,prop1_linkType,prop1_isSortable],[prop2_name,prop2_linkType,prop2_isSortable],....] 
	   	// 	var properties = data[i]; 
	   	var propLen = propertyHeadings.length;
	  	columnHeadingLinkTypes = new Array();//store link type for columns
	  	columnSortableInformation = new Array(); //is column sortable?
		columnDisplayName = new Array(); // column display name
		
	   	for(p=0;p<propLen;p++) {
	   	    var propHeadings = propertyHeadings[p];
	   	    htmlStrBuf.append('<TH ');
	   		htmlStrBuf.append(' CLASS="columnHeadingStyle" NOWRAP>&nbsp;&nbsp;');
	   		if(	propHeadings[2] == 1 && propHeadings[1]!=3 && propHeadings[1]!=4) {
	   			htmlStrBuf.append('<A href="javascript:sortAsPer(\''+dimId+'\', \''+propHeadings[4]+'\',\''+propHeadings[3]+'\',\''+propHeadings[5]+'\')">');	
	   		}
	   		if(propHeadings[1]==3 || propHeadings[1]==4){
			  	htmlStrBuf.append("<bean:message key='ui.label.Total'/>");
			  	htmlStrBuf.append('&nbsp;');		
			}
			htmlStrBuf.append(propHeadings[0]);	
			if(propHeadings[2] == 1 && propHeadings[1]!=3 && propHeadings[1]!=4){
	   			htmlStrBuf.append('</A>');	
			}	
			htmlStrBuf.append('&nbsp;&nbsp;');
	   		htmlStrBuf.append('</TH>');
	   		columnDisplayName[p] = propHeadings[0]; // display name	
	   		columnHeadingLinkTypes[p] = propHeadings[1]; //link type
	   		columnSortableInformation[p] = 	propHeadings[2]; // sortable
	   	}	    
		htmlStrBuf.append('</TR>');   
		htmlStrBuf.append("</THEAD>");
		htmlStrBuf.append("<TBODY>");
			 	
	 	// Jump ahead 1 to first set of treenode data
	 	var t = 15;
		var nextTraversal = null;
		firsttime=false;
		var parentIdStack = new Array(); 
		parentId=-1;
	 	var level = 0;
	 	globalBgColorShadeBlue = true; //the dimension property row is blue background
	 	while (t < data.length) { // While we're not at the end of the data stream
		 	// If this is the first treenode in the dimension
	 		if (nextTraversal == null) {
				if ( data[t+2] == -1 ) {
					parentIdStack.push(data[t+1])
				}
	 			t = renderTreeNodes(data, t, htmlStrBuf, 0, dimId, rowSnapShot,parentId); // Just render what's right in front of us
				firsttime=true;
	 		} else {		
				// Next node is child
				if (nextTraversal == 1) { // TODO: temp skip standard 1, and then 1 past children visible info and get right to rendering
					level++;
					parentId=parentIdStack[parentIdStack.length-1];
					if ( data[t+6] == -1 ) {
						parentIdStack.push(data[t+5])
					}
					t = renderTreeNodes(data, t + 1 + 3, htmlStrBuf, level, dimId, rowSnapShot,parentId);
				} else if (nextTraversal == 0) { 
					// Next node is peer
					// Jump 1 to actual treenode info
					parentId=parentIdStack[parentIdStack.length-1];
					if ( data[t+3] == -1 ) {
						parentIdStack.push(data[t+2])
					}
					t = renderTreeNodes(data, t + 1, htmlStrBuf, level, dimId, rowSnapShot,parentId);	
				} else if (nextTraversal == -1) {
					// Traverse up the tree one level
					parentIdStack.pop()
					level--;
					// In this case, scan for further traversal info, add 1 for next element of info, subtract 1 from level
					// Short circuit evaluation, scan for any more -1s
					while(t + 1 < data.length && data[t + 1] == -1) {
						level--;
						parentIdStack.pop()
						t++;							  
					}	
					// Now we're at the last -1 in this sequence of -1s, take it from here, and let the loop continue
					// Advance 1 more, since -1 tells us nothing, we need the next info
					t++;				
				}
	 		}
	 		
	 		// Now, we're at the next traversal index in the data
	 		// Let's consider when we're going to end a dimension, we could be:
	 		// 1. 1 past the last -1 in the data stream having climbed up from all the kids
	 		// 2. if only a single root node and it has no children, we could actually be AT THE END already
	 		//    as it DOES NOT have any next traversal info
	 		// 3. heading for our next dimension
	 		
	 		if (t == data.length || data[t] == 2) {
				// End dimension table
				htmlStrBuf.append("</TBODY>");
	  			htmlStrBuf.append('</TABLE>');	 
				// end treenode scrollable container
				htmlStrBuf.append('</DIV>');
		  		
			   	// End the ENTIRE parsing sequence if cases 1 or 2 above (i.e. let everyone know its the end)
			   	// if (t == data.length) return data.length;		   	
			   	// Otherwise keep going onto next dimension, return index of next dimension traversal info
			    // return t;
			} else { 
				// Otherwise, just keep parsing treenodes in this dimesnion and handle this next traversal 
				// info above in the loop
				nextTraversal = data[t];
			}
	 	}
	 	// document.getElementById('checkedNodesDiv').innerHTML = htmlStrBuf.toString();
 	} else {
 		htmlStrBuf.append('<font size="2" face="Arial, Helvetica, sans-serif" color="red">')
	    htmlStrBuf.append(dimErrorMessage);
	    htmlStrBuf.append('</font>');	
		// end treenode scrollable container
		htmlStrBuf.append('</DIV>');
   	}
	
 	// add dimension to its container
 	document.getElementById('dim_' + dimId).innerHTML = htmlStrBuf.toString();
	// fix virtual node ids for highlighting rows
	fixVirtualNodeIds($("#table_" + dimId).find("tr"), dimId, true);
	
	if (!FULL_NM_FROZEN) {
		return;
	}
	
	if (isNameFrozenForDimension(dimId)) { 
		fixColumnsForTable(dimId, NO_OF_FIXED_COLUMNS);
	}
	
	mainDimId = dimIndexToDimId[0];
	if (mainDimId == dimId) {
		adjustMainViewDimensionWidth();
	}
	
	// After every dimension is loaded, make sure that all scrollable and fixed column tables are properly updated
	updateAllScrollableTableSizes();
	
	if (!cubeRollupInProgress) {
		// if this is the last dimension, adjust main dimension div size; otherwise all browsers show vertical scrollbar for the window
		updateMainContainerDivHeight();
		adjustMainViewDimensionWidth();
		
		// this is extra check to make sure that all tables are properly rendered
		setTimeout(updateAllScrollableTableSizes, 1500)
		
		// fix height of main view dimension if its name isnt frozen so that it displays horizontal scrollbar if necessary
		if (!isNameFrozenForDimension(mainDimId)) {
			setHeightOfMainDimensionContainer($("#dim_treenode_container_" + mainDimId));
			setTimeout(function() {
				setHeightOfMainDimensionContainer(jQuery("#dim_treenode_container_" + mainDimId));
			}, 1500);			
		}
	}
}

/* If main view has vertical scrollbar, adjust inner container so that scrollbars are visible.
 * The reason this needs to be done is, main view dimension dim_DIMENSION div has left offset for
 * compensating the divider and if there is vertical scrollbar, it gets pushed out of the screen.
 */
function adjustMainViewDimensionWidth() {
	var mainPaneDiv = jQuery("#mainPaneDiv");
	// In case of crosstab and feedback requests, we need not do the adjustment.
	if (mainPaneDiv.length == 0) {
		return;
	}
	
	var mainViewDimId = dimIndexToDimId[0];
	var mainViewDimension = jQuery("#dim_" + mainViewDimId);
	var mainViewTreenodeContainer = jQuery("#dim_treenode_container_" + mainViewDimId);

	mainViewDimension.css("width", mainPaneDiv.innerWidth() - DIVIDER_WIDTH + "px");
	if (isNameFrozenForDimension(mainViewDimId)) {
		mainViewTreenodeContainer.css("width", jQuery("#mainPaneDiv").innerWidth() + "px");
	}
}

function refreshBreadCrumb(type,dimArr){
	
	if (type == "multiple") {
		var argStr = "";
		// eval(dimArr);
		for (var i = 0; i < dimArr.length; i++ ) {
		  	argStr += "," + dimArr[i];
		}
		sendBreadCrumbRequest('RefreshDeltaUpdate' + argStr);
	} else if (type == "single") {
	    sendBreadCrumbRequest('RefreshDeltaUpdate,' + lastSingleKeepDimId);    
	} else if (type = "reset") { 
	   sendBreadCrumbRequest('RefreshBreadcrumbs'); 
	}
}
/**
 * Global JS variable pointing to Row Snapshot panel.
 */
var snapShotAttributesPanel = null;

function displayAttributesValues(data){
	var dim = data[1];
	var hierStr = data[2];
	var attributeValues = data[3];	
	var measureValues = data[4];	
	
	var htmlStrBuf = new StringBuffer();
	htmlStrBuf.append('<TABLE width="100%" cellpadding="2" align="center" >');
	htmlStrBuf.append('<TR><TD colspan="2" CLASS="dimTitle" WIDTH="100%">');
 	htmlStrBuf.append('<b><font face="Arial, Helvetica, sans-serif" color="#003366" size="1">');
	htmlStrBuf.append(dim+'&nbsp;&nbsp;'+hierStr);
	htmlStrBuf.append('</font></b></TD></TR>');
	htmlStrBuf.append(createSnapshotRows(attributeValues));
	htmlStrBuf.append(createSnapshotRows(measureValues));
	htmlStrBuf.append('</TABLE>');
	if ( snapShotAttributesPanel == null ) {
		snapShotAttributesPanel = new YAHOO.widget.Panel("snapShotAttributesPanel",
		 { width: "700px", fixedcenter: true, close: true, constraintoviewport: true, visible: false, modal:false } );
		var attributeHeader = '<%=bundle.getValue("ui.label.snapshot.attribute.values")%>';
		snapShotAttributesPanel.setHeader('<span class="modalHeaderStyle">'+ attributeHeader + '</span>');    
	}
	snapShotAttributesPanel.setBody(htmlStrBuf.toString());
	snapShotAttributesPanel.render(document.body);     
	snapShotAttributesPanel.show();
	snapShotAttributesPanel.bringToTop();
}

function createSnapshotRows(attributeValues){
	var htmlStrRow = new StringBuffer();		
	// Rows for Attributes
	if(attributeValues != null){
		htmlStrRow.append('<TR><TD colspan="2">&nbsp;&nbsp;</TD></TR>');	
		var valLen = attributeValues.length;			
		for (i = 0; i < valLen; i++) {
			var value = attributeValues[i];
			if(value != null){
				htmlStrRow.append('<TR><TD><b><font face="Arial, Helvetica, sans-serif" color="#003366" size="2">');
				htmlStrRow.append(value[0]);
				htmlStrRow.append('</font></b></TD><TD><font face="Arial, Helvetica, sans-serif" color="#003366" size="2">');
				htmlStrRow.append(value[1]==""?'':value[1]);
				htmlStrRow.append('</font></TD></TR>');
			}
		}		
	}
	return htmlStrRow;
}
 
function getAttributesValues(nodeId, dimId) {
	sendRequest("ShowAttributeValuesRequest," + dimId + "," + nodeId);
}

// Divider

var dividerEl;
var areEventsAttachedToDocumentBody = false;

function dividerOnMouseDown(e) {
	if (!areEventsAttachedToDocumentBody) {
		jQuery(document).bind('mousemove', dividerOnMouseMove);
		jQuery(document).bind('mouseup', dividerOnMouseUp);
		areEventsAttachedToDocumentBody = true;
	}
}

function dividerOnMouseMove(e) {
	dividerEl.style.left = e.pageX + "px";
}

function dividerOnMouseUp(e) {
    var leftEl = (mainViewRight) ? document.getElementById("leftScrollDiv") : document.getElementById("mainPaneDiv");
    var rightEl = (!mainViewRight) ? document.getElementById("leftScrollDiv") : document.getElementById("mainPaneDiv");
	// offset width is needed for IE for some weird reason
	var offsetWidth = jQuery.browser.msie ? 4 : 0;
	rightEl.style.width = jQuery(document).width() - e.pageX - offsetWidth + "px";
    rightEl.style.left = e.pageX + "px";
	leftEl.style.width = e.pageX + "px";
	adjustMainViewDimensionWidth();
	
	jQuery(document).unbind('mousemove');
	jQuery(document).unbind('mouseup');
	areEventsAttachedToDocumentBody = false;
	
	// remove selection - take care of case where text is being selected while dragging the divider
	if (window.getSelection) {
		if (window.getSelection().empty) {  // Chrome
			window.getSelection().empty();
		} else if (window.getSelection().removeAllRanges) {  // Firefox
			window.getSelection().removeAllRanges();
		}
	} else if (document.selection) {  // IE
		document.selection.empty();
	}
	
	updateAllScrollableTableSizes();
}

var DIVIDER_WIDTH = 5;
function initDivider() {
	var sliderPosition= mainViewRight ? ${leftViewPercent} : ${mainViewPercent};
	document.getElementById("treeNodeDiv").innerHTML +=   
	'<div id = "divider" class="divider" style = "position: absolute; left:' + sliderPosition + '%; width: ' + DIVIDER_WIDTH + 
	  'px; height: 100%; background: #DDDDDD; ">' +
	  '<div style = "position: absolute; left: 0px; width: 1px; height: 100%; background: #FFFFFF;"></div>' + 
	  '<div style = "position: absolute; left: 4px; width: 1px; height: 100%; background: #999999;"></div>' + 
  	'</div>';  

	jQuery("#divider").bind('mousedown', dividerOnMouseDown);
	dividerEl = document.getElementById("divider");
}

// End Divider

// Globals for dimension
var dimCount = 0;
// This GLOBAL hashmap will store all dimensions that are being rendered on the view page.
// It is used to keep track of rollup calls.
var dimensionsList = [];
// Following index is used to iterate over all dimensions. Each iteration starts the rollup AJAX call.
var dimensionIndex = 0;

var cubeRollupInProgress = false;
var hasExportPermission = ${hasExportPermission};
var hasCreateTabulationPermission = ${canCreateTabulation};
var feedbackOrCrossTab = false;
var sumPrevDimPixelHeights = 0; // When  called by renderCube in succession
var leftSideIndexToDimId = new Array(); // Lookup table from left side index to DimId
var leftSideIndexLength = 0;
var columnHeadingLinkTypes;
var columnSortableInformation;
var dimIdToDimHeight = new Array();
var dimIdToLeftSideIndex = new Array();

var dimIndexToDimId = new Array();

var debugHTML = false;
var globalBgColorShadeBlue = true;
var requestTimeout = ${minDelayInTwoSuccessiveAjaxRequests}; // In seconds
var mainViewRight = ${mainViewRight};
var progressBarEnabled = ${progressBarEnabled};
var progressBarWithPercenatageEnabled = ${progressBarWithPercenatageEnabled};
function trim(s) {
    return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}

// Returns the function name and its params as a string for calling export functionality from common export UI in commonExportUI.jsp
function getParamString(name, id, status) {
	return "javascript:exportReport('"+ name +"')";
}

// Returns header string for export ui called from commonExportUI.jsp. It depends upon module its called for.
function getHeader() {
	return "<bean:message key='ui.title.exporting.Dimensions'/>";
}

// Validate file name and numeric field.
function validate(){
	var noOfRowsToDisplay =document.getElementById("noOfRows");
	var fileName = document.getElementById("fileName");
	var nodeTypes = document.getElementById("nodeOptionsValue");
    var displayModeXls = document.getElementById("fileTypeXls");
	var message = '';
	if (IsEmptyString(fileName.value)) {
		message = "<bean:message key='ui.error.file.name.required'/>";
	} 
	if (!validateInput(fileName)) {
		if (message != '') {
			message += '\n';
		}
		message += "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + "\n  _   -";
	}
	//if XLS is selected and Specify option is selected, then only validate noOfRowsvalue.
	if (displayModeXls.checked == true && nodeTypes.value == 'Specify') {
		var bRes = IsNumeric(noOfRowsToDisplay);
		var noOfRowsvalue = trim(noOfRowsToDisplay.value);
		if (bRes == false) {
			if (message != '') {
				message += '\n';
			}
			message += "<bean:message key='ui.export.dimension.excel.error.invalid.message'/>";
		}
		
		var maxExcelRows = parseInt(<%=ExpenseMapAppProperties.getMaxDimensionPreferenceRowForExpotToExcel()%>);
		if (noOfRowsvalue > maxExcelRows) {
			if (message != '') {
				message += '\n';
			}
			message += "<bean:message key='ui.export.excel.error.maxRows.message'/>";
		}
	}

	if (message != '') {
		alert(message);
		return false;
	}
	return true;
}

function showTextBox(){
	var elt=document.getElementById("txtoveridnoofrows");
	if(elt.style.display =='none'){
		elt.style.display='block';
		elt.value=<%=com.zeborg.expensemap.util.ExpenseMapAppProperties.getMaxNoOfRowsTheUserCanSetToView()%>
	}else{
		elt.style.display='none';
		elt.value=<%=com.zeborg.expensemap.util.ExpenseMapAppProperties.getMaxNoOfRowsTheUserCanSetToView()%>
	}
} 	

// Initialize the export UI. show/hide divs. It depends upon each module which div to show/hide. called from commonExportUI.jsp
function initDiv() {
	document.getElementById("level").disabled = true;
}

// Show/hide divs upon selection of csv/excel type. called from commonExportUI.jsp
function toggleOptionDiv(fileType) {
	var dimensionOptionsDiv = document.getElementById("dimensionOptionsDiv");
	var dimensionNoOfRowsOptionsDiv = document.getElementById("dimensionNoOfRowsOptionsDiv");
	if (fileType == 'CSV') {
		dimensionOptionsDiv.style.visibility = 'visible';
		dimensionNoOfRowsOptionsDiv.style.visibility = 'hidden';
		document.getElementById("level").disabled = false;
	} else if (fileType == 'XLS') {
		dimensionOptionsDiv.style.visibility = 'visible';
		dimensionNoOfRowsOptionsDiv.style.visibility = 'visible';
		var nodeTypes = document.getElementById("nodeOptionsValue");
		if(nodeTypes.value == 'Visible')
			document.getElementById("level").disabled = true;
	}
}

// Export to CSV and Excel
function exportReport(dim){
	var theForm = document.getElementById('primaryForm');
	var type = document.getElementById("hiddenType").value;
	var noOfRowsToDisplay =document.getElementById("noOfRows");
	var level = document.getElementById("level").value;
	var fileName = document.getElementById("fileName");
		
	var numFormatObject = document.getElementById("exportNumberFormat");
	var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;
	theForm.numberFormat.value = numFormat;
	var displayModeCsv = document.getElementById("fileTypeCsv");
    var displayModeXls = document.getElementById("fileTypeXls");
	var nodeTypes = document.getElementById("nodeOptionsValue");
	
	if (validate()) {
		if (nodeTypes.value == 'Visible') {
			noOfRowsToDisplay.value = -2;
			if(displayModeXls.checked == true)
				level = -1;
		} else if (nodeTypes.value == 'All') {
			noOfRowsToDisplay.value=-1;
		} else {
			noOfRowsToDisplay=document.getElementById("noOfRows");
		}

		
		if (displayModeCsv.checked == true) {
			theForm.action = '/expensemap/Export.do?operation=exportCSV&dimension='+dim+'&level='+level + "&fileName=" +trim(fileName.value);
		} else if (displayModeXls.checked == true) {
			theForm.action = "/expensemap/Export.do?operation=exportExcel&dimension="+dim+"&noOfRowsToExport="+trim(noOfRowsToDisplay.value)+"&level="+level + "&fileName=" + trim(fileName.value) ;
		}
		theForm.method="post";
		theForm.submit();
		closeExportBox();
	}
}

//Disable No Of Rows text box for All and Visible types. 
function disableTextBox(type, obj){
 	var noOfRows = document.getElementById("noOfRows");
 	var level = document.getElementById("level");
 	document.getElementById("nodeOptionsValue").value = obj.value;
 	if (type == 'All'){
		noOfRows.disabled = true;
		level.disabled = false;
	}else if( type == 'Visible') {
		noOfRows.disabled = true;		
		level.disabled = true;		
 	} else {
		noOfRows.disabled = false; 	
		level.disabled = false;
 	}
}

function setValue(dimId,obj){
	var hiddenDimName = dimId.toUpperCase()+'_HIDDEN';
	document.getElementById(hiddenDimName).value = obj.value;
}

function showCheckBoxMenu(dimId, checkbox) {
	var menuBuffer = new StringBuffer();
	var hiddenDimName = dimId.toUpperCase()+'_HIDDEN';
	var checkVal = document.getElementById(hiddenDimName).value;
	
	var radioStr = "setValue('"+dimId+"',this);";
	var closeBtnStr = "closeRadioMenu('"+dimId+"');";
	menuBuffer.append('<table border="0" cellspacing="0" cellpadding="0" width="100%">');
  	if ( checkbox.checked ) {
	    menuBuffer.append('<tr><td colspan="2"><input type="radio" value="selectOnPage" name="checkType" id="checkType" onclick="'+radioStr+'">&nbsp;<font color="#3300ff" size="1">'+"<bean:message key='ui.label.select.on.page'/>"+'</font></td></tr>');
		menuBuffer.append('<tr><td colspan="2"><input type="radio" value="selectAcrossPage" name="checkType" id="checkType" onclick="'+radioStr+'">&nbsp;<font color="#3300ff" size="1">'+"<bean:message key='ui.label.select.across.page'/>"+'</font></td></tr>');
	} else {
	    menuBuffer.append('<tr><td colspan="2"><input type="radio" value="unselectOnPage" name="checkType" id="checkType" onclick="'+radioStr+'">&nbsp;<font color="#3300ff" size="1">'+"<bean:message key='ui.label.dselect.on.page'/>"+'</font></td></tr>');
		menuBuffer.append('<tr><td colspan="2"><input type="radio" value="unselectAcrossPage" name="checkType" id="checkType" onclick="'+radioStr+'">&nbsp;<font color="#3300ff" size="1">'+"<bean:message key='ui.label.dselect.across.page'/>"+'</font></td></tr>');	
	}
	menuBuffer.append('</table>');
	menuBuffer.append('<hr>');
	menuBuffer.append('<table border="0" cellspacing="0" cellpadding="0" width="100%">');
	menuBuffer.append('<tr><td colspan="2" align="center"><input type="button" id="nodeSelectOk" name="okBtn" class="buttonStyle" value="&nbsp;<%=bundle.getValue("button.ok")%>&nbsp;">');
	menuBuffer.append('&nbsp;');
	menuBuffer.append('<input type="button" name="cancelBtn" id="nodeSelectCancel" class="buttonStyle" value="&nbsp;<%=bundle.getValue("ui.label.Cancel")%>&nbsp;" ></td></tr>');
	menuBuffer.append('</table>');		
	
	var popupPanel = new YAHOO.widget.Panel("dialog1" , {width : "20em", close : true, modal : true, fixedcenter:true });
	popupPanel.setBody(menuBuffer.toString());
	popupPanel.render(document.body);
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	Event.onAvailable('nodeSelectOk',  function(dimId) { 
		Event.on(Dom.get('nodeSelectOk'), "click", handleCheckBoxSelection, checkbox, popupPanel );
	}, dimId, popupPanel);
	
	Event.onAvailable('nodeSelectCancel',  function(dimId) { 
		Event.on(Dom.get('nodeSelectCancel'), "click", closeRadioMenu, checkbox, popupPanel );
	}, dimId, popupPanel);
	
	Event.on(popupPanel.close, "click", closeRadioMenu, checkbox, popupPanel);
}

function closeRadioMenu(e, checkbox){
	if(checkbox.checked){
		checkbox.checked = false;
	}else{
		checkbox.checked = true;
	}
	this.hide();
	jQuery("#dialog1").remove();
	jQuery("#dialog1_mask").remove();
}

function handleCheckBoxSelection(e, checkbox){
	var dimId = getDimIdFromCheckbox(checkbox);
	var hiddenDimName = dimId.toUpperCase()+'_HIDDEN';
	/*fix for EXP-8321 : intially 'checkVal' was refered from hiddenDimName.value,
	instead of that refer the current selected value of radio buttons. */
	var checkVal = null;	
	var chkGroup = document.getElementsByName("checkType");
	for (i=0;i<chkGroup.length;i++) {
		if (chkGroup[i].checked) {
			checkVal = chkGroup[i].value;
		}
	}			
	if(checkbox.checked){
		if(checkVal == null || checkVal == '' || checkVal == 'null'){
			alert('<%=bundle.getValue("ui.label.error.option.not.selected")%>');
			return false;
		}
		if(checkVal != 'selectOnPage' && checkVal != 'selectAcrossPage'){
			alert('<%=bundle.getValue("ui.label.error.option.not.selected")%>');
			return false;
		}
	}else{
		if(checkVal == null || checkVal == '' || checkVal == 'null'){
			alert('<%=bundle.getValue("ui.label.error.option.not.selected")%>');
			return false;
		}
		if(checkVal != 'unselectOnPage' && checkVal != 'unselectAcrossPage'){
			alert('<%=bundle.getValue("ui.label.error.option.not.selected")%>');
			return false;
		}	
	}
	
	if(checkVal == 'unselectAcrossPage'){ 
		checkbox.checked = false;
		sendRequestForNodeUpdate('updateAll'+","+dimId+","+'false');
	} else if(checkVal == 'selectAcrossPage'){
		sendRequestForNodeUpdate('updateAll'+","+dimId+","+'true');
	}
	// update check-boxes
	if ( checkVal == 'unselectAcrossPage' || checkVal == 'selectAcrossPage' ) {
		var elementArray = document.forms[0].elements;
		var elementArrayLength = elementArray.length;
		for(i=0;i<elementArrayLength;i++){
			var childChkBox = elementArray[i];
			// this if check is important since there will be dim namely commodity and commodityrule
			var temp=elementArray[i].id.substr(9);
			if (temp.search("_fixed$") != -1) {
				temp=temp.substr(0,temp.lastIndexOf('_'));
			}
			temp=temp.substr(0,temp.lastIndexOf('_'));
			if( childChkBox.type=='checkbox' && temp == dimId ) {
				childChkBox.checked=checkbox.checked;
			}
		}
	} else {
		callMeBeforeRegisterNodeFilter(false, dimId, 0, -1, checkbox, true);
	}
	// reset selection
	document.getElementById(hiddenDimName).value = '';
	//hidePopWin(false);
	this.hide();
	jQuery("#dialog1").remove();
	jQuery("#dialog1_mask").remove();
}

function sendRequestForNodeUpdate(argStr){
	try {
		var url = "/expensemap/jsp/nodesAjaxProcessor.jsp?" + argStr;
		jQuery.ajax({
			url: url,
			type: "GET",
			success: nodeUpdateResponseHandler,
			error: function(xhr, status, error) {
				alert('<%=bundle.getValue("ui.message.There.was.a.problem.retrieving.data.from.server")%> ' + xhr.statusText);
				return false;				
			}
		});
		
		if(argStr.indexOf('updateAll') >= 0) {
			renderProgressBar();
		} else if(argStr.indexOf('maxNodeValidation') >= 0) {
			renderProgressBar();
		} else if(argStr.indexOf('updateSelectedNodes') >= 0) {
			renderProgressBar();
		}
	} catch(e) {
		 alert(e);
	}
}

function nodeUpdateResponseHandler(response){
	try {
		var data = eval(response);
	} catch (e) {
		if ( e.message == 'Out of memory' ) {
			alert('<%=bundle.getValue("ui.message.js.out.of.memory")%>');
		} else {
			alert('<%=bundle.getValue("ui.message.There.was.a.problem.retrieving.data.from.server")%>' + e.message);
		}
		return;
	}
	if (data == null) {
		return;
	}
	if (data[0] == "Error"){
		hideProgressBar();
		hideHourglass();
		var errorCode = data[1];
		if(errorCode == "validation.error"){
			alert("<bean:message bundle='search' locale='app.locale' key='ui.error.message.em.max.node.apply.limit' arg0='${maxLimit}'/>");
		    return;
		} else if (errorCode == "all.nodes.error") {
			alert('<%=bundle.getValue("ui.label.error.all.nodes.selected.in.filter")%>'+' '+data[2]);
		    return;
		} else if (errorCode == "session.timeout"){
			var timeoutURL = data[3];
			parent.location.href=timeoutURL;
			return;
		}
	}else if(data[0] == "updateAll"){
		hideProgressBar();			 			   
	}else if(data[0] == "updateSelectedNodes"){
		hideProgressBar();
		setCheckBoxStatus(data[1]);			 			   
	}else if(data[0] == "Success"){	
		hideProgressBar();
		var warnLmt = ${warnLimit};
		var keepType = data[1];
		var nodeListSize = data[2];
		hideHourglass();
		if(nodeListSize == 0){
			alert('<%=bundle.getValue("ui.label.Please.select.atleast.one.checkbox")%>')
			return false;
		}
		if(nodeListSize > warnLmt){
			if(confirm("<bean:message bundle='search' locale='app.locale' key='ui.message.em.max.node.apply.limit.warning'/>")){
				if(keepType == 'multikeep'){
					addMultipleFilterNodes();
				}else if(keepType == 'singlekeep'){
					/*function prototype : addSingleFilterNode(isLargeNode,dimId, treeId);*/
					addSingleFilterNode(data[3],data[4],data[5]);
				}	
			}else{
				return false;
			}
		}else{
			if(keepType == 'multikeep'){
				addMultipleFilterNodes();
			}else if(keepType == 'singlekeep'){
				/*function prototype : addSingleFilterNode(isLargeNode,dimId, treeId);*/
				addSingleFilterNode(data[3],data[4],data[5]);
			}	
		}
	}
}

/*if all level 1 checkbox are selected, select/deselect checkbox_dimid_0*/
function setCheckBoxStatus(dimId){
	var checkboxes = document.getElementsByName('chkbox_'+dimId+'_0');
	var allChecked = true;
	if(checkboxes){
		if (!checkboxes[0] ) { 
			allChecked = checkboxes.checked;
		}else{
			var chkLength = checkboxes.length;
			for( var index=0; index < chkLength; index++ ) {
				var checkboxObj = checkboxes[index];
				if(!checkboxObj.checked){
					allChecked = false;
					break;
				}
			}//end for
		}//end else	
		var dim0chkbox = document.getElementById('checkbox_'+dimId+'_0');
		if(dim0chkbox){
			dim0chkbox.checked = allChecked;
		}
	
		dim0chkbox = document.getElementById('checkbox_'+dimId+'_0_fixed');
		if(dim0chkbox){
			dim0chkbox.checked = allChecked;
		}
	}
}

/* Open Transaction Page*/
function viewTransactionData(dimension,member,includeConstraints){
    var url = "/expensemap/transaction/openTransactionReportAction.do";
	theForm = document.getElementById("viewTransactionForm");
	theForm.action = url;
	theForm.dimension.value = dimension;
	theForm.selectedNodeId.value = member;
	theForm.includeConstraints.value =includeConstraints;
    theForm.method="post";
	theForm.target = '_blank';
	theForm.submit();
	theForm.target = '_self';

}

function printDimension(dimDisplayName, dimension) {
	theForm = document.getElementById("PrintForm");
	theForm.dimension.value = dimension;
	theForm.printTitle.value=dimDisplayName;
	theForm.method="post";
	theForm.target = '_blank';
	theForm.submit();
}

/* Update main container div's height so that browser doesn't show vertical scrollbar on right side. */
function updateMainContainerDivHeight() {
	var mainContainerDiv = document.getElementById("mainContainerDiv");
	var documentHeight = jQuery(window).height();
	// don't resize if visible browser area is less than threashold
	if (documentHeight < 300) {
		return;
	}
	var mainContainerDivTop = jQuery("#mainContainerDiv").position().top;
	var newMainContainerDivHeight = documentHeight - mainContainerDivTop;
	jQuery("#mainContainerDiv").height(newMainContainerDivHeight);
	jQuery("#treeNodeDiv > div").height(newMainContainerDivHeight);
	// iframes need to be resized individually because their parents don't have position: fixed/relative
	jQuery("#feedbackDiv").height(newMainContainerDivHeight);
	jQuery("#crossTabDiv").height(newMainContainerDivHeight);
}

// MainContainerdiv should be resized on browser resize event and when cap area is toggled.
jQuery.event.add(window, "resize", updateMainContainerDivHeight);
jQuery.event.add(window, "resize", updateAllScrollableTableSizes);

jQuery("#Menu_resize").click(function () {
	// for some weird reason IE9 requires two subsequent adjustments
	updateMainContainerDivHeight();
	updateMainContainerDivHeight();
	updateAllScrollableTableSizes();
});

jQuery(document).ready(function() {
	// IE shows unnecessary vertical scrollbar for whole page, which is totally unnecessary.
	// So hide the vertical scrollbar for IE only.
	if (jQuery.browser.msie) {
		jQuery("body").css("overflow-y", "hidden");
	}
});

// Update breadcrumb area and toggleBreadcrumb icon once the page is loaded.
YAHOO.util.Event.onContentReady("toggleBreadcrumb", function () {
<% if ( zs.getIsBreadCrumbHidden() ) {	%>
	fnHideBreadCrumb();
	return;
<%  } %> 
	sendBreadCrumbRequest('RefreshBreadcrumbs');
<%	
	if(zs.getIsBreadCrumbHidden()) { 
%>
	fnHideBreadCrumb();
<%	} %>
});

YAHOO.util.Event.onDOMReady(function() {
	
	progressBar = new YAHOO.widget.Overlay("pb", { fixedcenter:true, visible:false, width:"180px" } );	
	progressBar.render(document.body); 
	sendRequest('GetRootNodesRequest');
}
);

function showBKConfirmation(confirm) {
	setTimeout(function() {
		bkConfirmation(confirm);
	}, 100);

}

function bkConfirmation(confirm) {
	var bkConfirm = new YAHOO.widget.Panel('bkConfirmationPanel', { width: '330px', height: '60px', fixedcenter: true, visible:false, draggable:false, close:false } );
	bkConfirm.setBody("<div id=bkConfirmStyle>"+confirm+"</div>");
	bkConfirm.render('bkConfirm');
	bkConfirm.show();
	bkConfirm.bringToTop();

	setTimeout(function() {bkConfirm.destroy();},1300);

}
	
</script>
</body>
</html>