<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.emptoris.viewer.reports.Category"%>
<%@ page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="java.net.URLEncoder,com.zeborg.acl.util.LocaleUtil"%>
<%@ page import="com.zeborg.util.WebUtil,org.apache.struts.util.LabelValueBean"%>
<%@ page import="com.emptoris.viewer.reports.logic.TopnReportsLogic"%>
<%@ page import="com.emptoris.viewer.reports.ReportMeta"%>
<%@ page import="java.util.*, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.acl.util.LocaleUtil" %>
<%@ page import="org.apache.struts.Globals,java.util.Locale" %>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle" %>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager" %>
<%@ page import="com.zeborg.expensemap.view.TableViewUtil,com.zeborg.expensemap.view.HelpUtil" %>
<%@ page import="com.zeborg.expensemap.model3.ExpensemapACLUtil" %>
<%@ page import="com.zeborg.util.EncodeUtil, java.util.Date,java.text.SimpleDateFormat" %>
<%@ page import="org.apache.struts.Globals" %>
<%@ page import="org.apache.commons.lang.StringUtils" %>
<%@ page import="org.owasp.esapi.ESAPI"%>
<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>

<%
	//handled PR #77271
	session.removeAttribute("reportContext");
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	pageContext.setAttribute("returnToURL","../reports/ManageTopnReportAction.do?", PageContext.SESSION_SCOPE);
    //call addtype so that UTF-8 will be set as the encoding for all jsp pages
    WebUtil.addType(response, request);
    WebUtil.addNoCache(response);    
  	Locale locale =zs.getUser().getLocale();
	boolean isAdminUser = zs.getUser().isRootUser();
	String loggedInUserId = zs.getUser().getId();
  	//request.getSession().setAttribute(Globals.LOCALE_KEY, locale);
	EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_Topn_RESOURCE_BUNDLE, locale); 
 	String helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.topreport.helpUrl", locale);	
	String isDashboard ="false";
	String showBreadcrumb="true";
	String charSet = WebUtil.getEncoding();
	String encoding = ((null == charSet)?"UTF-8":charSet);
	int rowSize = 99;
	if (zs.getExpensemapFrame().equalsIgnoreCase("expensemapFrame")) {
	    rowSize = 59;
	}
	 
	//PR#70869  
	boolean hasExportTo_CSV_OR_ExcelPermission = false;	
	if(ExpensemapACLUtil.hasExportTo_CSV_OR_ExcelPermission(zs.getUser())){
		hasExportTo_CSV_OR_ExcelPermission = true;
	}
%>
<!DOCTYPE html> 
<HTML>
<HEAD>
<TITLE><%= ExpenseMapAppProperties.getBrowserTitleSpend()%> - <bean:message key="ui.topn.title"/></TITLE>
<jsp:include page="/jsp/includes/commonHeaderIncludes.jsp"/>
<SCRIPT LANGUAGE="javascript" SRC="/expensemap/jsp/javascript/header.js"></SCRIPT>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/export.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />

<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/menu/menu-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/button/button-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/export_pdf.js" ></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js" ></script>

<style TYPE="text/css">
<!--
.reportDataElement {font-family: Verdana, Arial, Helvetica, sans-serif;font-size:12px;font-weight:normal;
color:#0C209B;text-align: left;}
.reportTableHeader{font-family: Verdana, Arial, Helvetica, sans-serif;font-size:12px;font-weight:normal; 
color: #FFFFFF;text-align: center;}
.reportTitle {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-weight: bold;
color: #FFFFFF;}
.tdStyle{font-family:Verdana, Arial, Helvetica, sans-serif;font-size: 13px;font-weight: bold;
color:#342D7E;}
.errordisplay{font-family: Arial, Helvetica, sans-serif;font-size: 10pt;font-style: normal;
color: Red;font-weight : bold;}
.clearElement { height: 0; width: 0; clear: both; }
form { padding:0; margin: 0; }
-->


.reportTitle {font-family: Helvetica Neue Bold for IBM, Helvetica, Arial, sans-serif ;font-size: 14px;font-weight: bold;
color: #464646;}
.reportTableHeader{font-family: Helvetica Neue Roman for IBM, Helvetica, Arial, sans-serif ;font-size:12px;font-weight:normal; 
color: #464646;text-align: center;}


.titleStyle{font-family:Helvetica Neue Roman for IBM, Helvetica, Arial, sans-serif  ;font-size: 18px;font-weight: normal;
color:#464646;}
.reportDataElement {font-family: Verdana, Arial, Helvetica, sans-serif;font-size:12px;font-weight:bold;
color:#464646;text-align: left;}

#topReportsTable tr:hover {
    background-color:#bfd6eb;
}

</style>

<script>

$('#topReportsTable tr').hover(function() {
    $(this).addClass('hover');
}, function() {
    $(this).removeClass('hover');
});

var selectTypeVar;
window.select_current = new Array();
var ownerUserId = "";
function preOpenExportBox (reportName, crId, status,reportTypeId, remoteId, bookmarkId,analyticId,creatorUserId) {
	ownerUserId = creatorUserId;
	openExportBox(reportName, crId, status,reportTypeId, remoteId, bookmarkId,analyticId);
}
function setPrevSelectValue(obj){
	 window.select_current[obj.id] = obj.selectedIndex;
}
function selectType(selectTag) {	
	if (selectTag.options[selectTag.selectedIndex].disabled) { 
	       selectTag.selectedIndex = window.select_current[selectTag.id]; 
	    }else{			
			window.select_current[selectTag.id] = selectTag.selectedIndex;
			selectTypeVar = selectTag.value;
	    }
	 
}


function optionSelected() {	
    var  flag= true;
	var i;
	
	if (selectTypeVar == "BasicAnalytics") {
    	/*document.write("<frameset rows='<%= rowSize %>,*' border='0' >");
		document.write("<frame src='../jsp/breadCrumb.jsp?viewSelected=analytic&isDashboard=false&showBreadcrumb=false' scrolling='no' marginwidth='1' marginheight='1' >");
		document.write("<frame src='/expensemap/analytic/CreateNewAnalyticAction.do?isFromTopreport=true' scrolling='yes'  marginwidth='1' marginheight='1' >");
		document.write("</frame>");*/
		var frm = document.editTopnForm;
		frm.target = '_self';
		frm.method = "post";
    	frm.action = "/expensemap/analytic/CreateNewAnalyticAction.do?isFromTopreport=true";
    	frm.submit();
	}else if (selectTypeVar == "TrendAnalytics") {    	
		var frm = document.editTopnForm;
		frm.target = '_self';
		frm.method = "post";
    	frm.action = "/expensemap/analytic/trendAnalyticAction.do?operation=getTimeDimention&isFromTopreport=true";
    	frm.submit();
	}else if (selectTypeVar == "TopnAnalytics") {
		var frm = document.editTopnForm;
		frm.target = '_self';
		frm.method = "post";
    	frm.action = "/expensemap/analytic/topnAnalyticAction.do?operation=getCategory&isFromTopreport=true";
    	frm.submit();
	}
	if (selectTypeVar == "CrossTab") {
		var frm = document.editTopnForm;
		frm.target = '_self';
		frm.method = "post";
    	frm.action = "/expensemap/getDimensionalView.do?target=<%=zs.getExpensemapFrame()%>&theAction=chartCrossTabOn&topReport=true";
    	frm.submit();
    }
}

function exportTopnCrossTabHtml(remoteId,bookmarkId,title,statusId,creatorUserId) {
	if(statusId == <%=ReportMeta.STATUS_COMPLETED %>  || statusId == <%=ReportMeta.STATUS_STALE %> || statusId == <%=ReportMeta.STATUS_INVALID %>) {
		// if remoteId is -1 re generate that crosstab.
		if(remoteId <= 0){
			var adminUser = <%= isAdminUser%>;
			var loggedInUserId = '<%= loggedInUserId %>';
			if(adminUser && (loggedInUserId!=creatorUserId)){
				// change message key
			    alert("<bean:message key='ui.alertmsg.regenerate.analytics.adminuser' />");
				return false;
			}
			if (confirm("<bean:message key='ui.alertmsg.regenerate.analytics'/>")){
				showHourglass();
				var frm = document.getElementById("editTopnForm");
				frm.method="post";
				frm.action="/expensemap/crosstab/regenerateCrosstabAction.do?bookmarkId="+bookmarkId;
				frm.target="_self";
				frm.submit();
			} else {
				return false;
			}
		} else {
			var currentTime = new Date();
	    	var milliSeconds = currentTime.getTime();
	    	var ht = 500;
			var wt = 850;
			var left = (screen.width/2)-(wt/2);
			var top = (screen.height/2)-(ht/2);
	    	var newWindow = window.open("",'topn_'+remoteId+milliSeconds,
	 		"menubar=0,toolbar=0,status=1,location=0,height="+ht+",width="+wt+",resizable=1,scrollbars=1,left="+left+",top="+top);
	 		var theForm = document.getElementById('editTopnForm');
	 		theForm.operation.value='exportTopnHtml';
	 		theForm.exportChartType.value='exportTopnHtml';
	 		theForm.exportChartId.value=remoteId;
	 		theForm.target = 'topn_'+remoteId+milliSeconds;
	 		theForm.action="/expensemap/reports/ManageTopnReportAction.do?bookmarkId="+bookmarkId;
	  		theForm.submit();
		}
 	} else {
		alert("<bean:message key='ui.alert.report.not.completed' />");
   		return false;
   	} 	
}
 
// Export Tabulation top report to excel.
function exportTopnCrossTabExcel(remoteId,bookmarkId,statusId, anaReportId){
	if(statusId == <%=ReportMeta.STATUS_COMPLETED %>  || statusId == <%=ReportMeta.STATUS_STALE %> || statusId == <%=ReportMeta.STATUS_INVALID %>) {
		// if remoteId is -1 re generate that crosstab.
		if(remoteId <= 0){
			var adminUser = <%= isAdminUser%>;
			var loggedInUserId = '<%= loggedInUserId %>';
			if(adminUser&& (loggedInUserId!=ownerUserId)){
				// change message key
			    alert("<bean:message key='ui.alertmsg.regenerate.analytics.adminuser' />");
				return false;
			}
			if (confirm("<bean:message key='ui.alertmsg.regenerate.analytics'/>")){
				showHourglass();
				var frm = document.getElementById("editTopnForm");
				frm.method="post";
				frm.action="/expensemap/crosstab/regenerateCrosstabAction.do?bookmarkId="+bookmarkId;
				frm.submit();
			} else {
				return false;
			}
		} else {
			var theForm = document.getElementById('editTopnForm');
			theForm.operation.value='exportCrossTabExcel';
			theForm.exportChartType.value='exportCrossTabExcel';
			theForm.exportChartId.value=remoteId;
			// 42149 
				
			var fileName = document.getElementById("fileName");
			var numFormatObject = document.getElementById("exportNumberFormat");
			var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;
			theForm.numberFormat.value = numFormat;			
			var fName = trim(fileName.value);
			var displayModeXls = document.getElementById("fileTypeXls");
			var displayModeXlsx = document.getElementById("fileTypeXlsx");
			//method in commons.js
			if (validateFileName(fileName, "<bean:message key='ui.error.file.name.required'/>", "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + '\n  _   -')) {
				if ( displayModeXls.checked == true ) {
					theForm.action = "/expensemap/Export.do?operation=exportCrossTabExcel&type=CrossTab&includeConstraints=true&ctId="+remoteId+"&bkmrkId="+bookmarkId + "&userInputFileName=" + fName ;
				}else if ( displayModeXlsx.checked == true ) {
	    			if(isExportable(remoteId)){
	    				theForm.action = "/expensemap/Export.do?operation=exportCrossTabExcelx&type=CrossTab&includeConstraints=true&ctId="+remoteId+"&bkmrkId="+bookmarkId + "&userInputFileName=" + fName ;
	    			} else{
	    					alert("<bean:message key='ui.message.use.export.option.xls.for.tabulation'/>  ");
							return;
	    				  }
	  				}
				theForm.submit();
				closeExportBox();
			}
		}
 	} else {
		alert("<bean:message key='ui.alert.report.not.completed' />");
   		return false;
   	}
}

function isExportable(ctid) {
	try {
		var url = "/expensemap/checkExportXlsxCrosstabAction.xhtm";			
		var ajaxResponse = eval(jQuery.ajax({
									url: url,
									type: "GET",
									data: {ctid: ctid},
									async: false
								}).responseText); 
		if (ajaxResponse[0]=="TRUE") {
			return true ;
		} else {
			return false ;
		} 
	} catch(e) {
		return false ;
	}
}
// Export Analytic top report to excel.
function exportTopnAnalyticExcel(remoteId, bookmarkId, statusId, anaReportId) {
	if(statusId == 3) {
		// if remoteId is -1 re generate that analytics.
		if(remoteId < 0){
			var adminUser = <%= isAdminUser%>;
			var loggedInUserId = '<%= loggedInUserId %>';
			if(adminUser&& (loggedInUserId!=ownerUserId)){
				// change message key
			    alert("<bean:message key='ui.alertmsg.regenerate.analytics.adminuser' />");
				return false;
			}
			if (confirm("<bean:message key='ui.alertmsg.regenerate.analytics'/>")){
				showHourglass();
				var frm = document.getElementById("editTopnForm");
				frm.method="post";
				frm.action="/expensemap/analytic/regenerateAnalyticsAction.do?topReportRequest=true&reportId="+anaReportId;
				frm.submit();
			} else {
				return false;
			}
		} else {
			var theForm = document.getElementById('editTopnForm');
			var fileName = document.getElementById("fileName");
			var fName = trim(fileName.value);

			var numFormatObject = document.getElementById("exportNumberFormat");
			var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;
			theForm.numberFormat.value = numFormat;			
			
			//method in commons.js
			if (validateFileName(fileName, "<bean:message key='ui.error.file.name.required'/>", "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + '\n  _   -')) {
				theForm.action = "/expensemap/analytic/topReportAnaExportExcel.do?reportId="+anaReportId+"&reportName="+ fName;
				theForm.submit();
				closeExportBox();
			}
		}
 	} else {
		alert("<bean:message key='ui.alert.report.not.completed' />");
   		return false;
   	}
}

// Export Analytic top report to HTML.
function exportTopnAnlyticHtml(bookmarkId,title,statusId,remoteId, anaReportId,creatorUserId){
	if(statusId == <%=ReportMeta.STATUS_COMPLETED %> ) {
		// if remoteId is -1 re generate that analytics.
		if(remoteId < 0){
			var adminUser = <%= isAdminUser%>;
			var loggedInUserId = '<%= loggedInUserId %>';
			if(adminUser && (loggedInUserId!=creatorUserId)){
				
			    alert("<bean:message key='ui.alertmsg.regenerate.analytics.adminuser' />");
				return false;
			}
			if (confirm("<bean:message key='ui.alertmsg.regenerate.analytics'/>")){
				showHourglass();
				var frm = document.getElementById("editTopnForm");
				frm.method="post";
				frm.action="/expensemap/analytic/regenerateAnalyticsAction.do?topReportRequest=true&reportId="+anaReportId;
				frm.target="_self";
				frm.submit();
			} else {
				return false;
			}
		} else {
			var theForm = document.getElementById('editTopnForm');
			theForm.target = '_blank';
			theForm.action = "/expensemap/analytic/topReportAnaExportHtml.do?reportId="+anaReportId;
			theForm.submit();
		}
 	} else {
		alert("<bean:message key='ui.alert.report.not.completed' />");
   		return false;
   	}
}
function viewBookMark(bkid){
	open('/expensemap/getDimensionalView.do?viewSelected=dimension&bkid=' + bkid, '_self', 'resizable=yes,width=1000,height=470' );
}
/**
 * This JS function renders a selected dashboard.
 */
function renderDashboard(dashboardid){     
	open("/expensemap/dashboards/renderDashboard.do?dashBoardId="+dashboardid, '_self', 'resizable=yes,width=1000,height=470' );   
}

function showHourglass() {
	document.body.style.cursor = 'wait';    
	var s = document.getElementById('hourGlassPane').style;
	s.cursor = 'wait';
	s.visibility = 'visible';
	s.opacity = 1;
    s.filter = 'alpha(opacity=.9)';	
}

//Returns the cursor to the default pointer
function hideHourglass(){
	document.getElementById('topReportType').focus();
	document.body.style.cursor = 'default';
	var s = document.getElementById('hourGlassPane').style;
	s.visibility = 'hidden';
}

function refreshPage(){
	var frm = document.getElementById("editTopnForm");
	frm.method="post";
	frm.action="/expensemap/reports/ManageTopnReportAction.do?prefix=/reports";
	frm.target="_self";
	frm.submit();
}

// Returns the function name and its params as a string for calling export functionality from common export UI in commonExportUI.jsp
function getParamString(name, id, status, reportTypeId, remoteId, bookmarkId,analyticId) {
	if (reportTypeId == 1) {
		document.getElementById("reportType").value = "1";
		return "javascript:exportTopnCrossTabExcel('" + remoteId + "','" + bookmarkId + "','" + status + "', 'null')";
	} else if (reportTypeId == 2) {
		document.getElementById("reportType").value = "2";
		return "javascript:exportTopnAnalyticExcel('" + remoteId + "','" + bookmarkId +"','" + status + "', '"+ analyticId + "')";
	}
}

// Returns header string for export ui called from commonExportUI.jsp. It depends upon module its called for.
function getHeader(reportTypeId) {
	if (reportTypeId == 1) {
		return "<bean:message key='ui.title.exporting.tabulation'/>";
	} else if (reportTypeId == 2) {
		return "<bean:message key='ui.title.exporting.Analyitc'/>";
	}
	
}

// Show/hide divs upon selection of csv/excel type. called from commonExportUI.jsp
function toggleOptionDiv(fileType) {
	if (document.getElementById("fileTypeXlsx").checked ){
		document.getElementById("drNumberFormat").style.display = "none";
		document.getElementById("lableNumberFormat").style.display = "none";
		document.getElementById("trNumFormat").style.display = "none";
	}else{
		document.getElementById("drNumberFormat").style.display = "block";
		document.getElementById("lableNumberFormat").style.display = "block";
		document.getElementById("trNumFormat").style.display = "table-row";
	}
}

// Initialize the export UI. show/hide divs. It depends upon each module which div to show/hide. called from commonExportUI.jsp
function initDiv() {
	var dimensionOptionsDiv = document.getElementById("dimensionOptionsDiv");
	var dimensionNoOfRowsOptionsDiv = document.getElementById("dimensionNoOfRowsOptionsDiv");
	dimensionOptionsDiv.style.visibility = 'hidden';
	dimensionNoOfRowsOptionsDiv.style.visibility = 'hidden';
	document.getElementById("fileTypeCsv").disabled=true;
	document.getElementById("fileTypeXlsx").checked=true;
	document.getElementById("drNumberFormat").style.display = "none";
	document.getElementById("lableNumberFormat").style.display = "none";
	document.getElementById("trNumFormat").style.display = "none";
	if(document.getElementById("reportType").value=='1'){
		document.getElementById("fileTypeXlsxSpan").style.display = "block";
	}
}

// Returns level by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
function getLevelsBydimId(dimId) {
	return 0;
}

//Returns no of rows by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
function getNoOfRowsBydimId(dimId) {
	return 0;
}

</script>
<SCRIPT LANGUAGE="javascript" SRC="/expensemap/jsp/reports/javascript/reportutil.js"></SCRIPT>
</HEAD>
<body onload="hideHourglass();" class="yui-skin-sam">

<% CubeUtil.buildExpMapMastHead(out,"listtopn.jsp",zs,true,null,locale,null); %>
 <jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="helpUrl" value="<%=helpURL%>"/>
 </jsp:include> 
<div class="clearElement"></div>
<html:form styleId="editTopnForm" action="/ManageTopnReportAction">
<jsp:include page="/jsp/includes/commonExportUI.jsp"/>
<html:hidden property="operation" styleId="operation" />	
<html:hidden property="exportChartType" styleId="exportChartType"/>
<html:hidden property="exportChartId" styleId="exportChartId"/>
<logic:messagesPresent message="true">
<table border="0" width="98%">
<tr>
	<td align="center">	 
        <html:messages id="error" message="true"> 
	      <font class="errordisplay" color="red" size="3"><%=pageContext.findAttribute("error")%></font>
        </html:messages> 
	
</td></tr>
</table>
</logic:messagesPresent>
	
	<DIV ID = "hourGlassPane" STYLE = "position: absolute; left: 0px; top: 0px; width: 100%; height: 100%; background: #FFFFFF; visibility: hidden;"> </DIV>





<table width="100%"  border="0" cellspacing="0" cellpadding="5" bgcolor="#ffffff">
      <tr><td width="100%">
	  <table width="100%"  border="0" cellspacing="0">
	   <tr>
	   <td colspan="5" nowrap>
	   <img src="/expensemap/jsp/images/transparent.gif" height=1 width="5" border="0">
		</td>
	   <td align="right">&nbsp;</td>
	  </tr>
	  <logic:match name="editTopnForm" property="canCreateTopReports" value="true">
	  <tr>
	  
	  <td align="right" colspan="10" class="tdStyle"><b><bean:message key ='ui.topreport.type.Select.Type'/><b>
	  <html:select property="topReportType"  styleId="topReportType" size="1"  onchange="selectType(this);" onfocus="setPrevSelectValue(this)" >
 		   			<html:option value="Select"><bean:message key ='ui.label.Select'/> </html:option>
 		   			<%if(ExpensemapACLUtil.hasCreateTabulationPermission(zs.getUser(),zs.getDataSet())) {%>
						<html:option value="CrossTab"> <bean:message key ='ui.topreport.type.crosstab'/></html:option>
					<%}%>
					<logic:match name="editTopnForm" property="canCreateAnalyticsReports" value="true">
					<logic:match name="editTopnForm" property="canViewAnalyticsReports" value="true">
					<option value="Select" disabled style="color:graytext"><bean:message key ='ui.topreport.type.analytics'/></option>					
						<html:option value="BasicAnalytics"> &nbsp;&nbsp;<bean:message key ='ui.analytic.menu.create.new.basic'/></html:option>
                        <html:option value="TopnAnalytics"> &nbsp;&nbsp;<bean:message key ='ui.analytic.search.report.Topn'/></html:option>
						<html:option value="TrendAnalytics"> &nbsp;&nbsp;<bean:message key ='ui.analytic.search.report.Trend'/></html:option>
					</logic:match>
					</logic:match>
	  </html:select>
		</td>
	  </tr>
	 <tr>
			<td align="left" class="titleStyle" style="text-align: left;padding: 0 46px; !important"><bean:message key="ui.label.TopReports"/></td>
		   <td colspan="5"><img src="/expensemap/jsp/images/transparent.gif" height="36" border="0"></td>
		   <td align="right" nowrap>		   				   			
	   			<input type="button" style="background: url('/expensemap/jsp/nav_images/<%=LocaleUtil.getLocaleLanguage(locale)%>/create_new_report_bar.gif'); background-repeat: no-repeat; border: 0 none; height: 36px; width: 306px;" onclick="optionSelected();" >		   	
		   	</td>
	  </tr>
	  <tr></tr>
	 </logic:match>	
	</table>
	 </td></tr>
	 <tr><td width="100%">
	 <br>
	 <table width="100%"  border="0" cellspacing="0">
  <logic:notEmpty name="editTopnForm" property="categories">
  <logic:iterate id="item" name="editTopnForm" property="categories" 
					type="com.emptoris.viewer.reports.Category[]">
  <tr valign="top">
<%
    for(int j=0; j < item.length; j++)
    {
    	String strLocalizedDispName = "";
		if(StringUtils.isEmpty(item[j].getLocaleDisplayName()))
			strLocalizedDispName = bundle.getValue("ui.label."+ item[j].getDisplayName().toLowerCase().replaceAll(" ", "."));
		else
			strLocalizedDispName = item[j].getLocaleDisplayName();
%>
     <td width="40">&nbsp;</td>
     <td>
      <table width="100%"  border="0" cellspacing="0" cellpadding="0">
	      <tr>
	        <td valign="bottom"><table width="100%" height="25" border="0" cellpadding="0" cellspacing="0">
	          <tr>
	           <td  height="45"  bgcolor="#e0e0e0" class="reportTitle">&nbsp;&nbsp;&nbsp;<%=strLocalizedDispName%></td>
	          </tr>
	        </table>
	       </td>
	      </tr>
		  
		  <tr>
	        <td valign="bottom"><table width="100%" height="25" border="0" cellpadding="0" cellspacing="0" style="border: 1px;border-color: #cccccc;border-style: solid; border-bottom: none;">
	          <tr bgcolor="#ffffff" height="45" >
			            <td align="center"  width="70%" class="reportTableHeader" style="text-align: left;padding: 0 25px; !important"><bean:message key="ui.report.table.header.name"/></td>
			            <td valign="center" width="30%" colspan="2" class="reportTableHeader"><bean:message key="ui.report.table.header.export"/></td>
			           </tr>
	        </table>
	       </td>
	      </tr>
		  
	      <tr>
		   
	        <td valign="top" style="border: 1px;border-color: #cccccc;border-style: solid;">
	          <table width="100%"  border="0"  cellspacing="0" cellpadding="0" bgcolor="#FFFFFF">
	          <tr>
	            
	            <td width="100%" valign="top">     
                   <DIV ID="topnList<%= item[j].getName()%>" 
					       style="overflow:auto; 
					             margin-top:0;
					             margin-bottom:0;
					             margin-left:0;
					             margin-right:0;
					             position:relative;
					             height:180;">
					   <table width="100%" border="0" cellspacing="1" cellpadding="0" id="topReportsTable">
					   
	<%
	                     int colorIndex = 1;
	%>		 
						<logic:iterate id="rptItem" 
						                name="editTopnForm"
						                property='<%= "topNReportsMap(" + item[j].getName() + ")"%>' 
										type="com.emptoris.viewer.reports.TopnReportMeta">
						 <tr bgcolor='<%= ((colorIndex++)%2 == 0)?"#ffffff":"#f2f2f2"%>' height="45">
						    <td valign="center" width="70%" nowrap>
							    <table width="100%"  border="0" cellspacing="0" cellpadding="0" >
								    <tr>
								    <!-- begin ugly logical looping -->
								    <td align="right" width="5%">
								      <logic:match name="rptItem" property="bookmarkHasMultilpeKeep" value="true">
								        <img src="/expensemap/jsp/images/report/reports_icon_multi_keep.gif" border="0">
								      </logic:match>
								    </td>
								    <td align="left" width="5%">
								     <logic:match name="editTopnForm" property="hideOwnerIcon" value="true">
								       <logic:match name="rptItem" property="affectedByDataRefresh" value="true">
								      		<img src="/expensemap/jsp/images/report/reports_icon_data_refreshed.gif" title='<bean:message key="crosstab.refreshed.filters"/>' border="0">
								      	</logic:match>
								      	<logic:notMatch name="rptItem" property="affectedByDataRefresh" value="true">
									      	<%if(rptItem.isPrivateReport()) { %>
									      		<img src="/expensemap/jsp/images/report/private_reports_icon.jpg" border="0" title="<bean:message key='ui.topn.Private.Top.Report'/>">								      		
									      	<% } else { %>
									      		<img src="/expensemap/jsp/images/report/reports_icon.gif" border="0" title="<bean:message key='ui.topn.Top.Report'/>">
									      	<% } %>
								      	</logic:notMatch>
								      </logic:match>
								      <logic:notMatch name="editTopnForm" property="hideOwnerIcon" value="true">
								        <logic:match name="rptItem" property="affectedByDataRefresh" value="true">
								            <logic:match name="rptItem" property="createdByRoot" value="true">
								      			<img src="/expensemap/jsp/images/report/reports_icon_data_refreshed.gif" title='<bean:message key="crosstab.refreshed.filters"/>' border="0">
								      		</logic:match>
								      		<logic:notMatch name="rptItem" property="createdByRoot" value="true">
								      			<img src="/expensemap/jsp/images/report/reports_custom_icon_data_refreshed.gif" border="0">
								      		</logic:notMatch>
								      	</logic:match>
								      	<logic:notMatch name="rptItem" property="affectedByDataRefresh" value="true">
								            <logic:match name="rptItem" property="createdByRoot" value="true">
								      			<%if(rptItem.isPrivateReport()) { %>
								      				<img src="/expensemap/jsp/images/report/private_reports_icon.jpg" border="0" title="<bean:message key='ui.topn.Private.Top.Report'/>">								      		
										      	<% } else { %>
										      		<img src="/expensemap/jsp/images/report/reports_icon.gif" border="0" title="<bean:message key='ui.topn.Top.Report'/>">
										      	<% } %>
								      		</logic:match>
								      		<logic:notMatch name="rptItem" property="createdByRoot" value="true">
								      			<img src="/expensemap/jsp/images/report/reports_custom_icon.gif" border="0">
								      		</logic:notMatch>
								      	</logic:notMatch>
								      </logic:notMatch>
								    </td>
								    <!-- end ugly logical looping -->

									<td valign="center" width="76%" class="reportDataElement">
											<c:out value="<%=rptItem.getName()%>"/>
									</td>	
									<td align="right" width="14%">
								     <!-- Show in progress icon & refresh button, only for xtab and analytics.  -->				
								      <%if((rptItem.getReportTypeId() == 1 || rptItem.getReportTypeId() == 2) && 
											(rptItem.getStatusId()== ReportMeta.STATUS_PENDING || rptItem.getStatusId() == ReportMeta.STATUS_PROCESSING || rptItem.getStatusId() == ReportMeta.STATUS_SUBMITTED) ){%>				     
											<img src="/expensemap/jsp/images/report/in_progress.gif" border="0" title='<bean:message key="ui.label.report.generation.progress"/>'>&nbsp;&nbsp; 									      										      	
									      	<a href="javascript:void(0);" onclick="refreshPage();"><img src="/expensemap/jsp/images/report/refresh_icon.gif" border="0" title='<bean:message key="ui.label.title.refresh.status"/>'> </a>
									  <%} else {%>
									  		&nbsp;
									  <%}%>  
								    </td>										
									</tr>
								</table>
							</td>
							
							
		              <!--  export to excel -->
						   <%
						   boolean enableLink = false;
						   if(rptItem.getStatusId() == ReportMeta.STATUS_COMPLETED  ||  rptItem.getStatusId() == ReportMeta.STATUS_INVALID || rptItem.getStatusId() == ReportMeta.STATUS_STALE){
							    enableLink =true;
						   }
						    %>						 
						   <%if(rptItem.getReportTypeId() == 1){
							// 42149
							// 4718 escape apostrophe
						   	String title = ESAPI.encoder().encodeForHTML(TableViewUtil.decode(rptItem.getName()));	
						   %>
						   <c:if test="${ExportPermission}">						
						    <td align="center" width="15%">
								<% if (enableLink) { %><A HREF="javascript:void(0);" onclick="preOpenExportBox('<esapi:js><%=title%></esapi:js>', 'null', '<%=rptItem.getStatusId()%>', '<%=rptItem.getReportTypeId()%>','<%=rptItem.getRemoteId()%>','<%=rptItem.getBookmarkId()%>','null','<%=rptItem.getCreatorId()%>')" > <% } %>
								    <img src="/expensemap/jsp/images/icon_export_to_excel.gif" border="0" alt='<bean:message key="ui.label.export.to.excel"/>'>
								<% if (enableLink) { %> </A> <% } %>
							</td>
							</c:if>
							<td align="center" width="15%">
								<% if (enableLink) { %><A HREF="javascript:void(0);" onclick="exportTopnCrossTabHtml('<%=rptItem.getRemoteId()%>','<%=rptItem.getBookmarkId()%>','<esapi:js><%=title%></esapi:js>','<%=rptItem.getStatusId()%>','<%=rptItem.getCreatorId()%>')"> <% } %>
									<img src="/expensemap/jsp/images/icon_export_to_html.gif" border="0" title='<bean:message key="ui.topn.tooltip.export.to.html"/>'>
								<% if (enableLink) { %></A> <% } %>
							</td>
						  <%}else if(rptItem.getReportTypeId() == 2){
							  // 42149
							  // 4718 escape apostrophe
							  String title = ESAPI.encoder().encodeForHTML(rptItem.getName());							 					        
						  %>
							<c:if test="${ExportPermission}">
							<td align="center" width="15%">
								<A HREF="javascript:void(0);" onclick="preOpenExportBox('<esapi:js><%=title%></esapi:js>', 'null', '<%=rptItem.getStatusId()%>', '<%=rptItem.getReportTypeId()%>','<%=rptItem.getRemoteId()%>','<%=rptItem.getBookmarkId()%>','<%=rptItem.getAnaltyicsReportId()%>','<%=rptItem.getCreatorId()%>')">
									<img src="/expensemap/jsp/images/icon_export_to_excel.gif" border="0" title='<bean:message key="ui.label.export.to.excel"/>'>
								</A>								
							</td>
							</c:if>
							<td align="center" width="15%">
								<A HREF="javascript:void(0);" onclick="exportTopnAnlyticHtml('<%=rptItem.getBookmarkId()%>','<esapi:js><%=title%></esapi:js>','<%=rptItem.getStatusId()%>','<%=rptItem.getRemoteId()%>','<%=rptItem.getAnaltyicsReportId()%>','<%=rptItem.getCreatorId()%>')">
									<img src="/expensemap/jsp/images/icon_export_to_html.gif" border="0" title='<bean:message key="ui.topn.tooltip.export.to.html"/>'>
								</A>
 							</td>
						  <% } else if(rptItem.getReportTypeId() == 3) { %> 						
 								<td colspan="2" align="center" width="30%"><a href="javascript:void(0);" onclick="viewBookMark('${rptItem.bookmarkId}');" title='<%=rptItem.getName()%>'><bean:message key="ui.label.bookmark" /></a></td>
 						  <% } else if(rptItem.getReportTypeId() == 4) { %> 
 						  		<logic:match name="editTopnForm" property="canViewDashboardTopReports" value="true">						
 									<td colspan="2" align="center" width="30%"><a href="javascript:void(0);" onclick="renderDashboard('${ rptItem.dashboardId }');" title='<%=rptItem.getName()%>'><bean:message key="ui.dashboard.pdf.list.type.dashboard" /></a></td>		
 								</logic:match>
 								<logic:match name="editTopnForm" property="canViewDashboardTopReports" value="false">						
 									<td colspan="2" align="center" width="30%"><span title='<bean:message key="ui.error.topn.report.no.permission.to.view.dashboard"/>'><bean:message key="ui.dashboard.pdf.list.type.dashboard" /></a></span></td>
 								</logic:match>
						  <%} else {%>
						  		<td align="center" width="15%">&nbsp;</td>
						  		<td align="center" width="15%">&nbsp;</td>
						  <%} %>
						 					    
						    </tr>										        
						</logic:iterate>
						</table>
					 </DIV>
	            </td>
	            
	          </tr>
	          <tr>
	           
	           
	            
	          </tr>
	        </table>
	        </td>
	      </tr>
     </table>
    </td>
<%
     if(item.length == 1)
     {
%>
        <td width="40">&nbsp;</td>
        <td>&nbsp;</td>
<%
     }
   } //end for-loop
 
%>
      <td width="40">&nbsp;</td>
  </tr>
  <tr>
    <td width="40">&nbsp;</td>
    <td>&nbsp;</td>
    <td width="40">&nbsp;</td>
    <td>&nbsp;</td>
    <td width="40">&nbsp;</td>
  </tr>
</logic:iterate>
</logic:notEmpty>
</table>
</td></tr>
</table>
<input type="hidden" id="reportType" name="reportType" value=""/>
<input id="exportTitle" type="hidden" name="exportTitle">
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
<input type="hidden" name="numberFormat" value="" />
</html:form>
</BODY>
</HTML>
