<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@page import="java.util.Locale"%>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@page import="com.zeborg.expensemap.view2.ZSession"%>
<%@include file="/jsp/includes/tlib.jspf"%>
<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	Locale locale = zs.getUser().getLocale();

%>
<fmt:setBundle basename="ExpensemapMessagesBundle" />
<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/macromap.css">
<html:html>
<HEAD><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">

<TITLE><%= ExpenseMapAppProperties.getBrowserTitleSpend()%> - <fmt:message key='ui.label.Transactions' /></TITLE>
<jsp:include page="/jsp/includes/commonHeaderIncludes.jsp" />
<script language="javascript">
function closeButton() {
	theAction = document.getElementById("theAction").value;
	
	if(theAction == "seeTransactions"){
	    
		window.close();
	}else{
		
		window.parent.close();
	}
}

function disableLink(){
	var parentDocObj = window.parent.document;
	obj = parentDocObj.getElementById("icons");
	obj.style.display="none";
}
</script>
</head>
<body>
<form name="failForm" id="failForm">
<center>
<logic:equal name="viewTransactionForm" property="errorName" value="preferenceTransactionColumnsNotExist">
	<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>

	<style type="text/css">
		<!--
		.topMenu { font-family:Arial,Helvetica,sans-serif; font-size:10px; color:#003366; font-weight:bold; }
		.mainMenu { font-family:Arial,Helvetica,sans-serif; font-size:12px; color:#FFFFFF; }
		.system-message { font-family:Arial,Helvetica,sans-serif; font-size:10px; color:#FF0000; align:center;}
		A { color:#0000FF; text-decoration:none; }
		A:LINK { color:#0000FF; text-decoration:none; }
		A:ACTIVE { color:#FF0000; text-decoration:underline; }
		A:VISITED { color:#0000FF; text-decoration:none; }
		A:HOVER { color:#0000FF; text-decoration:underline; }
		-->
	</style>
	<TABLE CELLSPACING="0" CELLPADDING="0" BORDER="0" WIDTH="100%" BGCOLOR="#FFFFFF">
	 <TR align="center" ><TD align="center" width="99%"><FONT color="#003366" size="4"><B><bean:message key="ui.label.Transactions"  bundle="emSrcMessages"/></B></FONT>&nbsp;</TD>
	 <TD align="left"><A id="help" TARGET="_blank" HREF="<%=HelpUtil.getHelpUtil().getHelpURL("view_transactions", zs.getUser().getLocale())%>"><IMG SRC="../jsp/cap_area/btn_help_up.gif" WIDTH="22" HEIGHT="22" BORDER="0" title="<bean:message key='ui.label.Help'  bundle='emSrcMessages'/>"></A></TD>
	 </TR>

	 <TR colspan="1" ><TD><img src="/expensemap/jsp/images/transparent.gif" width="1" height="6"></TD></TR>

	 <TR colspan="1"><TD ALIGN="center" CLASS="warning" ><fmt:message key ='ui.label.There.are.no.transaction.columns.defined.in.your.preferences'/></TD></TR>

	 <TR colspan="1"><TD ALIGN="center" CLASS="warning" >
	 <fmt:message key ='ui.label.Please.go.to.the.transaction.tab.in.preferences.and.add.transaction.columns.to.the.Transaction.Fields.Displayed.list'/>
	 </TD></TR>
	</TABLE>
</logic:equal>
<logic:equal name="viewTransactionForm" property="errorName" value="transactionColumnLevelPermissionNotExist">
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>

	<TABLE CELLSPACING="0" CELLPADDING="0" BORDER="0" WIDTH="100%" BGCOLOR="#FFFFFF">
	 <TR align="center" >
	  <TD align="center" width="99%"><FONT color="#003366" size="4"><B><bean:message key="ui.label.Transactions"  bundle="emSrcMessages"/></B></FONT>&nbsp;</TD>
	  <TD align="left"><A id="help" TARGET="_blank" HREF="<%=HelpUtil.getHelpUtil().getHelpURL("view_transactions", zs.getUser().getLocale())%>"><IMG SRC="../jsp/images/help.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<bean:message key='ui.label.Help'  bundle='emSrcMessages'/>"></A></TD>
	 </TR>
	 <TR colspan="1" >
	  <TD><img src="/expensemap/jsp/images/transparent.gif" width="1" height="6">
	  </TD></TR>

	 <TR colspan="1">
	 <TD ALIGN="center" CLASS="warning" >
	  <fmt:message key ='ui.label.You.do.not.have.permission.to.view.transaction.details'/>
	  </TD></TR>
	</TABLE>
</logic:equal>
<logic:equal name="viewTransactionForm" property="errorName" value="someSqlException">	
	<TABLE CELLSPACING="0" CELLPADDING="0" BORDER="0" WIDTH="100%" BGCOLOR="#FFFFFF">	 
	 <TR colspan="1" >
	  <TD><img src="/expensemap/jsp/images/transparent.gif" width="1" height="6">
	  </TD></TR>
	 <TR colspan="1">
	 <TD ALIGN="center" CLASS="warning" >
	  <fmt:message key ='ui.label.Some.SQL.Exception'/>
	  </TD></TR>
	  <TR><td ALIGN="center"><table width="98%" align="center">
			<tr align="center">
				<td colspan="4"><html:button property="backButton"
					onclick="closeButton();">
					<bean:message key="button.close" bundle="analytic" />
				</html:button></td>
			</tr>
		</table></td></TR>
	</TABLE>
	<script language="javascript">disableLink(); </script>
</logic:equal>
<logic:equal name="viewTransactionForm" property="errorName" value="">
		<font color="red" face="Verdana" size="3"><b>
		<html:messages id="msg" message="true" bundle="emMessages"> 
		      <bean:write name="msg" bundle="emMessages"/> 
		</html:messages> 
		</b></font><br><br>
		</center>
		<table width="98%" align="center">
			<tr align="center">
				<td colspan="4"><html:button property="backButton"
					onclick="closeButton();">
					<bean:message key="button.close" bundle="analytic" />
				</html:button></td>
			</tr>
		</table>
		<script language="javascript">disableLink(); </script>
		</body>		
</logic:equal>
<html:hidden name="viewTransactionForm" property="pageNo"/>
<html:hidden name="viewTransactionForm" property="theAction"/>
<html:hidden name="viewTransactionForm" property="member"/>
<html:hidden name="viewTransactionForm" property="dimension"/>
<html:hidden name="viewTransactionForm" property="includeConstraints"/>
</FORM>
</html:html>
