<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="/jsp/includes/tlib.jspf"%>
<%@ page import="java.util.*"%>
<%@ page import="com.zeborg.expensemap.view2.*"%>
<%@ page import="com.zeborg.util.*"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle" %>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.zeborg.expensemap.view.*"%>


<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext); 
	Locale locale = zs.getUser().getLocale();
%>
<script type="text/javascript">

function openTransactionPage() {
		var url = "/expensemap/showTransAttributePage.xhtm?source=transaction";
		var ht = 575;
		var wt = 910;
		var left = (screen.width/2)-(wt/2);
		var top = (screen.height/2)-(ht/2);
		window.open(url, 'Transaction', "resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
}

</script>
<fmt:setBundle basename="ExpensemapMessagesBundle" />


<table border="0" cellpadding="0" cellspacing="0" width="100%" style="background-color: #ECF4FE;" >	
	<tr height="0" STYLE="font-size:6px;BORDER-TOP: #7f7f7f 1px solid">		
		<td style="font-size:6px;BORDER-TOP: #7f7f7f 1px solid" nowrap="nowrap">
			<table border="0">
				<tr>	
					<td>
						<div id="currPageTextMsg" >
							<b>
							<font color="blue" SIZE="2"><fmt:message key='ui.label.Transactions' /> : 
							<span id="transactionPageStatus"></span>
							</font>
							</b>
						</div>
				 	</td>
					<td>&nbsp;&nbsp;</td>			
					<td id="prevBtnEnabled" style="display:none" nowrap="nowrap">
						<div id="prevBtnEnabledDiv">					
							<img onclick="return getTransactionReportPage('first');" src="/expensemap/jsp/images/beginning_enabled.gif" 
								border="0" class="tabledata" style="cursor:pointer" title="<bean:message key='tooltip.go.top' bundle='emMessages'/>">
							<img onclick="return getTransactionReportPage('previous');" src="/expensemap/jsp/images/back_enabled.gif"
								border="0" class="tabledata" style="cursor:pointer" title="<bean:message key='ui.image.tooltip.movePrevious' bundle='emMessages' arg0='${ pagination.rowsPerPage }' />">	
						</div>
					</td>
					<td id="prevBtnDisabled" style="display:table-cell" nowrap="nowrap">
						<div>
							<img src="/expensemap/jsp/images/beginning_disabled.gif" border="0" class="tabledata"
								title="<bean:message key='tooltip.you.are.at.top'  bundle='emMessages'/>">
							<img src="/expensemap/jsp/images/back_disabled.gif" border="0" class="tabledata" 
								title="<bean:message key='tooltip.you.are.at.top'  bundle='emMessages'/>">
						</div>
					</td>			
					<td id="nextBtnEnabled" style="display:none" nowrap="nowrap">
						<div id="nextBtnEnabledDiv">
							<img onclick="return getTransactionReportPage('next');" src="/expensemap/jsp/images/forward_enabled.gif"
								border="0" class="tabledata" style="cursor:pointer"
								title="<bean:message key='ui.image.tooltip.moveNext' bundle='emMessages' arg0='${ pagination.rowsPerPage }'/>">
							<img onclick="return getTransactionReportPage('last');" src="/expensemap/jsp/images/end_enabled.gif"
								border="0" width="16" height="16" class="tabledata" style="cursor:pointer"
								title="<bean:message key='tooltip.go.bottom' bundle='emMessages'/>"/>
						</div>
					</td>
					<td id="nextBtnDisabled" style="display:table-cell" nowrap="nowrap">
						<div>	
							<img src="/expensemap/jsp/images/forward_disabled.gif" border="0" class="tabledata"  title="<bean:message key='tooltip.you.are.at.bottom' bundle='emMessages'/>">
							<img src="/expensemap/jsp/images/end_disabled.gif" border="0" class="tabledata"  title="<bean:message key='tooltip.you.are.at.bottom' bundle='emMessages'/>">
						</div>
					</td>			
				</tr>
			</table>		
		</td>
		<td align="left" style="font-size:6px;BORDER-TOP: #7f7f7f 1px solid" nowrap="nowrap" >
			<table width="100%" border="0" cellpadding="0" cellspacing="0">
			<tr>
				<td id="icons"align="right" width="98%">
				<a href="#" onclick="return openTransactionPage();">
							<img src="../jsp/images/report/transaction_preferences.gif" width="16" height="16" border="0"
								title="<bean:message key='ui.label.transaction.preferences'  bundle='emSrcMessages'/>"></a>&nbsp;
					<c:if test="${ hasExportPermission }">
						<a href="#" onclick="return openExportBox('transactions');">
							<img src="../jsp/images/excel.gif" width="16" height="16" border="0"
								title="<bean:message key='ui.label.Export.Report.to.Excel'  bundle='emSrcMessages'/>"></a>&nbsp;
					</c:if>
					<a href="#" onclick="return exportTransactions('PRINT');">
						<img src="../jsp/images/print.gif" width="16" height="16" border="0" title="<bean:message key='ui.label.Print.Report' bundle='emSrcMessages'/>"></a>&nbsp;
				</td>
				<td align="right" width="98%">
					<a id="help" target="_blank" href="<%=HelpUtil.getHelpUtil().getHelpURL("view_transactions", zs.getUser().getLocale())%>">
						<img src="../jsp/cap_area/btn_help_up.gif" width="22" height="22" border="0" title="<bean:message key='ui.label.Help' bundle='emSrcMessages'/>">
					</a>
	   			</td>
	   			<td><img src="/expensemap/jsp/images/transparent.gif" width="3" height="1"></td>
      		</tr>
		</table> 
     </td>
  </tr>		
</table>