<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ taglib uri="http://www.springframework.org/tags" prefix="spring"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ page import="com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="org.owasp.esapi.ESAPI"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>	
	<link rel="stylesheet" type="text/css" href="/expensemap/jsp/css/listPage.css"/>
		<link REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/macromap.css">
	
	<style>
	A {
   color: #0C209B;
    font-family: arial,helvetica,sans-serif;
    font-size: 10px;
    font-weight: normal;
    text-decoration: underline;
}
A:link {
    color: #0C209B;
    font-family: arial,helvetica,sans-serif;
    font-size: 10px;
    font-weight: normal;
    text-decoration: underline;
}
A:visited {
    color: #003399;
    font-family: arial,helvetica,sans-serif;
    font-size: 10px;
    font-weight: normal;
    text-decoration: underline;
}
A:hover {
       color: #FE6300;
    font-family: arial,helvetica,sans-serif;
    font-size: 10px;
    font-weight: normal;
    text-decoration: none;

}
	</style>
		
		<STYLE type="text/css">
<!--
.dataSetlabel {
	font-size: 12pt;
	height: 30px;
	background-color: #D2D8E7;
}

.tabledata {
	color: #0C209B;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 11px;
	font-weight: normal;
	text-decoration: none;
}

.TREENODE {
	background-color: #A5B6DE;
	color: #31659C;
	font-family: Arial;
	font-size: 10px;
	text-decoration: none;
}

body {
	margin: 0;
}
-->
</STYLE>
		<script type="text/javascript">
			
			function addNewStaticReport(){
				var theForm =  document.getElementById("reportForm");
				theForm.action = "editStaticReport.shtm?dataSetId"+theForm.dataSetId.value;				
				theForm.method="GET";
				theForm.submit();
			}

			function removeStaticReport(){
				var confirmMsg = '<spring:message code="ui.delete.alertmsg" />';
				if(isSelected() && confirm(confirmMsg)){
					var theForm =  document.getElementById("reportForm");
					theForm.action = "deleteStaticReport.shtm";
					theForm.method="POST";				
					theForm.submit();
				}
			}

			function isSelected(){
				var frm = document.getElementById("reportForm");
				if(null==frm.reportId){
					return false;
				}
				var noOfRows = frm.reportId.length;				
				if (frm.reportId[0]) { // if the checkbox group is an array (one check box is not an array)
					for (i = 0; i < noOfRows; i++) {
						if (frm.reportId[i].checked == true) {
								return true;
						}
					}
				}else { // There is only one check box (it's not an array)
					if (frm.reportId.checked) { // if the one check box is checked
						 return true;
					  }				  
				}
				alert('<spring:message code="ui.delete.alertmsg.atleaset.select.one.static.report" />');				
				return false;
			 }

			function selectAll(selectAllControl){
				var theForm =  document.getElementById("reportForm");
			   	if ( theForm.reportId == null ) {
				   	  return false;	
			   	} 
   
				if ( theForm.reportId.length ) {
   					// There are more than one rows on this form.
					for( var i=0; i< theForm.reportId.length; i++ ) {
						theForm.reportId[i].checked = selectAllControl.checked;
					}
					return true;
	   			}
			   	// There is just a single row on this form.
			   	theForm.reportId.checked = selectAllControl.checked;
			}// end of function select all.
		
				
			function updateSelectAll(checkboxSelected) {
				var theForm = document.getElementById("reportForm");
				var selectAllControl = document.getElementById("selectAllReportId");
				var allSelected = true;
				
				if ( !theForm.reportId.length ) {
					// Only one row is there 
					allSelected = checkboxSelected.checked;
				} else {
					// for more than one row
					for( var i=0; i< theForm.reportId.length; i++ ) {
						if ( theForm.reportId[i].checked == false ) {
							allSelected = false;
							break;
						}	
					}
				}
				selectAllControl.checked = allSelected;
			}

			function showReportList(){
				var theForm = document.getElementById("reportForm");
				theForm.dataSetId.value = theForm.dataSetOption.value;
				theForm.action="staticReportList.shtm";
				theForm.method="GET";
				theForm.submit();
			}
		</script>

	</head>
	
<% ZSession zs = ZSessionUtil.getFromSession(pageContext); %>	
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zs.getUser().getTimeZone().getID()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	

	<body>
	<form id="reportForm">
		<table width="100%" bgcolor="#EFEFEF" >
		 	<tr>
				<td nowrap="nowrap" class="dataSetlabel">
					<spring:message code="ui.label.Dataset" /> :
					<select id="dataSetOption" onchange="showReportList();">
						
							<c:forEach items="${dataSetList}" var="currentDataSet" >
								<c:choose>
								<c:when test="${currentDataSet.id eq dataSetId}">
									<option value="${currentDataSet.id}" selected>${currentDataSet.displayNameWithVersion}</option>
								</c:when>
								<c:otherwise>
									<option value="${currentDataSet.id}">${currentDataSet.displayNameWithVersion}</option>
								</c:otherwise>
								</c:choose>
							</c:forEach>
						
					</select>
				</td>
			</tr>
		</table>
		<table width="100%" bgcolor="#336699">
		 	<tr>       	
				<td width="52%" align="right">
					<c:if test="${hasCreatePerm}" >
						<input  type="button"  name="createCompany" value="<spring:message code="ui.button.Create" />" onClick="addNewStaticReport();"/>					
						<input  type="button"  name="deleteCompany" value="<spring:message code="ui.label.Delete" />" onClick="removeStaticReport();"/>
					</c:if>
				</td>
			</tr>
		</table>
				
		<table bgcolor="#EFEFEF" >
			<tr>
				<td nowrap="nowrap" align="left" class="TREENODE" ><spring:message code="ui.label.Name" /></td>
				<td nowrap="nowrap" align="left" class="TREENODE" ><spring:message code="ui.usability.report.heading.display.name" /></td>
				<td nowrap="nowrap" align="left" class="TREENODE" ><spring:message code="ui.label.File.Name" /></td>
				<td nowrap="nowrap" align="left" class="TREENODE" ><spring:message code="ui.label.Last.Modified.Date" /></td>
				<td nowrap="nowrap" align="left" class="TREENODE" >
					<input type="checkbox" id="selectAllReportId" onclick="selectAll(this);" />	
				</td>
			</tr>
			<c:forEach items="${reportList}" var="currentReport" varStatus="ctr">
				<c:choose>
					<c:when test="${ctr.index % 2 == 0}" >
						<c:set var="rowClass" value="trEven" scope="page" />
						<c:set var="cellbackground" value="background-color:#dee3ef;" scope="page" />
					</c:when>
					<c:otherwise>
						<c:set var="rowClass" value="trOdd" scope="page" />
						<c:set var="cellbackground" value="background-color:#ffffff;" scope="page" />
					</c:otherwise>
				</c:choose>
				<tr class="${rowClass}" style="${cellbackground}">
					<td class="tabledata" align="left">


						<a href="/expensemap/editStaticReport.shtm?reportId=${currentReport.id}&dataSetId=${dataSetId}">
							<c:out value="${currentReport.name}"/>
						</a>
					</td>
					<td class="tabledata" align="left">   			
						<c:out value="${currentReport.displayName}"></c:out>
		     		</td>
		     		<td class="tabledata" align="left">   			
						<c:out value="${currentReport.fileName}"></c:out>
		     		</td>
		     		<td class="tabledata" align="left">
		     			<fmt:formatDate value="${currentReport.lastModifiedDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}"/>						
		     		</td>
					<td class="tabledata" align="center">   			
						<input type="checkbox" name="reportId" id="reportId" value="${currentReport.id}" onclick="updateSelectAll(this);"/>
		     		</td>
				</tr>
			</c:forEach>
		</table>
		<%String uiDataSet = ESAPI.encoder().encodeForHTML(request.getParameter("dataSetId"));%>
		<c:set var="dataSetIdfromUI" value="<%=uiDataSet%>" />

		<c:if test="${! empty dataSetIdfromUI}" >
			<input type="hidden" name="dataSetId" id="dataSetId" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("dataSetId"))%>">
		</c:if>
		<c:if test="${empty dataSetIdfromUI}" >
			<input type="hidden" name="dataSetId" id="dataSetId" value="${dataSetId}"/>			
		</c:if>
		<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
	</form>
	</body>
</html>