<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="/jsp/includes/tlib.jspf"%>
<%@page import="com.zeborg.expensemap.view2.ZSession"%>
<%@page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@page import="java.util.Locale"%>
<%@page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	Locale locale = zs.getUser().getLocale();

%>
<fmt:setBundle basename="ExpensemapMessagesBundle" />
<html>
<head>
<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title><%= ExpenseMapAppProperties.getBrowserTitleSpend()%> - <fmt:message key='ui.label.Transactions' /></title>
<jsp:include page="/jsp/includes/commonHeaderIncludes.jsp" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/macromap.css" />
<script language="javascript">
function closeButton() {
	window.close();
}
</script>
</head>
<body>

<center>
<c:if test="${ printHeader }">
	<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
</c:if>
<table cellspacing="0" cellpadding="0" border="0" width="100%" bgcolor="#FFFFFF" >
	<c:if test="${ printHeader }">
		<tr align="center">
			<td align="center" width="99%">
				<font color="#003366" size="4">
				<b><bean:message key="ui.label.Transactions"  bundle="emSrcMessages"/></b></font>
			</td>
			<td align="left">
				<a id="help" target="_blank" href="<%=HelpUtil.getHelpUtil().getHelpURL("view_transactions", zs.getUser().getLocale())%>">
					<img src="../jsp/cap_area/btn_help_up.gif" width="22" height="22" border="0"
						title="<bean:message key='ui.label.Help'  bundle='emSrcMessages'/>" />
				</a>
			</td>
		 </tr>
	 </c:if>
	 <tr>
	 	<td colspan="2">
	 		<img src="/expensemap/jsp/images/transparent.gif" width="1" height="6" />
	 	</td>
	 </tr>
	 <c:choose>
	 	<c:when test="${ preferenceTransactionColumnsNotExist }">
	 		 <tr>
			 	<td colspan="2" align="center" class="warning" >
			 		<fmt:message key ='ui.label.There.are.no.transaction.columns.defined.in.your.preferences'/>
			 	</td>
			 </tr>
			<tr>
			 	<td colspan="2" align="center" class="warning" >
					<fmt:message key ='ui.label.Please.go.to.the.transaction.tab.in.preferences.and.add.transaction.columns.to.the.Transaction.Fields.Displayed.list'/>
			 	</td>
			</tr>
	 	</c:when>
	 	<c:when test="${ transactionColumnLevelPermissionNotExist }">
	 		<tr>
			 	<td colspan="2" align="center" class="warning" >
					<fmt:message key ='ui.label.You.do.not.have.permission.to.view.transaction.details'/>
			 	</td>
			</tr>
	 	</c:when>
	 	<c:otherwise>
	 		<tr>
			 	<td colspan="2" align="center" class="warning" >
					<html:messages id="msg" message="true" bundle="emMessages"> 
						<bean:write name="msg" bundle="emMessages"/> 
					</html:messages>
			 	</td>
			</tr>
	 	</c:otherwise>
	 </c:choose>
	 <c:if test="${ printHeader }">
		 <tr align="center">
			<td colspan="2">
				<html:button property="backButton" onclick="closeButton();">
					<bean:message key="button.close" bundle="emMessages" />
				</html:button>
			</td>
		</tr>
	</c:if>
</table>
</center>
</body>
</html>
